#include "otf.h"


void BaselineAll()
{
 int i,ii,k,idmp;
 int IHORN;
 float *R1,*R2,*R,*M,*TA;

 ReadHEADER();

 if ( (R1 = (float *)malloc(sizeof(float)*h.H.nchan*h.H.nhorns))==NULL) {
   fprintf(stderr,"\n Can not allocate memory for REF 1  data array\n");
   exit(3);
 }
 if ( (R2 = (float *)malloc(sizeof(float)*h.H.nchan*h.H.nhorns))==NULL) {
   fprintf(stderr,"\n Can not allocate memory for REF 2  data array\n");
   exit(3);
 }
 if ( (R = (float *)malloc(sizeof(float)*h.H.nchan*h.H.nhorns))==NULL) {
   fprintf(stderr,"\n Can not allocate memory for REF  data array\n");
   exit(3);
 }
 if ( (M = (float *)malloc(sizeof(float)*h.H.nchan*h.H.nhorns))==NULL) {
   fprintf(stderr,"\n Can not allocate memory for MAIN data array\n");
   exit(3);
 }
 if ( (TA = (float *)malloc(sizeof(float)*h.H.nsample*h.H.nchan))==NULL) {
   fprintf(stderr,"\n Can not allocate memory for MAIN data array\n");
   exit(3);
 }


 GetREFERENCE(IF,1,R1);
 GetREFERENCE(IF,2,R2);

/* Now start gathering ON data */
 for(IHORN=0; IHORN<h.H.nhorns; IHORN++) {
  for(idmp=0; idmp<h.H.nsample; idmp++) {   /* MAIN data in idmp 1:ndumps-1 */

     GetDUMP(IF,idmp+1,M);
     if (h.H.coeff[IHORN][IF][idmp][0]==0.0) {  /* still raw data  */
       WeightREF(WTmode,idmp+1,R1,R2,R);
       for(k=0; k<h.H.nchan; k++) {
        i=Getindex(k,idmp,h.H.nchan);
        ii=Getindex(k,IHORN,h.H.nchan);
        TA[i]=M[ii]-R[ii];

/*  ************       for real data: ***********************************
       TA[i]=NAN;
       if (R[k] != 0.0) TA[i]=h.H.tsys[IF][IHORN]*(M[k]-R[k])/(R[k]-h.H.BLANK);
******************************************************************************/

       }  
     } 
     else {                          /* baseline subtracted data */
       for(k=0; k<h.H.nchan; k++) {
        i=Getindex(k,idmp,h.H.nchan);
        ii=Getindex(k,IHORN,h.H.nchan);
        TA[i]=M[ii];
       }  
     }
   }                   /* end of dump loop */

  baseline(TA,IHORN);

/*Write data back to file */
  WriteHEADER();
  WriteIMAGE(IHORN,IF,TA);

 }                   /* end of horn loop */

 fclose(otffp);

/* Free memory */
  free(R1);
  free(R2);
  free(R);
  free(M);
  free(TA);
}
