#ifdef GUI
#include "otftool.h"
extern void update_plabel (int, char*);
extern void update_progressbar(int, float);
#else
#include "otf.h"
#endif

extern int ReadXHeader(char*);
extern void GetCALSCAN(float*);
extern void baseline(float *, int);


int Baseline_AllHorns(ifile)
int ifile;
{
 int i,ih,ii,k,idmp;
 int IHORN;
 float *R1,*R2,*R,*M,*TA,*CALSCAN=NULL;
 float TCAL;

 ReadHEADER();
 ReadXHeader(infile[ifile]);

/* initialize stat counters for this file */
 for(ih=0; ih<MAXHORNS; ih++) {
   rmsstat.s0[ifile][ih]=0.0; 
   rmsstat.s1[ifile][ih]=0.0; 
   rmsstat.s2[ifile][ih]=0.0; 
 }

 if (H.caltype) {
   if ( (CALSCAN = (float *)malloc(sizeof(float)*H.nchan*H.nhorns))==NULL) {
     fprintf(stderr,"\n Can not allocate memory for CALSCAN data array\n");
     exit(3);
   }
   GetCALSCAN(CALSCAN);
 }

 if ( (R1 = (float *)malloc(sizeof(float)*H.nchan*H.nhorns))==NULL) {
#ifdef GUI
   strcpy(logtext_string, "\n Can not allocate memory for REF 1  data array\n");
   append_log (2,1,1,otfgui->logtext,logtext_string);
   return(-1);
#else     
   fprintf(stderr,"\n Can not allocate memory for REF 1  data array\n");
   exit(3);
#endif   
 }
 if ( (R2 = (float *)malloc(sizeof(float)*H.nchan*H.nhorns))==NULL) {
#ifdef GUI
   strcpy(logtext_string, "\n Can not allocate memory for REF 2  data array\n");
   append_log (2,1,1,otfgui->logtext,logtext_string);
   return(-1);
#else        
   fprintf(stderr,"\n Can not allocate memory for REF 2  data array\n");
   exit(3);
#endif   
 }
 if ( (R = (float *)malloc(sizeof(float)*H.nchan*H.nhorns))==NULL) {
#ifdef GUI
   strcpy(logtext_string,"\n Can not allocate memory for REF  data array\n");
   append_log (2,1,1,otfgui->logtext,logtext_string);
   return(-1);
#else        
   fprintf(stderr,"\n Can not allocate memory for REF  data array\n");
   exit(3);
#endif
 }
 if ( (M = (float *)malloc(sizeof(float)*H.nchan*H.nhorns))==NULL) {
#ifdef GUI
   strcpy(logtext_string,"\n Can not allocate memory for MAIN data array\n");
   append_log(2,1,1,otfgui->logtext,logtext_string);
   return(-1);
#else
   fprintf(stderr,"\n Can not allocate memory for MAIN data array\n");
   exit(3);
#endif
 }
 if ( (TA = (float *)malloc(sizeof(float)*H.nsample*H.nchan))==NULL) {
#ifdef GUI
   strcpy(logtext_string,"\n Can not allocate memory for MAIN data array\n");
   append_log(2,1,1,otfgui->logtext,logtext_string);
   return(-1);
#else
   fprintf(stderr,"\n Can not allocate memory for MAIN data array\n");
   exit(3);
#endif
 }


 GetREFERENCE(1,R1);
 GetREFERENCE(2,R2);

#ifdef GUI
   update_plabel(0, "Working on horn");
#endif
/* Now start gathering ON data */
 for(IHORN=0; IHORN<H.nhorns; IHORN++) {
#ifdef GUI
   sprintf(logtext_string," %d", IHORN+1);
   update_plabel(1, logtext_string);
#endif
  for(idmp=0; idmp<H.nsample; idmp++) {   /* MAIN data in idmp 1:ndumps-1 */

     GetDUMP(idmp,M);
     WeightREF(WTmode,idmp,R1,R2,R);
     for(k=0; k<H.nchan; k++) {
       i=Getindex(k,idmp,H.nchan);
       ii=Getindex(k,IHORN,H.nchan);
       TCAL=H.tsys[IHORN];
       if (H.caltype) TCAL=CALSCAN[ii];

       TA[i]=NAN;
       if (fabs(M[ii]) < 1.0e+30 && fabs(R[ii]) < 1.0e+30) {
        if(OTFPOS.XOFF[idmp] < 21600) {
           if (R[ii] != 0.0) TA[i]=TCAL*(M[ii]-R[ii])/(R[ii]);
        }
       }
     }  
  }                   /* end of dump loop */

  baseline(TA,IHORN);

/* Tabulate statistics */
  for(idmp=0; idmp<H.nsample; idmp++) { 
    /*    if (rms[IHORN][idmp] != 0.0) {*/
    if ((rms[IHORN][idmp] != 0.0) && 
	(rms[IHORN][idmp] < rmsthreshold && rms[IHORN][idmp] < 1.0e30)) {
      rmsstat.s2[ifile][IHORN]+=pow(rms[IHORN][idmp],2.0);
      rmsstat.s1[ifile][IHORN]+=rms[IHORN][idmp];
      rmsstat.s0[ifile][IHORN]+=1.0;
    }
  }
#ifdef GUI
  progress_val = (float) (((float) (IHORN+1)/(float) H.nhorns)*100.0);
  update_progressbar(0, progress_val);
  if (baselinemode == BASEALL)
    update_progressbar(1, ((((float) ifile/(float) nfiles)+
			    ((progress_val/100.0)*((float) 1./(float) nfiles)))*100.0));
#endif
 }                   /* end of horn loop */

/* Free memory */
  if (H.caltype) free(CALSCAN);
  free(R1);
  free(R2);
  free(R);
  free(M);
  free(TA);
  return(0);
}
