#include "otf.h"

void CompileStats(int jfile, int NFILES)
{
 int ih,ifile;
 float S0,S1,S2;

/* compile statistics */

/* Average for each horn  */
 for(ih=0; ih<H.nhorns; ih++) {
  S0=0.0; S1=0.0; S2=0.0;
  for(ifile=jfile; ifile<jfile+NFILES; ifile++) {
   S0+=rmsstat.s0[ifile][ih]; 
   S1+=rmsstat.s1[ifile][ih]; 
   S2+=rmsstat.s2[ifile][ih]; 
  }
  rmsstat.horn_ave[ih]=NAN; rmsstat.horn_sd[ih]=NAN;
  if (S0 != 0.0) rmsstat.horn_ave[ih]=S1/S0;
  if (S0 > 1.0) rmsstat.horn_sd[ih]=sqrt( (S2-2.0*S1*rmsstat.horn_ave[ih]+
                          S0*pow(rmsstat.horn_ave[ih],2.0))/(S0-1.0) ); 
 }

/* Average for each file  */
 for(ifile=jfile; ifile<jfile+NFILES; ifile++) {
  S0=0.0; S1=0.0; S2=0.0;
  for(ih=0; ih<H.nhorns; ih++) {
   S0+=rmsstat.s0[ifile][ih]; 
   S1+=rmsstat.s1[ifile][ih]; 
   S2+=rmsstat.s2[ifile][ih]; 
  }
  rmsstat.file_ave[ifile]=NAN; rmsstat.file_sd[ifile]=NAN;
  if (S0 != 0.0) rmsstat.file_ave[ifile]=S1/S0;
  if (S0 > 1.0) rmsstat.file_sd[ifile]=sqrt( (S2-2.0*S1*rmsstat.file_ave[ifile]+
                          S0*pow(rmsstat.file_ave[ifile],2.0))/(S0-1.0) ); 
 }
/* Global Average */
 S0=0.0; S1=0.0; S2=0.0;
 for(ifile=jfile; ifile<jfile+NFILES; ifile++) {
  for(ih=0; ih<MAXHORNS; ih++) {
   S0+=rmsstat.s0[ifile][ih]; 
   S1+=rmsstat.s1[ifile][ih]; 
   S2+=rmsstat.s2[ifile][ih]; 
  }
 }
 rmsstat.AVE=NAN; rmsstat.SD=NAN;
 if (S0 != 0.0) rmsstat.AVE=S1/S0;
 if (S0 > 1.0) rmsstat.SD=sqrt( (S2-2.0*S1*rmsstat.AVE+S0*pow(rmsstat.AVE,2.0))/(S0-1.0) ); 

/* Average/SD matrices */
 for(ifile=jfile; ifile<jfile+NFILES; ifile++) {
  for(ih=0; ih<MAXHORNS; ih++) {
   S0=rmsstat.s0[ifile][ih]; 
   S1=rmsstat.s1[ifile][ih]; 
   S2=rmsstat.s2[ifile][ih]; 
   rmsstat.ave[ifile][ih]=NAN; rmsstat.sd[ifile][ih]=NAN;
   if (S0 != 0.0) rmsstat.ave[ifile][ih]=S1/S0;
   if (S0 > 1.0) rmsstat.sd[ifile][ih]=sqrt( (S2-2.0*S1*rmsstat.ave[ifile][ih]+
                      S0*pow(rmsstat.ave[ifile][ih],2.0))/(S0-1.0) ); 
  }
 }
}
