#include "otf.h"

int ExamineScan(IHORN,TA)
int *IHORN;
float *TA;
{
 char ch,title[96],comment[96];
 unsigned char c;
 int i1,i2,ok,i,k,idmp,ix,iy,jmark1,jmark2;
 int inputorder,iwind,iwindcur,itemp;
 int just,axis;
 int stat;
 float v1,v2,vtmp,tamin,tamax,tr[6];
 float x,y;
 float s0,s1,s2,mean,sd,t1,t2;



 /* Open graphics device. */
 if (id1 > 0) {
  cpgslct(id1);
  cpgask(0);
  cpgeras();
 }
 else if (id1 == 0) {
   id1=cpgopen("/xserve");
   if (id1 < 1) exit(1);
 }
 tr[0]=H.xvel1; tr[1]=H.dveldin; tr[2]=0.0;
 tr[3]=-1.0; tr[4]=0.0; tr[5]=1.0;
 v1=H.xvel1; v2=v1+(H.nchan-1.0)*H.dveldin;
 if (v1 > v2) {
   vtmp=v1;
   v1=v2;
   v2=vtmp;
 }
 just=0; axis=0;

 cpgenv(v1,v2,0,H.nsample+1,just,axis);
 sprintf(comment,"OTF Scan %d  PIXEL %2d  HORN %2d",H.iscan,*IHORN+1,H.hornID[*IHORN]);
 cpglab(H.vlabel,"DUMP", comment);
 GetStretch(TA,&t1,&t2);
 cpggray(TA,H.nchan,H.nsample,1,H.nchan,1,H.nsample,t1,t2,tr);
 ShowMASK(*IHORN);

/* initialize cursor position to the center of the image */
 x=(v2+v1)/2.; y=H.nsample/2.;
        
 do {
   cpgcurs(&x,&y,&ch);
   ix=x; iy=y;
   if (iy < 0 || iy > H.nsample-1) {
     ch='z';
   }
 
   if (ch == '?' || ch=='h') {
     PrintHelp();
   }
   else if (ch == 'z') {  
     fprintf(stderr,"\n Cursor off image\n");
   }
   else if (ch == 'b') {  
     baseline(TA,*IHORN);

/*   Redisplay baseline subtracted data */
     GetStretch(TA,&t1,&t2);
     cpggray(TA,H.nchan,H.nsample,1,H.nchan,1,H.nsample,t1,t2,tr);
     ShowMASK(*IHORN);
   }
   else if (ch == 'l') {  /* These are plotting requests
                                        open window */
     if (id2 > 0) {
       cpgslct(id2);
       cpgask(0);
       cpgeras();
     }
     else if (id2 == 0) {
 /*    Open graphics device. */
       id2=cpgopen("/xserve");
       if (id2 < 1) exit(1);
       cpgslct(id2);
     }
     PlotLine(*IHORN,iy,TA); 
     cpgslct(id1);  
   }
   else if (ch=='m') {
     jmark1=y;
     fprintf(stderr,"\n Mark again with m");
     cpgcurs(&x,&y,&ch);
     if (ch=='m') {
       jmark2=y;
       SetMask(*IHORN,jmark1,jmark2);
       xotf.XH.modified=1;
       ShowMASK(*IHORN);
     }
     else {
       fprintf(stderr,"\n Wrong keystroke -- aborting mark routine");
     }
   }
   else if (ch=='w') {
     for(iwind=0; iwind<MAXWIND; iwind++) {
       xotf.XH.w1[iwind]==-1;
       xotf.XH.w2[iwind]==-1;
     }
     iwind=0;
     xotf.XH.w1[iwind]=(x-H.xvel1)/H.dveldin;
     iwindcur=iwind;
     do {
       fprintf(stderr,"\n Mark again with w or x to quit setting windows");
       cpgcurs(&x,&y,&ch);
       if (ch=='w') {
         if (iwind == iwindcur) {
          xotf.XH.w2[iwind]=(x-H.xvel1)/H.dveldin;
          if (xotf.XH.w2[iwind]<xotf.XH.w1[iwind]) {
            itemp=xotf.XH.w1[iwind];
            xotf.XH.w1[iwind]=xotf.XH.w2[iwind];
            xotf.XH.w2[iwind]=itemp;
          }
          xotf.XH.nwind=iwind;
          iwind++;
          if (iwind == MAXWIND-1) {
           fprintf(stderr,"\n %d Max. Windows allowed\n", MAXWIND);
           break;
          }
         }
         else {
          xotf.XH.w1[iwind]=(x-H.xvel1)/H.dveldin;
          iwindcur=iwind;
         }
         xotf.XH.modified=1;
       }
       else if (ch != 'w' && ch!='x') {
         fprintf(stderr,"\n Invalid keystroke\n");
       }
     } while(ch!='x');
     fprintf(stdout,"\n Window intervals");
     for(iwind=0; iwind<NWIND; iwind++) {
       if (xotf.XH.w2[iwind]==-1) break;
       fprintf(stderr,"\n   %2d %4d %4d ",iwind+1,xotf.XH.w1[iwind],xotf.XH.w2[iwind]);
     }
     ch='z';
   }
   else if (ch=='k') {
     if (id2 > 0) {
       cpgslct(id2);
       cpgask(0);
       cpgeras();
     }
     else if (id2 == 0) {
 /*    Open graphics device. */
       id2=cpgopen("/xserve");
       if (id2 < 1) exit(1);
       cpgslct(id2);
     }
     PlotRMS(*IHORN,TA); 
     cpgslct(id1);  
   }
   else if (ch=='u') {
     jmark1=y;
     fprintf(stderr,"\n Mark again with u");
     cpgcurs(&x,&y,&ch);
     if (ch=='u') {
       jmark2=y;
       UnSetMask(*IHORN,jmark1,jmark2);
       xotf.XH.modified=1;
       GetStretch(TA,&t1,&t2);
       cpggray(TA,H.nchan,H.nsample,1,H.nchan,1,H.nsample,t1,t2,tr);
       ShowMASK(*IHORN);
     }
     else {
       fprintf(stderr,"\n Wrong keystroke -- aborting unmark routine");
     }
   }
   else if (ch=='r') {
     UnSetMask(*IHORN,1,H.nsample);
     xotf.XH.modified=1;
     GetStretch(TA,&t1,&t2);
     cpggray(TA,H.nchan,H.nsample,1,H.nchan,1,H.nsample,t1,t2,tr);
     ShowMASK(*IHORN);
   }
   else if (ch=='R') {
     ResetMASK();
     xotf.XH.modified=1;
     GetStretch(TA,&t1,&t2);
     cpggray(TA,H.nchan,H.nsample,1,H.nchan,1,H.nsample,t1,t2,tr);
     ShowMASK(*IHORN);
   }
   else if (ch=='s') {
     fprintf(stderr,"\n Current Baseline Parameters:");
     fprintf(stderr,"\n         Order:  %2d", xotf.XH.order);
     fprintf(stderr,"\n         # Windows: %2d", xotf.XH.nwind);
     for(iwind=0; iwind<xotf.XH.nwind; iwind++) {
     fprintf(stderr,"\n         %2d %4d %4d ",iwind+1,xotf.XH.w1[iwind],xotf.XH.w2[iwind]);
     }
   }
   else if (ch=='p') {
     if (*IHORN==0) {
      fprintf(stderr,"\n No previous pixel for Horn 1\n");
     }
     else {
       *IHORN=*IHORN-2;
       break;
     }
   }
   else if (ch=='n') {
     break;
   }
   else if (ch=='q') {
     fprintf(stdout,"\n Exiting from otfedit Program\n"); 
     break;
   }
   else {
     fprintf(stderr,"\n Not a keystroke command\n"); 
   }

 } while(ch != 'q');

/* Close the graphics device */
  stat=0;
  if (*IHORN == H.nhorns || ch == 'q') {
   stat=1;
   if (id2 > 0) {
      cpgslct(id2); 
      cpgclos();
   }
   cpgslct(id1);
   cpgclos();
  }
  return(stat); 
}
