#include "otf.h"

void 
GetStretch(float *TA, float* t1, float*t2)
{
float s0,s1,s2,tamin,tamax,mean,sd;
int idmp,i1,i2,i,k;

/* Do some quick statistics  */
/* Firt pass thru data */
 tamin=1.0e+20; tamax=-1.0e+20;
 s0=0.0; s1=0.0; s2=0.0; 
 i1=H.caltype+1;  i2=H.nsample-1;
 for(idmp=i1; idmp<i2; idmp++) {  
  if (OTFPOS.XOFF[idmp] < 21600) {
   for(k=0; k<H.nchan; k++) {
     i=Getindex(k,idmp,H.nchan);
     if (fabs(TA[i]) < 1.0e+30) {
       s0+=1.0;
       s1+=TA[i];
       s2+=pow(TA[i],2.0);
       if (TA[i] < tamin) tamin=TA[i];
       if (TA[i] > tamax) tamax=TA[i];
     }
    }
   }
 }
 if (s0 > 1.0) {
  mean=s1/s0;
  sd=sqrt( (s2-2.0*s1*mean+s0*pow(mean,2.0))/(s0-1.0));
 }
 else {
  *t1=tamin;
  *t2=tamax;
  return;
 }

 tamin=1.0e+20; tamax=-1.0e+20;
 s0=0.0; s1=0.0; s2=0.0; 
 for(idmp=i1; idmp<i2; idmp++) {  
  if (OTFPOS.XOFF[idmp] < 21600) {
   for(k=0; k<H.nchan; k++) {
     i=Getindex(k,idmp,H.nchan);
     if (fabs(TA[i]) < 1.0e+30) {
       if (fabs(TA[i]-mean) < 5.0*sd) {
         if (TA[i] < tamin) tamin=TA[i];
         if (TA[i] > tamax) tamax=TA[i];
       }
     }
    }
   }
 }
 *t1=tamin;
 *t2=tamax;
}
