#include "otftool.h"
#include <pthread.h>

extern int ReadXHeader (char *);
extern void GetCALSCAN (float *);
int GtkExamineScan(int *,float *);
void PrintGtkHelp(char *);
extern void settext_baselines();
extern void WriteXHeader(char *);
extern void GetStretch (float *, float *, float *);
extern void ShowMASK (int);
extern void ShowWINS (int);
extern void ShowWIN(int, int);
extern void baseline(float *, int);
extern void PlotLine(int, int, float *);
extern void PlotRMS(int, float *);
extern void ResetMASK(void);


GtkWidget *winentry[5][2];
GtkWidget *winlabel;
/*
void WriteHEADER();
int ExamineScan(int,float*);
void PlotRMS(int,int,int,float*);
void PlotLine(int,int,float*);
void PlotColumn(int,int,float*);
void SetMask(int,int,int);
void UnSetMask(int,int,int);
void PrintHelp();
*/


void 
save_yes (GtkWidget *widget, GtkWidget *window)
{
  int iwind;

  ORDER = xotf.XH.order;
  NWIND = xotf.XH.nwind;
  /*  wind_type = 1;*/
  for (iwind = 0; iwind<NWIND; iwind++){
    w1[iwind] = xotf.XH.w1[iwind]; w2[iwind] = xotf.XH.w2[iwind];
  }
  settext_baselines();
  gtk_widget_destroy(GTK_WIDGET (window));
}

void 
save_no (GtkWidget *widget, GtkWidget *window)
{
  gtk_widget_destroy(GTK_WIDGET (window));
}

void
save_baseline()
{  
  GtkWidget *dialog_window;
  GtkWidget *button, *label;

  dialog_window = gtk_dialog_new ();
  gtk_signal_connect (GTK_OBJECT (dialog_window), "destroy",
                      GTK_SIGNAL_FUNC(gtk_widget_destroyed),
                      &dialog_window);
  gtk_window_set_title (GTK_WINDOW (dialog_window), "Query");
  gtk_container_set_border_width (GTK_CONTAINER (dialog_window), 0);
  gtk_widget_set_usize (dialog_window, 500, 150);

  label = gtk_label_new ("Save baseline info from otfedit to global values?");
  gtk_label_set_line_wrap (GTK_LABEL (label), TRUE);
  gtk_box_pack_start (GTK_BOX (GTK_DIALOG (dialog_window)->vbox),
                      label, TRUE, TRUE, 0);
  gtk_widget_show (label);

  button = gtk_button_new_with_label ("Yes");
  GTK_WIDGET_SET_FLAGS (button, GTK_CAN_DEFAULT);
  gtk_box_pack_start (GTK_BOX (GTK_DIALOG (dialog_window)->action_area), 
                      button, TRUE, TRUE, 0);
  gtk_widget_grab_default (button);
  gtk_widget_show (button);
  gtk_signal_connect (GTK_OBJECT (button), "clicked",
                        GTK_SIGNAL_FUNC (save_yes),
                        dialog_window);

  button = gtk_button_new_with_label ("No");
  gtk_box_pack_start (GTK_BOX (GTK_DIALOG (dialog_window)->action_area), 
                      button, TRUE, TRUE, 0);
  gtk_widget_show (button);
  gtk_signal_connect (GTK_OBJECT (button), "clicked",
                        GTK_SIGNAL_FUNC (save_no),
                        dialog_window);
  gtk_widget_show(dialog_window);

}


void 
*OTFEdit(void *arg)
{
 int i,ii,k,idmp;
 int IHORN;
 int stat;
 float *R1,*R2,*R,*M,*TA,*CALSCAN=NULL;
 float TCAL;
 char *scanfile;
 /* pid_t pid;*/
 char temp[MAXPATHLEN];

 scanfile = (char *)arg;
 /* strcpy(temp,rawdir);*/
 strcpy(temp,scanfile);
 if ((otffp=fopen(temp,"r"))==NULL) {
   append_log (0,1,1,otfgui->logtext, "Cannot open file %s\n", temp);
   pthread_exit(0);
   }
 ReadHEADER();
   
 /* ReadXHeader(scanfile);*/
 ReadXHeader(temp);
 wind_type = 1;
 xotf.XH.modified=0;      /* flag to gauge whether 
			     extension headers are modified by program 
                               in ExamineScan  */  
 
 /* gopal -- you will need to set this up before calling the function
    
    IF=IF-1;
    IHORN=IHORN-1;
 */
 CmdLineMASK=-1;
 
 if (H.caltype) {
   if ( (CALSCAN = (float *)malloc(sizeof(float)*H.nchan*H.nhorns))==NULL) {
     fprintf(stderr,"\n Can not allocate memory for REF 1  data array\n"); 
     exit(3);
   }
   GetCALSCAN(CALSCAN);
 } 
 if ( (R1 = (float *)malloc(sizeof(float)*H.nchan*H.nhorns))==NULL) {
   append_log(0,1,1,otfgui->logtext,"\n Can not allocate memory for REF 1  data array\n");
   pthread_exit(0);
 }
 if ( (R2 = (float *)malloc(sizeof(float)*H.nchan*H.nhorns))==NULL) {
   append_log(0,1,1,otfgui->logtext,"\n Can not allocate memory for REF 2  data array\n");
   pthread_exit(0);
 }
 if ( (R = (float *)malloc(sizeof(float)*H.nchan*H.nhorns))==NULL) {
   append_log(0,1,1,otfgui->logtext,"\n Can not allocate memory for REF  data array\n");
   pthread_exit(0);
 }
 if ( (M = (float *)malloc(sizeof(float)*H.nchan*H.nhorns))==NULL) {
   append_log(0,1,1,otfgui->logtext,"\n Can not allocate memory for MAIN data array\n");
   pthread_exit(0);
 }
 if ( (TA = (float *)malloc(sizeof(float)*H.nsample*H.nchan))==NULL) {
     append_log(0,1,1,otfgui->logtext,"\n Can not allocate memory for MAIN data array\n");
     pthread_exit(0);
 }
 
 
 GetREFERENCE(1,R1);
 GetREFERENCE(2,R2);
 
 
 
 
 /* Now start gathering ON data */
 id1=0; id2=0;    /* set graphics device IDs  */
   
 /* enter thread */
 gdk_threads_enter();
 /* PrintGtkHelp(scanfile);*/
 PrintGtkHelp(temp);
 /* release GTK thread lock */
 gdk_threads_leave(); 
 IHORN = 0;
 
 
 while(1) {
   if (horn_is_active[IHORN]) {
     TCAL=H.tsys[IHORN];
     for(idmp=0; idmp<H.nsample; idmp++) {   /* MAIN data in idmp 1:ndumps-1 */
    
       GetDUMP(idmp,M);
       
       if (OTFPOS.XOFF[idmp] > 29000) {
	 for(k=0; k<H.nchan; k++) {
	   i=Getindex(k,idmp,H.nchan);
	   ii=Getindex(k,IHORN,H.nchan);
	   TA[i]=M[ii];
	 }
       }
       if (OTFPOS.XOFF[idmp] > 23000 && OTFPOS.XOFF[idmp] < 29000) {
	 for(k=0; k<H.nchan; k++) {
	   i=Getindex(k,idmp,H.nchan);
	   ii=Getindex(k,IHORN,H.nchan);
	   if (idmp == H.nsample-1) {
	     TA[i]=R2[ii];
	   }
	   else {
	     TA[i]=R1[ii];
	   } 
       }
       }
       if (OTFPOS.XOFF[idmp] < 21600) {
	 WeightREF(WTmode,idmp,R1,R2,R);
	 for(k=0; k<H.nchan; k++) {
	   i=Getindex(k,idmp,H.nchan);
	   ii=Getindex(k,IHORN,H.nchan);
	   if (H.caltype) TCAL=CALSCAN[ii];
	   
	   TA[i]=NAN;
	   if (fabs(M[ii]) && fabs(R[ii]) < 1.0e+30) {
	     if (R[ii] != 0.0) TA[i]=TCAL*(M[ii]-R[ii])/(R[ii]);
	   }
	 }
       }
     }
     
     stat=GtkExamineScan(&IHORN,TA);
     if (stat) break;
   }
   IHORN++;
 }
  

 if (xotf.XH.modified) {
   xotf.XH.iscan=H.iscan;  
   /*   WriteXHeader(scanfile);*/
   WriteXHeader(temp);
 }

 /* pid = (pid_t) system("pidof /usr/bin/pgxwin_server");
    printf("pid = %d\n", pid);*/


/* Free memory */
  if (H.caltype) free(CALSCAN);
  free(R1);
  free(R2);
  free(R);
  free(M);
  free(TA);
  gdk_threads_enter();
  append_log(0,1,1,otfgui->otfeditstatus,"\n Exiting from otfedit Program\n"); 
  append_log(0,1,1,otfgui->logtext,"\n Exiting from otfedit Program\n"); 
  if (xotf.XH.modified)  save_baseline();
  if (GTK_IS_WIDGET (otfgui->otfedithelp))  gtk_widget_destroy (otfgui->otfedithelp);
  gdk_threads_leave();
  otfedit_exit = 1;
  id1 = 0; id2 = 0;
  pthread_exit(0);
}


void
otfedit_settext_baselines(void)
{
  char txt[50], tmptxt[30];
  int iwind;

  strcpy (txt,"Channels: ");
  for (iwind=0; iwind<xotf.XH.nwind; iwind++){
    sprintf(tmptxt, "(%d, %d)", xotf.XH.w1[iwind], xotf.XH.w2[iwind]);
    strcat (txt, tmptxt);
    if (iwind != (xotf.XH.nwind-1)) strcat(txt," ; ");
  }
  gtk_entry_set_text (GTK_ENTRY (otfgui->otfeditwindow), txt);
  sprintf(txt,"%1d",xotf.XH.nwind);
  gtk_entry_set_text (GTK_ENTRY ( GTK_COMBO (otfgui->otfeditnwindow)->entry),txt);
  sprintf(txt,"%1d",xotf.XH.order);
  gtk_entry_set_text (GTK_ENTRY ( GTK_COMBO (otfgui->otfeditorder)->entry),txt);
}

void
otfedit_settext_winentry (void)
{
  short i, j, nwin;
  char txt[30];

  sscanf(gtk_entry_get_text (GTK_ENTRY ( GTK_COMBO (otfgui->otfeditnwindow)->entry)),
	 "%hd",&nwin);  
  for (i = 0; i<nwin; i++){
    for (j = 0; j < 2; j++) {
      switch (j) {
      case 0:
	sprintf(txt,"%d",xotf.XH.w1[i]);
	gtk_entry_set_text (GTK_ENTRY (winentry[i][j]), txt);
	break;
      case 1:
	sprintf(txt,"%d",xotf.XH.w2[i]);
	gtk_entry_set_text (GTK_ENTRY (winentry[i][j]), txt);
	break;
      }
    }
  }
}


void
otfedit_window_unit_change (GtkWidget *widget, gpointer data)
{
  char txt[10];
  short i;

  strcpy(txt,gtk_entry_get_text(GTK_ENTRY( widget)));
  if (!strcmp(txt,"Channels")) {
    wind_type = 1;
    for (i = 0; i<NWIND; i++){
      xotf.XH.w1[i] = w1[i]; xotf.XH.w2[i] = w2[i];
    }
  } else {
    wind_type = 2;
    for (i = 0; i<NWIND; i++){
      xotf.XH.w1[i] = (w1[i]*H.dveldin) + H.xvel1;
      xotf.XH.w2[i] = (w2[i]*H.dveldin) + H.xvel1;
    }
  }
  otfedit_settext_winentry();

  if (log_mode == LOG_VERBOSE) {
    append_log(0,1,1,otfgui->otfeditstatus,"Window Unit changed to %s\n",txt);
  }
}

void
otfedit_set_windows (GtkWidget *widget, gpointer data)
{
  int nwin, i;
  char txt[200], tmptxt[20];
  float wi1,wi2;
  
  sscanf(gtk_entry_get_text (GTK_ENTRY ( GTK_COMBO (otfgui->otfeditnwindow)->entry)),
	 "%d",&nwin);
  printf("%d\n",nwin);

  switch(wind_type) {
  case 1:
    strcpy (txt,"Channels: ");
    break;
  case 2:
    strcpy (txt,"Velocity: ");
    break;
  }
  for (i=0; i<nwin; i++){
    if ((sscanf(gtk_entry_get_text (GTK_ENTRY (winentry[i][0])), "%g", &wi1) != 1) ||
	(sscanf(gtk_entry_get_text (GTK_ENTRY (winentry[i][1])), "%g", &wi2) != 1)) {
      gtk_label_set_text (GTK_LABEL (winlabel), "Invalid Entries");
      return;
    } else {
      gtk_label_set_text (GTK_LABEL (winlabel), "");
      /*
      if (wind_type == 1) {
	xotf.XH.w1[i] = (w1-H.xvel1[IF])/H.dveldin[IF];
	xotf.XH.w2[i] = (w2-H.xvel1[IF])/H.dveldin[IF];
      } else {
	xotf.XH.w1[i] = w1;
	xotf.XH.w2[i] = w2;
	}*/
      if (wind_type == 2) {
	xotf.XH.w1[i]=(wi1-H.xvel1)/H.dveldin;
	xotf.XH.w2[i]=(wi2-H.xvel1)/H.dveldin;
      } else {
	xotf.XH.w1[i] = wi1;
	xotf.XH.w2[i] = wi2;
      }
      sprintf(tmptxt, "(%g, %g)", wi1, wi2);
      strcat (txt, tmptxt);
      if (i != (nwin-1)) strcat(txt," ; ");
    }
  }
  gtk_entry_set_text (GTK_ENTRY (otfgui->otfeditwindow), txt);
  xotf.XH.modified = 1;
  gtk_widget_destroy (GTK_WIDGET (data));
  
}

void 
otfedit_edit_windows (GtkWidget *widget, gpointer data)
{

  GtkWidget *dialog_window;
  GtkWidget *button, *label;
  GtkWidget *hbox;
  int nwin, i, j;
  char txt[9];
  GList *glist = NULL;
  GtkWidget *combo;

  dialog_window = gtk_dialog_new ();
  gtk_signal_connect (GTK_OBJECT (dialog_window), "destroy",
                      GTK_SIGNAL_FUNC(gtk_widget_destroyed),
                      &dialog_window);
  gtk_window_set_title (GTK_WINDOW (dialog_window), "Set Windows");
  gtk_container_set_border_width (GTK_CONTAINER (dialog_window), 0);
  label = gtk_label_new ("Windows");

  gtk_box_pack_start (GTK_BOX (GTK_DIALOG (dialog_window)->vbox),
                      label, TRUE, TRUE, 0);
  sscanf(gtk_entry_get_text (GTK_ENTRY ( GTK_COMBO (otfgui->otfeditnwindow)->entry)),
	 "%d",&nwin);

#ifdef DEBUG  
  printf("%d\n",nwin);
#endif
  hbox = gtk_hbox_new (FALSE, 5);
  gtk_box_pack_start (GTK_BOX (GTK_DIALOG (dialog_window)->vbox),
                      hbox, TRUE, TRUE, 0);
  label = gtk_label_new ("Windows Units");
  gtk_box_pack_start (GTK_BOX (hbox), label, FALSE, FALSE, 0);
  combo = gtk_combo_new ();
  glist = g_list_append (glist, "Channels");  glist = g_list_append (glist, "Velocity");
  gtk_combo_set_popdown_strings( GTK_COMBO(combo), glist) ;
  gtk_entry_set_editable (GTK_ENTRY (GTK_COMBO (combo)->entry), FALSE);
  gtk_signal_connect (GTK_OBJECT(GTK_COMBO (combo)->entry), "changed",
                           GTK_SIGNAL_FUNC (otfedit_window_unit_change), NULL);
  gtk_box_pack_start (GTK_BOX (hbox), combo, FALSE, FALSE, 0);
  gtk_widget_show (label);   gtk_widget_show (combo);   gtk_widget_show (hbox); 
  wind_type = 1;

  for (i = 0; i<nwin; i++) {
    hbox = gtk_hbox_new (FALSE, 10);
    gtk_box_pack_start (GTK_BOX (GTK_DIALOG (dialog_window)->vbox),
                      hbox, FALSE, FALSE, 0);
    sprintf(txt,"Window %1d",i+1);
    label = gtk_label_new (txt);
    gtk_box_pack_start (GTK_BOX (hbox), label, FALSE, FALSE, 0);
    gtk_widget_show (label);
    for (j=0; j<2; j++) {
      winentry[i][j] = gtk_entry_new();
      gtk_box_pack_start (GTK_BOX (hbox), winentry[i][j], FALSE, FALSE, 0);
      gtk_widget_set_usize (GTK_WIDGET (winentry[i][j]), 75, -1);
      gtk_widget_show (winentry[i][j]);
    }
    gtk_widget_show (hbox);
  }

  otfedit_settext_winentry();

  winlabel = gtk_label_new ("");
  gtk_box_pack_start (GTK_BOX (GTK_DIALOG (dialog_window)->vbox),
		      winlabel, TRUE, TRUE, 0);
  gtk_widget_show (winlabel);

  hbox = gtk_hbox_new (FALSE, 5);
  gtk_box_pack_start (GTK_BOX (GTK_DIALOG (dialog_window)->action_area),
		      hbox, TRUE, TRUE, 0);
  button = gtk_button_new_with_label ("Set");
  gtk_box_pack_start (GTK_BOX (hbox), button, TRUE, TRUE, 0);
  gtk_signal_connect (GTK_OBJECT (button), "clicked",
      GTK_SIGNAL_FUNC (otfedit_set_windows), dialog_window);
  gtk_widget_show (button);

  
  button = gtk_button_new_with_label ("Cancel");
  gtk_box_pack_start (GTK_BOX (hbox), button, TRUE, TRUE, 0);
  gtk_signal_connect_object (GTK_OBJECT (button), "clicked",
		      GTK_SIGNAL_FUNC (gtk_widget_destroy), GTK_OBJECT (dialog_window));
  gtk_widget_show (button);
  
  gtk_widget_show (hbox);
  gtk_widget_show (label);
  gtk_widget_show(dialog_window);

}


void 
otfedit_set_order (short num)
{
  xotf.XH.order = num;
}

int
otfedit_get_order ()
{
  return xotf.XH.order;
}

void
otfedit_order_change (GtkWidget *widget, gpointer data)
{
  otfedit_set_order((short) atoi(gtk_entry_get_text
				 (GTK_ENTRY(GTK_COMBO(otfgui->otfeditorder)->entry))));
  /*  xotf.XH.modified=1;*/
  if (log_mode == LOG_VERBOSE) {
    append_log(0,1,1,otfgui->otfeditstatus,"Order changed to %d \n",otfedit_get_order());
  }
}

void 
otfedit_set_nwind (short num)
{
  xotf.XH.nwind = num;
}

int
otfedit_get_nwind ()
{
  return xotf.XH.nwind;
}

void
otfedit_nwindow_change (GtkWidget *widget, gpointer data)
{
  otfedit_set_nwind((short) atoi(gtk_entry_get_text
				 (GTK_ENTRY(GTK_COMBO(otfgui->otfeditnwindow)->entry))));
  if (log_mode == LOG_VERBOSE) {
    append_log(0,1,1,otfgui->otfeditstatus,
	       "Baseline number of windows changed to %d\n",otfedit_get_nwind());
  }
}




GtkWidget
*otfedit_setup_baseline ()
{

  GtkWidget *frame;
  GtkWidget *vbox2;
  GtkWidget *box1;
  GList *glist = NULL;
  /*  GList *glist1 = NULL;*/
  GtkTooltips *tooltips;
  GtkWidget *labelbox;
  GtkWidget *button;
  GtkWidget *label;
  /*  GtkWidget *combo;*/


  frame = gtk_frame_new ("Baseline Parameters");

  vbox2 = gtk_vbox_new (FALSE, 5);
  gtk_container_add (GTK_CONTAINER (frame), vbox2);
  
  box1 = gtk_hbox_new (FALSE, 5);
  gtk_box_pack_start (GTK_BOX (vbox2), box1, FALSE, FALSE, 0);

  label = gtk_label_new ("Baseline Order");
  gtk_box_pack_start (GTK_BOX (box1), label, FALSE, TRUE, 0);

  otfgui->otfeditorder = gtk_combo_new ();
  glist = g_list_append (glist, NULL);
  glist = g_list_append (glist, "0");  glist = g_list_append (glist, "1");
  glist = g_list_append (glist, "2");  glist = g_list_append (glist, "3");
  glist = g_list_append (glist, "4");  glist = g_list_append (glist, "5");  


  gtk_combo_set_popdown_strings( GTK_COMBO(otfgui->otfeditorder), glist) ;
  gtk_entry_set_editable (GTK_ENTRY (GTK_COMBO (otfgui->otfeditorder)->entry), FALSE);
  gtk_signal_connect (GTK_OBJECT(GTK_COMBO (otfgui->otfeditorder)->entry), "changed",
                           GTK_SIGNAL_FUNC (otfedit_order_change), NULL);

  gtk_box_pack_start (GTK_BOX (box1), otfgui->otfeditorder, FALSE, FALSE, 0);
  gtk_widget_set_usize (GTK_WIDGET (otfgui->otfeditorder), 50, -1);
  sprintf(logtext_string, "%1d",otfedit_get_order());
  gtk_entry_set_text (GTK_ENTRY (GTK_COMBO (otfgui->otfeditorder)->entry), logtext_string);
  
  gtk_widget_show (otfgui->otfeditorder);
  gtk_widget_show (label);


  tooltips = gtk_tooltips_new ();
  labelbox = gtk_event_box_new ();
  label = gtk_label_new ("# Windows");
  gtk_container_add (GTK_CONTAINER (labelbox), label);
  gtk_tooltips_set_tip (tooltips, labelbox, 
                        "Number of baseline windows", NULL);

  gtk_widget_show (label);  gtk_widget_show (labelbox);

  otfgui->otfeditnwindow = gtk_combo_new();
  glist = NULL; glist = g_list_append (glist, "1");
  glist = g_list_append (glist, "2");glist = g_list_append (glist, "3");
  glist = g_list_append (glist, "4");glist = g_list_append (glist, "5");  
  gtk_combo_set_popdown_strings( GTK_COMBO(otfgui->otfeditnwindow), glist) ;
  gtk_entry_set_editable (GTK_ENTRY (GTK_COMBO (otfgui->otfeditnwindow)->entry), FALSE);
  gtk_signal_connect (GTK_OBJECT(GTK_COMBO (otfgui->otfeditnwindow)->entry), "changed",
                           GTK_SIGNAL_FUNC (otfedit_nwindow_change), NULL);
  sprintf(logtext_string, "%1d",otfedit_get_nwind());

  gtk_box_pack_end (GTK_BOX (box1), otfgui->otfeditnwindow, FALSE, FALSE, 0);
  gtk_box_pack_end (GTK_BOX (box1), labelbox, FALSE, FALSE, 0);  
  gtk_widget_set_usize (GTK_WIDGET (otfgui->otfeditnwindow), 40, -1);

  gtk_widget_show (otfgui->otfeditnwindow);
  gtk_entry_set_text (GTK_ENTRY (GTK_COMBO (otfgui->otfeditnwindow)->entry), logtext_string);
  gtk_widget_show (box1);

  box1 = gtk_hbox_new (FALSE, 5);
  gtk_box_pack_start (GTK_BOX (vbox2), box1, FALSE, FALSE, 0);

  labelbox = gtk_event_box_new ();
  label = gtk_label_new ("Windows:");
  gtk_container_add (GTK_CONTAINER (labelbox), label);
  gtk_label_set_justify (GTK_LABEL (label), GTK_JUSTIFY_RIGHT);
  gtk_tooltips_set_tip (tooltips, labelbox, 
                        "Comma-separated Channel pairs; use Edit to set or use 'w' in the pgplot window", NULL);
  gtk_box_pack_start (GTK_BOX (box1), labelbox, FALSE, FALSE, 0);  

  button = gtk_button_new_with_label ("Edit");
  gtk_box_pack_start (GTK_BOX (box1), button, FALSE, FALSE, 0);  
  gtk_signal_connect (GTK_OBJECT (button), "clicked",
		      GTK_SIGNAL_FUNC (otfedit_edit_windows), NULL);
  gtk_widget_show (button);

  otfgui->otfeditwindow = gtk_entry_new ();
  gtk_box_pack_start (GTK_BOX (box1), otfgui->otfeditwindow, FALSE, FALSE, 0);  

  gtk_widget_show (label); gtk_widget_show (labelbox); gtk_widget_show (box1);
  gtk_widget_show (otfgui->otfeditwindow);
  gtk_widget_set_usize (GTK_WIDGET (otfgui->otfeditwindow), 300, -1);
  gtk_entry_set_editable (GTK_ENTRY (otfgui->otfeditwindow), FALSE);
  gtk_widget_show (box1);

  gtk_widget_show (vbox2);
  gtk_widget_show (frame);
  return (frame);

}

int
otfedit_exit_cb (GtkWidget *widget, GdkEvent *event, gpointer data)
{


  append_log(0,1,1,otfgui->otfeditstatus,"\n Use q in PGPLOT window to exit\n");   
  return TRUE;
  /* trap destroy signal */
}


void
PrintGtkHelp(char *scanfile)
{

  /* GtkWidget *helpwin;*/
 GtkWidget *vbox;
 GtkWidget *scrolled_window;
 GtkWidget *txtw;
 /* GtkWidget *button;*/
 GtkWidget *frame;
 GtkWidget *hbox;
 /* GList *glist=NULL;*/
 char txt[30];

 /*
 if (GTK_IS_WIDGET (otfgui->otfedithelp) && (otfgui->otfedithelp != NULL)) {
   gtk_widget_destroy(otfgui->otfedithelp);
 }
 */
 sprintf(txt,"OtfEdit File %s",scanfile);
 otfgui->otfedithelp = gtk_window_new (GTK_WINDOW_TOPLEVEL);
 gtk_window_set_title (GTK_WINDOW (otfgui->otfedithelp), txt);

 /* gtk_signal_connect (GTK_OBJECT (otfgui->otfedithelp), "destroy",
    GTK_SIGNAL_FUNC (gtk_widget_destroyed), &otfgui->otfedithelp);*/
 gtk_signal_connect (GTK_OBJECT (otfgui->otfedithelp), "delete_event",
		     GTK_SIGNAL_FUNC (otfedit_exit_cb), &otfgui->otfedithelp);
 gtk_container_border_width (GTK_CONTAINER (otfgui->otfedithelp), 5);
 vbox = gtk_vbox_new(FALSE, 5);
 gtk_container_add (GTK_CONTAINER (otfgui->otfedithelp), vbox);
 
 otfgui->otfedithelpwin = gtk_scrolled_window_new (NULL, NULL);
 gtk_box_pack_start (GTK_BOX (vbox), otfgui->otfedithelpwin, TRUE, TRUE, 0);
 gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (otfgui->otfedithelpwin),
				 GTK_POLICY_NEVER,
				 GTK_POLICY_ALWAYS);
 gtk_widget_set_usize (otfgui->otfedithelpwin, 375, 400);
 gtk_widget_show (otfgui->otfedithelpwin);
   
 txtw = gtk_text_new (NULL, NULL);
 gtk_text_set_editable (GTK_TEXT (txtw), FALSE);
 gtk_container_add (GTK_CONTAINER (otfgui->otfedithelpwin), txtw);
 gtk_widget_grab_focus (txtw);
 gtk_widget_show (txtw);
 gtk_text_set_word_wrap(GTK_TEXT (txtw), TRUE);
 
 append_log(2,1,2,txtw,"\n      OTF EDIT Cursor Commands\n ");
 append_log(0,1,1,txtw, "\n In the PGPLOT window, the following cursor commands are available:\n");
 append_log(0,1,1,txtw,"\n b -- Subtract baseline from the current horn's data");
 append_log(0,1,1,txtw,"\n k -- Plot run of RMS values");
 append_log(0,1,1,txtw,"\n l -- Plot a spectrum");
 append_log(0,1,1,txtw,"\n m -- Mask a line/section");
 append_log(0,1,1,txtw,"\n n -- Next Horn");
 /*   append_log(0,1,1,txtw,"\n o -- Set order of baseline polynomial");*/
 append_log(0,1,1,txtw,"\n r -- Reset Mask for Current Horn");
 append_log(0,1,1,txtw,"\n s -- Show Current Parameters");
 append_log(0,1,1,txtw,"\n u -- Unmask a line/section");
 append_log(0,1,1,txtw,"\n w -- Set Window for baseline subtraction");
 append_log(0,1,1,txtw,"\n R -- Reset Mask for ALL Horns");
 append_log(0,1,1,txtw,"\n q -- to exit from OtfEdit ");
 /* append_log(0,1,1,txtw,"\n ? -- to print this help menu");*/
 
 hbox = gtk_hbox_new (FALSE, 5);
 gtk_box_pack_start (GTK_BOX (vbox), hbox, TRUE, TRUE, 0);
 
 
 /*
   label = gtk_label_new ("Baseline Order");
   gtk_box_pack_start (GTK_BOX (hbox), label, TRUE, TRUE, 0);
   otfgui->otfeditorder = gtk_combo_new ();
   glist = g_list_append (glist, "0");
   glist = g_list_append (glist, "1");   glist = g_list_append (glist, "2");
   glist = g_list_append (glist, "3");   glist = g_list_append (glist, "4");
   glist = g_list_append (glist, "5");
   gtk_combo_set_popdown_strings( GTK_COMBO(otfgui->otfeditorder), glist) ;
   gtk_entry_set_editable (GTK_ENTRY (GTK_COMBO (otfgui->otfeditorder)->entry), FALSE);
   gtk_box_pack_start (GTK_BOX (hbox), otfgui->otfeditorder, FALSE, FALSE, 0);

   gtk_widget_show (otfgui->otfeditorder); gtk_widget_show (label); gtk_widget_show (hbox);
   */

 frame = gtk_frame_new ("OtfEdit Status");

 gtk_box_pack_start (GTK_BOX (vbox), frame, TRUE, TRUE, 0); 
 scrolled_window = gtk_scrolled_window_new (NULL, NULL);
 gtk_container_add (GTK_CONTAINER (frame), scrolled_window);
 
 gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolled_window),
				 GTK_POLICY_NEVER,
				 GTK_POLICY_ALWAYS);
 gtk_widget_set_usize (scrolled_window, 375, 100);
 gtk_widget_show (scrolled_window);
 gtk_widget_show (frame);
 
 otfgui->otfeditstatus = gtk_text_new (NULL, NULL);
 gtk_text_set_editable (GTK_TEXT (otfgui->otfeditstatus), FALSE);
 gtk_container_add (GTK_CONTAINER (scrolled_window), otfgui->otfeditstatus);
 gtk_widget_grab_focus (otfgui->otfeditstatus);
 gtk_widget_show (otfgui->otfeditstatus);
 gtk_text_set_word_wrap(GTK_TEXT (otfgui->otfeditstatus), TRUE);
 
 append_log(2,1,2,otfgui->otfeditstatus, "Starting OTF Edit for OTF Scan %d\n", H.iscan);
 
 /*
 sprintf(txt,"Quit OtfEdit File %s",scanfile);
 button = gtk_button_new_with_label (txt);
 gtk_box_pack_start (GTK_BOX (vbox), button, FALSE, FALSE, 0);*/
 /* gtk_signal_connect_object (GTK_OBJECT (button), "clicked",
			    GTK_SIGNAL_FUNC (gtk_widget_destroy), 
			    GTK_OBJECT (otfgui->otfedithelp));*/
 /* gtk_signal_connect (GTK_OBJECT (button), "clicked",
			    GTK_SIGNAL_FUNC (otfedit_exit_cb), 
			    GTK_OBJECT (otfgui->otfedithelp));
			    gtk_widget_show (button);*/

 frame = otfedit_setup_baseline();
 gtk_box_pack_start (GTK_BOX (hbox), frame, TRUE, TRUE, 0);
 gtk_widget_show (frame); gtk_widget_show (hbox);
 otfedit_settext_baselines();

 gtk_widget_show (vbox);
 gtk_widget_show (otfgui->otfedithelp);
 
}


void PrintHelp()
{
  fprintf(stdout,"\n ");
  fprintf(stdout,"\n ");
  fprintf(stdout,"\n      OTF EDIT Cursor Commands\n ");
  fprintf(stdout,"\n ");
  fprintf(stdout,"\n b -- Subtract baseline from the current horn's data");
  fprintf(stdout,"\n k -- Plot run of RMS values");
  fprintf(stdout,"\n l -- Plot a spectrum");
  fprintf(stdout,"\n m -- Mask a line/section");
  fprintf(stdout,"\n n -- Next Horn");
  fprintf(stdout,"\n o -- Set order of baseline polynomial");
  fprintf(stdout,"\n r -- Reset Mask for Current Horn");
  fprintf(stdout,"\n s -- Show Current Parameters");
  fprintf(stdout,"\n u -- Unmask a line/section");
  fprintf(stdout,"\n w -- Set Window for baseline subtraction");
  fprintf(stdout,"\n R -- Reset Mask for ALL Horns");
  fprintf(stdout,"\n q -- to exit");
  fprintf(stdout,"\n ? -- to print this help menu");
  fprintf(stdout,"\n ");
  fprintf(stdout,"\n ");
}

void SetMask(IHORN,m1,m2)
int IHORN, m1,m2;
{
 int idmp,itmp;
 long f,temp;

#ifdef GUI
 gdk_threads_enter();
 append_log(0,1,1,otfgui->otfeditstatus,"\n Setting Mask");
 gdk_threads_leave();
#else
 fprintf(stderr,"\n Setting Mask");
#endif
 f=pow(2.,IHORN);
 if (m1 > m2) {
   itmp=m2;
   m2=m1;
   m1=itmp;
 }
 
 for(idmp=m1; idmp<=m2; idmp++) {
   temp=xotf.XH.MASK[idmp];
   xotf.XH.MASK[idmp]=temp&(~f);
 }
}
 
void UnSetMask(IHORN,m1,m2)
int IHORN,m1,m2;
{
 int idmp,itmp;
 long f,temp;

#ifdef GUI
 gdk_threads_enter();
 append_log(0,1,1,otfgui->otfeditstatus,"\n Un-Setting Mask");
 gdk_threads_leave();
#else
 fprintf(stderr,"\n Un-Setting Mask");
#endif
 f=pow(2.,IHORN);
 if (m1 > m2) {
   m2=itmp;
   m2=m1;
   m1=itmp;
 }
 for(idmp=m1; idmp<=m2; idmp++) {
   temp=xotf.XH.MASK[idmp];
   xotf.XH.MASK[idmp]=f|temp;
 }
}

int GtkExamineScan(IHORN,TA)
int *IHORN;
float *TA;
{
 char ch,comment[96];
 /* unsigned char c;*/
 int ix,iy,jmark1,jmark2;
 int iwind,iwindcur,itemp;
 int just,axis;
 int stat;
 float vtmp,v1,v2,t1,t2,tr[6];
 float x,y;
 /* char txt[200], tmptxt[20];*/

 /* Open graphics device. */
 if (id1 > 0) {
  cpgslct(id1);
  cpgask(0);
  cpgeras();
 }
 else if (id1 == 0) {
   id1=cpgopen("/xserv");
   if (id1 < 1) exit(1);
 }

 tr[0]=H.xvel1; tr[1]=H.dveldin; tr[2]=0.0;
 tr[3]=-1.0; tr[4]=0.0; tr[5]=1.0;
 v1=H.xvel1; v2=v1+(H.nchan-1.0)*H.dveldin;
 if (v1 > v2) {
   vtmp=v1;
   v1=v2;
   v2=vtmp;
 }
 just=0; axis=0;
 cpgenv(v1,v2,0,H.nsample+1,just,axis);
 sprintf(comment,"OTF Scan %d  PIXEL %2d  HORN %2d",
          H.iscan,*IHORN+1,H.hornID[*IHORN]);
 cpglab(H.vlabel,"DUMP", comment);
 GetStretch(TA,&t1,&t2);
 cpggray(TA,H.nchan,H.nsample,1,H.nchan,1,H.nsample,t1,t2,tr);
 ShowMASK(*IHORN);
 ShowWINS(3);

/* initialize cursor position to the center of the image */
 x=(v2+v1)/2.; y=H.nsample/2.;
        
 do {
   cpgcurs(&x,&y,&ch);
   ix=x; iy=y;
   if (ch == 'q' || ch == 'Q') break;
   if (iy < 0 || iy > H.nsample-1) {
     ch='z';
   }
 
   if (ch == '?' || ch=='h') {
     gdk_threads_enter();
     gtk_widget_grab_focus (GTK_WIDGET (otfgui->otfedithelpwin));
     /*     PrintGtkHelp();*/
     gdk_threads_leave();
   }
   else if (ch == 'z') {
     gdk_threads_enter();
     append_log(0,1,1,otfgui->otfeditstatus,"\n Cursor off image\n");
     gdk_threads_leave();
   }
   else if (ch == 'b') {  
     baseline(TA,*IHORN);

/*   Redisplay baseline subtracted data */
     GetStretch(TA,&t1,&t2);
     cpggray(TA,H.nchan,H.nsample,1,H.nchan,1,H.nsample,t1,t2,tr);
     ShowMASK(*IHORN);
     ShowWINS(3);
   }
   else if (ch == 'l') {  /* These are plotting requests
                                        open window */
     if (id2 > 0) {
       cpgslct(id2);
       cpgask(0);
       cpgeras();
     }
     else if (id2 == 0) {
 /*    Open graphics device. */
       id2=cpgopen("/xserve");
       if (id2 < 1) exit(1);
       cpgslct(id2);
     }
     PlotLine(*IHORN,iy,TA); 
     cpgslct(id1);  
   }
   else if (ch=='m') {
     jmark1=y;
     gdk_threads_enter();
     append_log(0,1,1,otfgui->otfeditstatus,"\n Mark again with m");
     gdk_threads_leave();
     cpgcurs(&x,&y,&ch);
     if (ch=='m') {
       jmark2=y;
       SetMask(*IHORN,jmark1,jmark2);
       xotf.XH.modified=1;
       ShowMASK(*IHORN);
       ShowWINS(3);
     }
     else {
       gdk_threads_enter();
       append_log(0,1,1,otfgui->otfeditstatus,"\n Wrong keystroke -- aborting mark routine");
       gdk_threads_leave();
     }
   }
   else if (ch=='w') {
     cpggray(TA,H.nchan,H.nsample,1,H.nchan,1,H.nsample,t1,t2,tr);
     ShowMASK(*IHORN);
     for(iwind=0; iwind<MAXWIND; iwind++) {
       xotf.XH.w1[iwind]=-1;
       xotf.XH.w2[iwind]=-1;
     }
     iwind=0;
     xotf.XH.w1[iwind]=(x-H.xvel1)/H.dveldin;
     iwindcur=iwind;
     do {
       gdk_threads_enter();
       append_log(0,1,1,otfgui->otfeditstatus,
		  "\n Mark again with w or x to quit setting windows");
       gdk_threads_leave();
       cpgcurs(&x,&y,&ch);
       if (ch=='w') {
         if (iwind == iwindcur) {
          xotf.XH.w2[iwind]=(x-H.xvel1)/H.dveldin;
          if (xotf.XH.w2[iwind]<xotf.XH.w1[iwind]) {
            itemp=xotf.XH.w1[iwind];
            xotf.XH.w1[iwind]=xotf.XH.w2[iwind];
            xotf.XH.w2[iwind]=itemp;
          }
	  ShowWIN(3,iwind);
          iwind++;
          xotf.XH.nwind=iwind;
          if (iwind == MAXWIND) {
	    gdk_threads_enter();
	    append_log(0,1,1,otfgui->otfeditstatus,
		       "\n %d Max. Windows allowed\n", MAXWIND);
	    gdk_threads_leave();
           break;
          }
         }
         else {
          xotf.XH.w1[iwind]=(x-H.xvel1)/H.dveldin;
          iwindcur=iwind;
         }
         xotf.XH.modified=1;
       }
       else if (ch != 'w' && ch!='x') {
	 gdk_threads_enter();
	 append_log(0,1,1,otfgui->otfeditstatus,"\n Invalid keystroke\n");
	 gdk_threads_leave();
       }
     } while(ch!='x');
     gdk_threads_enter();
     append_log(0,1,1,otfgui->otfeditstatus,"\n Chosen Window intervals");
     for(iwind=0; iwind<xotf.XH.nwind; iwind++) {
       if (xotf.XH.w2[iwind]==-1) break;
       append_log(0,1,1,otfgui->otfeditstatus,
		  "\n   %2d %4d %4d ",iwind+1,xotf.XH.w1[iwind],xotf.XH.w2[iwind]);
     }
     otfedit_settext_baselines();
     gdk_threads_leave();
     ch='z';
   }
   else if (ch=='k') {
     if (id2 > 0) {
       cpgslct(id2);
       cpgask(0);
       cpgeras();
     }
     else if (id2 == 0) {
 /*    Open graphics device. */
       id2=cpgopen("/xserve");
       if (id2 < 1) exit(1);
       cpgslct(id2);
     }
     PlotRMS(*IHORN,TA); 
     cpgslct(id1);  
   }
   else if (ch=='u') {
     jmark1=y;
     gdk_threads_enter();
     append_log(0,1,1,otfgui->otfeditstatus,"\n Mark again with u");
     gdk_threads_leave();
     cpgcurs(&x,&y,&ch);
     if (ch=='u') {
       jmark2=y;
       UnSetMask(*IHORN,jmark1,jmark2);
       xotf.XH.modified=1;
       cpggray(TA,H.nchan,H.nsample,1,H.nchan,1,H.nsample,t1,t2,tr);
       ShowMASK(*IHORN);
       ShowWINS(3);
     }
     else {
       gdk_threads_enter();
       append_log(0,1,1,otfgui->otfeditstatus,"\n Wrong keystroke -- aborting unmark routine");
       gdk_threads_leave();
     }
   }
   else if (ch=='r') {
     UnSetMask(*IHORN,1,H.nsample);
     xotf.XH.modified=1;
     cpggray(TA,H.nchan,H.nsample,1,H.nchan,1,H.nsample,t1,t2,tr);
     ShowMASK(*IHORN);
     ShowWINS(3);
   }
   else if (ch=='R') {
     ResetMASK();
     xotf.XH.modified=1;
     cpggray(TA,H.nchan,H.nsample,1,H.nchan,1,H.nsample,t1,t2,tr);
     ShowMASK(*IHORN);
     ShowWINS(3);
   }
   else if (ch=='s') {
     gdk_threads_enter();
     append_log(0,1,1,otfgui->otfeditstatus,"\n Current Baseline Parameters:");
     append_log(0,1,1,otfgui->otfeditstatus,"\n         Order:  %2d", xotf.XH.order);
     append_log(0,1,1,otfgui->otfeditstatus,"\n         # Windows: %2d", xotf.XH.nwind);
     for(iwind=0; iwind<xotf.XH.nwind; iwind++) {
     append_log(0,1,1,otfgui->otfeditstatus,
		"\n         %2d %4d %4d ",iwind+1,xotf.XH.w1[iwind],xotf.XH.w2[iwind]);
     }
     gdk_threads_leave();
   }
   else if (ch=='p') {
     if (*IHORN==0) {
       gdk_threads_enter();
      append_log(0,1,1,otfgui->otfeditstatus,"No previous pixel for Horn 1;  ");
      append_log(0,1,1,otfgui->otfeditstatus,"Use q to exit\n");
      gdk_threads_leave();
     }
     else {
       *IHORN=*IHORN-2;
       break;
     }
   }
   else if (ch=='n') {
     if (*IHORN == (last_active_horn)) {
       gdk_threads_enter();
       append_log(0,1,1,otfgui->otfeditstatus,"No next pixel for Horn %d;", last_active_horn+1);
       append_log(0,1,1,otfgui->otfeditstatus,"  Use q to exit\n");
       gdk_threads_leave();
     } else {     
       break;
     }
   }
   else if (ch=='q') {
     gdk_threads_enter();
     append_log(0,1,1,otfgui->otfeditstatus,"\n Exiting from otfedit Program\n"); 
     append_log(0,1,1,otfgui->logtext,"\n Exiting from otfedit Program\n"); 
     gdk_threads_leave();
     break;
   }
   else {
     gdk_threads_enter();
     append_log(0,1,1,otfgui->otfeditstatus,"\n Not a keystroke command\n"); 
     gdk_threads_leave();
   }

 } while (ch != 'q');

/* Close the graphics device */
  stat=0;
  /*  if (*IHORN == H.nhorns || ch == 'q') {*/
  if (ch == 'q') {
    stat=1;
    if (id2 > 0) {
      cpgslct(id2); 
      cpgclos();
    }
    cpgslct(id1);
    cpgclos();
  }
  /*  id1 = 0; id2 = 0;*/
  return(stat); 
}

