#include <cpgplot.h>
#include "otf.h"

void PlotLine(IHORN,iy,TA)
int IHORN,iy;
float *TA;
{
 char title[96];
 int i,k,npts;
 int just,axis;
 float vtmp,v1,v2,tmin,tmax,dx,dy;
 float *X,*Y;
  
 just=0; axis=0;
 if ( (X = (float *)malloc(sizeof(float)*H.nchan))==NULL) {
   fprintf(stderr,"\n Can not allocate memory for X array\n");
   exit(3);
 }
 if ( (Y = (float *)malloc(sizeof(float)*H.nchan))==NULL) {
   fprintf(stderr,"\n Can not allocate memory for X array\n");
   exit(3);
 }
 tmax=-1.0e+20; tmin=1.0e+20;
 npts=0;
 for(k=0; k<H.nchan; k++) {
   i=Getindex(k,iy,H.nchan);
   if (fabs(TA[i]) < 1.0e+30) {
     X[npts]=H.xvel1+k*H.dveldin;
     Y[npts]=TA[i];
     if (TA[i] > tmax) tmax=TA[i];
     if (TA[i] < tmin) tmin=TA[i];
     npts++;
   }
 }
 npts--;
 if (OTFPOS.XOFF[iy]<21600) {
   dx=XPOS[IHORN][iy];    dy=YPOS[IHORN][iy];
   sprintf(title,"%s (%7.2f,%7.2f)    Scan %6d Line %3d ", 
         H.name,dx,dy,H.iscan,iy);
 }
 else if (OTFPOS.XOFF[iy]==30000) {
   sprintf(title,"%s (CAL Scan)    Scan %6d Line %3d ", 
         H.name,H.iscan,iy);
 }
 else  {
   sprintf(title,"%s (REF)    Scan %6d Line %3d ", 
         H.name,H.iscan,iy);
 }
 v1=X[0]; v2=X[npts];
 if (v1 > v2) {
   vtmp=v1;
   v1=v2;
   v2=vtmp;
 }
 cpgenv(v1,v2,tmin,tmax,just,axis);
 cpglab(H.vlabel,"T", title);
 cpgbin(npts,X,Y,1);

 free(X);
 free(Y);
}


