#include "otf.h"

extern int CheckMASK (int, int);

void PlotRMS(IHORN,TA)
int IHORN;
float *TA;
{
 char title[96];
 short int *C;
 int i,i1,i2,nmain,iwind,iy,k;
 int sym=4,just,axis;
 float d,tmin,tmax;
 /* float s0,s1,s2,m;*/
 float *X,*Y;
  
 just=0; axis=0;
 if ( (X = (float *)malloc(sizeof(float)*H.nsample))==NULL) {
   fprintf(stderr,"\n Can not allocate memory for X array\n");
   exit(3);
 }
 if ( (Y = (float *)malloc(sizeof(float)*H.nsample))==NULL) {
   fprintf(stderr,"\n Can not allocate memory for Y array\n");
   exit(3);
 }
 if ( (C = (short int *)malloc(sizeof(short int )*H.nchan))==NULL) {
   fprintf(stderr,"\n Can not allocate memory for C array\n");
   exit(3);
 }
/* Set up channel mask according to window intervals */
 for(k=0; k<H.nchan; k++) C[k]=1;
 for(iwind=0; iwind<xotf.XH.nwind; iwind++) {
   i1=xotf.XH.w1[iwind]; i2=xotf.XH.w2[iwind];
   for(k=i1; k<=i2; k++) C[k]=0;
 }

 tmax=-1.0e+20; tmin=1.0e+20;
 i1=H.caltype+1;  i2=H.nsample-2; nmain=i2-i1+1;
 for(iy=i1; iy<i2; iy++) {
   X[iy-i1]=(float)iy-i1;
   Y[iy-i1]=NAN;
   if (CheckMASK(iy,IHORN)) {
     i=Getindex(0,iy-i1,H.nchan);
     Y[iy-i1]=GetRMS(&TA[i],C);
     if (Y[iy-i1]>tmax) tmax=Y[iy-i1];
     if (Y[iy-i1]<tmin) tmin=Y[iy-i1];
   }
 }
 d=0.1*(tmax-tmin);
 sprintf(title," %s RMS    Scan %6d ", H.name,H.iscan);
 cpgenv(1.0, nmain,tmin-d,tmax+d,just,axis);
 cpglab("DUMP","RMS", title);
 cpgpt(nmain,X,Y,sym);

 free(X);
 free(Y);
 free(C);
}

