#ifdef GUI
#include "otftool.h"
extern void update_plabel (int, char*);
extern void update_progressbar(int, float);
extern void error_mes (gchar *, gchar *);
#include <pthread.h>
pthread_t thread;
#else
#include "otf.h"
#endif

struct STATPLOT {
  int fileno;
  int NFILES;
  int mode;
  char postscript_file[80];
} statplot;

void *make_stat_plot (void *);

void PrintSTATS(int jfile, int NFILES)
{
 int i,N,ifs,ih;

  N=strlen(infile[jfile]);
  fprintf(stdout,"\n ");
  for(i=0; i<N+3+3*H.nhorns-10; i++) fprintf(stdout," ");
  fprintf(stdout," P I X E L S \n");
  fprintf(stdout,"\n");
  for(i=0; i<N+3; i++) fprintf(stdout," ");
  for(ih=0; ih<16; ih++) fprintf(stdout," %4d ",ih+1);
  fprintf(stdout,"    File Average ");
  fprintf(stdout,"\n ");
  for(i=0; i<N+3+6*H.nhorns+15; i++) fprintf(stdout,"-");
  fprintf(stdout,"\n ");
  for(ifs=jfile; ifs<NFILES; ifs++) {
    N=strlen(infile[ifs]);
    fprintf(stdout,"\n %s  ", infile[ifs]);
    for(ih=0; ih<16; ih++) fprintf(stdout," %5.2f",rmsstat.ave[ifs][ih]);
    fprintf(stdout,"      %4.2f",rmsstat.file_ave[ifs]);
    fprintf(stdout,"\n ");
    for(i=0; i<N+2; i++) fprintf(stdout," ");
    for(ih=0; ih<16; ih++) fprintf(stdout," %5.2f",rmsstat.sd[ifs][ih]);
    fprintf(stdout,"      %4.2f\n",rmsstat.file_sd[ifs]);
  }
  fprintf(stdout,"\n ");
  for(i=0; i<N+3+6*H.nhorns+15; i++) fprintf(stdout,"-");
  fprintf(stdout,"\n ");
  fprintf(stdout," Pixel Average ");
  for(i=0; i<N+2-15; i++) fprintf(stdout," ");
  for(ih=0; ih<16; ih++) fprintf(stdout," %5.2f",rmsstat.horn_ave[ih]);
  fprintf(stdout,"\n ");
  for(i=0; i<N+2; i++) fprintf(stdout," ");
  for(ih=0; ih<16; ih++) fprintf(stdout," %5.2f",rmsstat.horn_sd[ih]);
  fprintf(stdout,"\n ");
  for(i=0; i<N+3+6*H.nhorns+15; i++) fprintf(stdout,"-");
  fprintf(stdout,"\n ");
  fprintf(stdout,"\n ");
    for(i=0; i<N+3+3*H.nhorns-10; i++) fprintf(stdout," ");
  fprintf(stdout,"Global Average: %4.2f +/- %4.2f K\n\n", rmsstat.AVE,rmsstat.SD);
}

void
psfile_ok_save_log (GtkWidget *w, GtkFileSelection *fs)
{
  
  strcpy(statplot.postscript_file,gtk_file_selection_get_filename (GTK_FILE_SELECTION (fs)));
  strcat(statplot.postscript_file,"/ps");
  printf("%s\n",statplot.postscript_file);
  pthread_create (&thread, NULL, make_stat_plot, NULL);
  /*  make_stat_plot();*/
  gtk_widget_destroy(GTK_WIDGET (fs));
}


void
psfile_win () 
{
  static GtkWidget *filew = NULL;
  
  if (!filew) {
    filew = gtk_file_selection_new ("Save Plot to Postscript File"); 
    
    /*    gtk_file_selection_hide_fileop_buttons (GTK_FILE_SELECTION (filew));*/
    gtk_signal_connect (GTK_OBJECT (filew), "destroy",
                        GTK_SIGNAL_FUNC (gtk_widget_destroyed), &filew);

    /* Connect the ok_button to file_ok_sel function */
    gtk_signal_connect (GTK_OBJECT (GTK_FILE_SELECTION (filew)->ok_button),
                        "clicked", (GtkSignalFunc) psfile_ok_save_log, filew );
    /* Connect the cancel_button to destroy the widget */
    gtk_signal_connect_object (GTK_OBJECT (GTK_FILE_SELECTION
                                           (filew)->cancel_button),
                               "clicked", (GtkSignalFunc) gtk_widget_destroy,
                               GTK_OBJECT (filew));
    
    gtk_file_selection_set_filename (GTK_FILE_SELECTION(filew),
                                   "otftool.ps");

  }
  if (!GTK_WIDGET_VISIBLE (filew))
    gtk_widget_show(filew);
  else 
    gtk_widget_destroy(filew);

}

void
*make_stat_plot (void *args)
{
  float x[MAXHORNS], y[MAXHORNS];
  int i,j;
  float y1[MAXHORNS], y2[MAXHORNS];
  int ci,ls;


  if (id1 != 0 ) {
     gdk_threads_enter();
     append_log(0,1,1,otfgui->logtext,"Pgplot window in use. Quit otfedit first\n");
     error_mes("Error!","Pgplot window in use. Quit otfedit first");
     gdk_threads_leave();    
     pthread_exit(0);
     return;
  }
  /*
  if (id1 > 0) {
    cpgslct(id1);
    cpgask(0);
    cpgeras();
  }
  */
  /*  else if (id1 == 0) {*/
  if (statplot.mode == 0) 
    id1=cpgopen("/xserv");
  else 
    id1 = cpgopen(statplot.postscript_file);
  if (id1 < 1) exit(1);

  printf("id1 = %d\n",id1);

  for (i = 0; i<H.nhorns; i++) x[i] = (float) (i+1);
  cpgenv(0,H.nhorns+1 ,rmsstat.AVE-6*rmsstat.SD,rmsstat.AVE+6*rmsstat.SD,0,0);
  cpglab("Horn","rms (K)","Average rms for all dumps");
  ci = 1; ls =1;
  for (j = statplot.fileno; j < statplot.fileno+statplot.NFILES; j++) {
    for (i = 0; i<H.nhorns; i++) {
      y[i] = rmsstat.ave[j][i];
      y1[i] = rmsstat.ave[j][i]-rmsstat.sd[j][i];
      y2[i] = rmsstat.ave[j][i]+rmsstat.sd[j][i];
    }
    cpgsci(ci); cpgsls(ls);
    cpgpt(H.nhorns, x, y,1);
    cpgline(H.nhorns, x, y);
    cpgerry(H.nhorns, x, y1, y2, 1);
    ci++;
    ls++;
    if (ls>5) ls = 1;
  }
  cpgslct(id1);
  cpgclos();
  id1 = 0;
  pthread_exit(0);
}

void
stats_plot (GtkWidget *widget, gpointer data)
{
  statplot.mode = (int) data;
  if (statplot.mode == 1) 
    psfile_win();
  else 
    pthread_create (&thread, NULL, make_stat_plot, NULL);
  /*    make_stat_plot();*/
}


void
PrintGtkSTATS(int jfile, int NFILES)
{

  char txt[25];
  static GtkWidget *statw;
  GtkWidget *vbox;
  GtkWidget *scrolled_window;
  GtkWidget *txtw;
  GtkWidget *button;
  /*  GtkWidget *frame;*/
  GtkWidget *hbox;
  int i,N,ifs,ih;  
  
  if (statw != NULL) gtk_widget_destroy (statw);
  sprintf(txt,"Statistics for file %s",infile[jfile]);

  statplot.fileno = jfile;
  statplot.NFILES = NFILES;
  statplot.mode = 0;
  statw = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_window_set_title (GTK_WINDOW (statw), txt);
  
  gtk_signal_connect (GTK_OBJECT (statw), "destroy",
		      GTK_SIGNAL_FUNC (gtk_widget_destroyed), &statw);
  gtk_container_border_width (GTK_CONTAINER (statw), 5);
  vbox = gtk_vbox_new(FALSE, 5);
  gtk_container_add (GTK_CONTAINER (statw), vbox);
  
  scrolled_window = gtk_scrolled_window_new (NULL, NULL);
  gtk_box_pack_start (GTK_BOX (vbox), scrolled_window, TRUE, TRUE, 0);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolled_window),
				  GTK_POLICY_NEVER,
				  GTK_POLICY_ALWAYS);
  gtk_widget_show (scrolled_window);

  txtw = gtk_text_new (NULL, NULL);
  gtk_text_set_editable (GTK_TEXT (txtw), FALSE);
  gtk_container_add (GTK_CONTAINER (scrolled_window), txtw);
  gtk_widget_grab_focus (txtw);
  gtk_widget_show (txtw);
  gtk_text_set_word_wrap(GTK_TEXT (txtw), FALSE);
  gtk_widget_set_usize (txtw, 900, 300);


  N=strlen(infile[jfile]);
  for(i=0; i<N+3+4*H.nhorns-10; i++) append_log(0,1,1,txtw," ");
  append_log(2,1,2,txtw," P I X E L S \n");
  append_log(0,1,1,txtw,"\n");
  for(i=0; i<N+6; i++) append_log(0,1,1,txtw," ");
  for(ih=0; ih<16; ih++) append_log(4,1,1,txtw," %5d ",ih+1);
  append_log(2,1,1,txtw,"    File Average ");
  append_log(0,1,1,txtw,"\n ");
  for(i=0; i<N+8; i++) append_log(0,1,1,txtw," ");
  for(i=0; i<5*H.nhorns+4; i++) append_log(0,1,1,txtw,"_");
  append_log(0,1,1,txtw,"\n\n");
  for(ifs=jfile; ifs<jfile+NFILES; ifs++) {
    N=strlen(infile[ifs]);
    append_log(4,1,1,txtw,"%s", infile[ifs]);
    for (i = 0; i<3; i++) append_log(0,1,1,txtw," ");
    for(ih=0; ih<16; ih++) append_log(0,1,1,txtw," %5.2f",rmsstat.ave[ifs][ih]);
    append_log(2,1,1,txtw,"      %4.2f",rmsstat.file_ave[ifs]);
    append_log(0,1,1,txtw,"\n");
    append_log(4,1,1,txtw,"+/-");
    for(i=0; i<N+2; i++) append_log(0,1,1,txtw," ");
    for(ih=0; ih<16; ih++) append_log(0,1,1,txtw," %5.2f",rmsstat.sd[ifs][ih]);
    append_log(2,1,1,txtw,"      %4.2f\n",rmsstat.file_sd[ifs]);
  }
  /*  append_log(0,1,1,txtw,"\n ");*/
  for(i=0; i<N+8; i++) append_log(0,1,1,txtw," ");
  for(i=0; i<5*H.nhorns+4; i++) append_log(0,1,1,txtw,"_");
  append_log(0,1,1,txtw,"\n\n");
  append_log(2,1,1,txtw,"Pixel Avg");
  for(i=0; i<N+3-9; i++) append_log(0,1,1,txtw," ");
  for(ih=0; ih<16; ih++) append_log(0,1,1,txtw," %5.2f",rmsstat.horn_ave[ih]);
  append_log(0,1,1,txtw,"\n");
  append_log(4,1,1,txtw,"+/-");
  for(i=0; i<N+2; i++) append_log(0,1,1,txtw," ");
  for(ih=0; ih<16; ih++) append_log(0,1,1,txtw," %5.2f",rmsstat.horn_sd[ih]);
  append_log(0,1,1,txtw,"\n");
  for(i=0; i<N+8; i++) append_log(0,1,1,txtw," ");
  for(i=0; i<5*H.nhorns+4; i++) append_log(0,1,1,txtw,"_");
  append_log(0,1,1,txtw,"\n");
  append_log(0,1,1,txtw,"\n");
  for(i=0; i<N+3+3*H.nhorns-10; i++) append_log(0,1,1,txtw," ");
  append_log(2,1,1,txtw,"Global Average: %4.2f +/- %4.2f K\n\n", rmsstat.AVE,rmsstat.SD);

  hbox = gtk_hbox_new (FALSE, 5);
  gtk_box_pack_start (GTK_BOX (vbox), hbox, TRUE, TRUE, 0);
  
  button = gtk_button_new_with_label ("Plot");
  gtk_box_pack_start (GTK_BOX (hbox), button, FALSE, FALSE, 0);
  gtk_widget_show (button);
  gtk_signal_connect (GTK_OBJECT (button), "clicked",
		      GTK_SIGNAL_FUNC (stats_plot), 
		      (gpointer) 0);


  button = gtk_button_new_with_label ("Plot to Postscript file");
  gtk_box_pack_start (GTK_BOX (hbox), button, FALSE, FALSE, 0);
  gtk_widget_show (button);
  gtk_signal_connect (GTK_OBJECT (button), "clicked",
		      GTK_SIGNAL_FUNC (stats_plot), 
		      (gpointer) 1);

  gtk_widget_realize (statw);
  button = gtk_button_new_with_label ("Dismiss");
  gtk_box_pack_start (GTK_BOX (hbox), button, FALSE, FALSE, 0);
  gtk_widget_show (button);
  gtk_signal_connect_object (GTK_OBJECT (button), "clicked",
			     GTK_SIGNAL_FUNC (gtk_widget_destroy),
			     GTK_OBJECT (statw));

  gtk_widget_show (hbox);
  gtk_widget_show (vbox);
  gtk_widget_show (statw);
 
}

