#ifdef GUI
#include "otftool.h"
extern void update_plabel (int, char*);
extern void update_progressbar(int, float);
extern void error_mes (gchar *, gchar *);
#else
#include "otf.h"
#endif
#include "classio.h"

extern int ReadXHeader (char *);
extern void GetCALSCAN (float *);
extern int CheckMASK (int, int);
extern int ChebychevSet (float *, short int *);
extern int ChebychevFit1(float *, short int *);
extern int ChebychevFit2(float *, short int *);
extern void ChebychevFree (void);


     /* User_function is an external function called by Class subroutine rzero 
      * simply expects a logical .false. on return */

     int User_function(char *text) {
       return 0;
}

FCALLSCFUN1(INT,User_function,USER_FUNCTION,user_function, STRING)




int compare(const void *a,const void *b);

int ReGridData(outfile)
char *outfile;
{
 FILE *calfp;
 char history[72];
 char errmsg[50];
 short int iwind;
 int ifile,i1,i2,i,ih,idmp,k,ix,iy; 
 long nvox,firstpixel,ii,jj,ind,ndim;
 /* float xmin,xmax,ymin,ymax,XMIN,XMAX,YMIN,YMAX;*/
 /* float xpos,ypos;*/
 float HR,TCAL;
 float HORNC[32],FACTOR[32];
 float nulval;
 float *WT,*T,*R1,*R2,*R,*M,*Z;
 float *CALSCAN=NULL;
 float *TSYS,*INT_TIME,*MAX_WT;
 struct stat statbuf;
 int len_outfile;
 int rstart[MSEQ],rend[MSEQ],done,curr,diff,nseq;
 int *scanhist;
 int ERROR = 0;
 float datamin, datamax;
 int beenhere;
 short int neq;
 short int *C=NULL;
 /* double *b;*/
 double xcen,ycen;
 char temp[MAXPATHLEN];

/* Make lookup table for convolving kernel */
 MakeWeights();
/* initialize beenhere flag */
 beenhere=0;

/* Generate Arrays */
 ndim=H.nchan*H.nhorns;
 if (H.caltype) {
   if ( (CALSCAN = (float *) malloc(sizeof(float)*ndim))==NULL) {
#ifdef GUI
     strcpy(logtext_string,"\n Can not allocate memory for array CALSCAN\n");
     append_log(2,1,1,otfgui->logtext,logtext_string);
     return(-1);
#else
     fprintf(stderr,"\n Can not allocate memory for array\n");
     exit(3);
#endif
   }
 }
 if ( (R1 = (float *) malloc(sizeof(float)*ndim))==NULL) {
#ifdef GUI
   strcpy(logtext_string,"\n Can not allocate memory for array R1\n");
   append_log(2,1,1,otfgui->logtext,logtext_string);
   return(-1);
#else
   fprintf(stderr,"\n Can not allocate memory for array\n");
   exit(3);
#endif
 }
 if ( (R2 = (float *)malloc(sizeof(float)*ndim))==NULL) {
#ifdef GUI
   strcpy(logtext_string, "\n Can not allocate memory for array R2\n");
   append_log(2,1,1,otfgui->logtext,logtext_string);
   return(-1);
#else
   fprintf(stderr,"\n Can not allocate memory for array\n");
   exit(3);
#endif
 }
 if ( (R = (float *)malloc(sizeof(float)*ndim))==NULL) {
#ifdef GUI
   append_log(2,1,1,otfgui->logtext,"\n Can not allocate memory for array R\n");
   return(-1);
#else
   fprintf(stderr,"\n Can not allocate memory for array\n");
   exit(3);
#endif
 }
 if ( (M = (float *)malloc(sizeof(float)*ndim))==NULL) {
#ifdef GUI
   append_log(2,1,1,otfgui->logtext,"\n Can not allocate memory for array M\n");
   return(-1);
#else
   fprintf(stderr,"\n Can not allocate memory for array\n");
   exit(3);
#endif
 }
 if ( (Z = (float *)malloc(sizeof(float)*H.nchan))==NULL) {
#ifdef GUI
   append_log(2,1,1,otfgui->logtext,"Can not allocate memory for array Z\n");
   return(-1);
#else 
    fprintf(stderr,"\n Can not allocate memory for array\n");
    exit(3);
#endif
 }
 if (base || noise_weight*rmsweight || rmsthreshold < 1.0e+30) {
   /* Set up channel mask according to window intervals */
   if ( (C = (short int *)malloc(sizeof(short int )*H.nchan))==NULL) {
#ifdef GUI
     append_log(2,1,1,otfgui->logtext,"Can not allocate memory for array C\n");
     return(-1);
#else
     fprintf(stderr,"\n Can not allocate memory for C array\n");
     exit(3);
#endif
   }
 }

/* Check for cal file command line argument */
 if (strcmp(&calfile[0],"")) {
   if ((calfp=fopen(calfile,"r"))==NULL) {
#ifdef GUI
     sprintf(logtext_string,"Cannot open calfile file %s :",calfile);
     strcat(logtext_string, strerror(errno));
     append_log(2,1,1,otfgui->logtext,"%s\n",logtext_string);
   /*      append_log(0,1,1,"\n");*/
     return(-2);     
#else 
     fprintf(stderr,"\n Can not open calfile %s\n", calfile);
     exit(1);
#endif
   }
   ih=0;
   while(!feof(calfp)) {
     fscanf(calfp,"%f %f",&HORNC[ih],&FACTOR[ih]);
#ifdef GUI
     append_log(2,1,1,otfgui->logtext,"CAL Coeff: %3.0f %5.3f\n",HORNC[ih],
		FACTOR[ih]);
#else 
     fprintf(stderr,"\n %3.0f %5.3f",HORNC[ih],FACTOR[ih]);
#endif
     ih++;
   }
   fclose(calfp);
  }

 nvox=naxes[0]*naxes[1]*naxes[2];
 if ( (T = (float *)malloc(sizeof(float)*nvox))==NULL) {
#ifdef GUI
   append_log(2,1,1,otfgui->logtext,"\n Can not allocate memory for array T\n");
   return(-1);
#else   
   fprintf(stderr,"\n Can not allocate memory for array\n");
   exit(3);
#endif
 }
 nelements=naxes[1]*naxes[2];
 if ( (WT = (float *)malloc(sizeof(float)*nelements))==NULL) {
#ifdef GUI
   append_log(2,1,1,otfgui->logtext,"\n Can not allocate memory for array WT\n");
   return(-1);
#else   
   fprintf(stderr,"\n Can not allocate memory for array\n");
   exit(3);
#endif
 }
 if ( (TSYS = (float *)malloc(sizeof(float)*nelements))==NULL) {
#ifdef GUI
   append_log(2,1,1,otfgui->logtext,"\n Can not allocate memory for array TSYS\n");
   return(-1);
#else   
   fprintf(stderr,"\n Can not allocate memory for array\n");
   exit(3);
#endif
 }
 if ( (MAX_WT = (float *)malloc(sizeof(float)*nelements))==NULL) {
#ifdef GUI
   append_log(2,1,1,otfgui->logtext,"\n Can not allocate memory for array MAX_WT\n");
   return(-1);
#else   
   fprintf(stderr,"\n Can not allocate memory for array\n");
   exit(3);
#endif
 }
 if ( (INT_TIME = (float *)malloc(sizeof(float)*nelements))==NULL) {
#ifdef GUI
   append_log(2,1,1,otfgui->logtext,"\n Can not allocate memory for array INT_TIME\n");
   return(-1);
#else   
   fprintf(stderr,"\n Can not allocate memory for array\n");
   exit(3);
#endif
 }

  if ((scanhist = (int *) malloc (sizeof(int)*nfiles)) == NULL) {
#ifdef GUI
    append_log(2,1,1, otfgui->logtext,"scanhist malloc error\n");
    return(-1);
#else
    fprintf(stderr, "scanhist malloc error\n");
    exit(3);
#endif
  }


/* Initialize arrays */
 for(i=0; i<nvox; i++) T[i]=0.0;
 for(i=0; i<nelements; i++) {
   WT[i]=0.0;
   TSYS[i]=0.0;
   MAX_WT[i]=-1.0e+30;
   INT_TIME[i]=0.0;
 }

#ifdef GUI
 update_plabel (0, "Working on file");
 append_log (0, 1, 1,otfgui->logtext,"\n");
#endif
/* Start reading, re-gridding, writing */
 for(ifile=0; ifile<nfiles; ifile++) {
#ifdef GUI
   update_progressbar(0, ((float) ifile/(float) nfiles)*100.0);
   update_plabel(1,infile[ifile]);
   /*   append_log(0,1,1,otfgui->logtext,"\n**********************************************\n");*/
   append_log(0,1,1,otfgui->logtext,"Processing: %s\n",infile[ifile]);
#else
    fprintf(stderr,"\n\n\n**********************************************");
    fprintf(stderr,"\n Processing: %s",infile[ifile]);
#endif
    /*    strcpy(temp,rawdir);
	  strcat(temp,infile[ifile]); */
    strcpy (temp, infile[ifile]);
    if ((otffp=fopen(temp,"r"))==NULL) {
#ifdef GUI
      sprintf(logtext_string,"Cannot open input file %s :",temp);
      strcat(logtext_string, strerror(errno));
      append_log(2,1,1,otfgui->logtext,"%s\n",logtext_string);
      /*      append_log(0,1,1,"\n");*/
      return(-2);     
#else 
      fprintf(stderr,"\n Can not open file %s\n", infile[ifile]);
      exit(1);
#endif
    }

    ReadHEADER();
    ReadXHeader(infile[ifile]);

    if (H.caltype) GetCALSCAN(CALSCAN);
      
    GetREFERENCE(1,R1);
    GetREFERENCE(2,R2);
#ifdef GUI
    /*    append_log(0,1,1,otfgui->logtext,"\n");*/
#else
    fprintf(stderr,"\n ");
#endif
    i1=H.caltype+1;   
    i2=H.nsample-1;
    for(idmp=0; idmp<H.nsample; idmp++) {
#ifdef GUI
      if (stop_regrid) return (-5);
      sprintf(logtext_string," %d",idmp+1);
      progress_val = (float) (((float) idmp/(float) H.nsample)*100.0);
      /*     fprintf(stderr, " %g ", progress_val); */
      update_progressbar (1, (gfloat) progress_val);
      update_progressbar(0, ((((float) ifile/(float) nfiles)+
			      ((progress_val/100.0)*((float) 1.0/(float) nfiles)))*100.0));
      update_plabel (3,logtext_string);
      /*      append_log (0,1,1,otfgui->logtext,logtext_string);*/
#else
      fprintf(stderr," %d",idmp+1);
#endif


      if (OTFPOS.XOFF[idmp] < 21600) {
      for(ih=0; ih<H.nhorns; ih++) {
/*      check mask for this horn at this position */
        if (CheckMASK(idmp,ih)) {
          GetDUMP(idmp,M);
          WeightREF(WTmode,idmp,R1,R2,R);
          for(k=0; k<H.nchan; k++) {
            ii=Getindex(k,ih,H.nchan);
            TCAL=H.tsys[ih];
            if (H.caltype) TCAL=CALSCAN[ii];
            Z[k]=NAN;
            if (fabs(M[ii]) < 1.0e+30 && fabs(R[ii]) < 1.0e+30) {
              if (R[ii] != 0.0) 
                Z[k]=TCAL*(M[ii]-R[ii])/R[ii];
            }
          }
 
/*        Apply 12CO scaling factor from calfile */
          if (strcmp(&calfile[0],"")) {
            for(k=0; k<H.nchan; k++) {
               if (fabs(Z[k]) < 1.0e+30) Z[k]=Z[k]/FACTOR[ih];
            }
          }

 
/*        flat field data              */
          if (flatfield) {
            for(k=0; k<H.nchan; k++) {
               if (fabs(Z[k]) < 1.0e+30) Z[k]=Z[k]/(0.001*H.gain[ih]);
            }
          }

          if (!beenhere) {
           if (base || noise_weight*rmsweight || rmsthreshold < 1.0e+30) {
            neq=order+1;
            for(k=0; k<H.nchan; k++) C[k]=1;
            for(iwind=0; iwind<nwind; iwind++) {
             i1=w1[iwind]; i2=w2[iwind];
             for(k=i1; k<=i2; k++) C[k]=0;
            }
            ChebychevSet(Z,C);
           }
           beenhere=1;
          }


/*        remove baseline if necessary */
          if (base) {
            if (H.bw < 320. ) {
             ChebychevFit1(Z,C); 
            }
            else ChebychevFit2(Z,C);
          }
          if (base || noise_weight*rmsweight || rmsthreshold < 1.0e+30) 
               rms[ih][idmp]=GetRMS(Z,C);

/*        convolve this position into output image */
          convolve(idmp,ih,Z,WT,TSYS,INT_TIME,MAX_WT,T);

        }  /* end of checkmask condition */

      } /* end of horn loop */
     } /* end of OTFPOS.XOFF condition */

      /*      sleep(1);*/

    }  /* end of dump loop */

    fclose(otffp);
    for(ih=0; ih<H.nhorns; ih++) {
      free(XPOS[ih]);
      free(YPOS[ih]);
    }

 }   /* end of infile loop */

#ifdef GUI
 append_log (0,1,1,otfgui->logtext, "End of infile loop\n");
#endif

  if (H.caltype) free(CALSCAN);
  free(R1);
  free(R2);
  free(R);
  free(M);
  if (base || noise_weight*rmsweight || rmsthreshold < 1.0e+30) {
    free(C);
    if (base) ChebychevFree();
  }
    
  if (out_type==1) {
#ifdef GUI
    append_log (0,1,1, otfgui->logtext, "Initializing FITS file\n");
#else
    fprintf(stderr,"\n Initializing FITS file");
#endif
    naxis=3;
    if (fits_create_file(&fptr, outfile, &status)) printerror( status );
    if (fits_create_img(fptr,FLOAT_IMG,naxis,naxes,&status)) printerror( status );
/* Set undefined pixel value */
/*   irrelevant for floating pt images
    fits_set_imgnul(fptr,LONG_NAN,&status);
    fits_update_key(fptr, TLONG, "BLANK  ", &LONG_NAN, " ",&status);
*/
#ifdef GUI
    append_log(0,1,1, otfgui->logtext,"Writing FITS Headers\n");
#else 
    fprintf(stderr,"\n Writing FITS Headers");
#endif
    fits_write_date(fptr,&status);
    fits_update_key(fptr, TSTRING, "OBJECT  ", H.name, " ",&status);
    fits_update_key(fptr, TSTRING, "TELESCOP", "FCRAO-14M", " ",&status);
    fits_update_key(fptr, TSTRING, "INSTRUME", "SEQUOIA", " ",&status);
    fits_update_key(fptr, TDOUBLE, "OBS_DATE", &H.utd, " ",&status);
    HR=57.295779513*H.utc/15.0;
    fits_update_key(fptr, TFLOAT, "UT      ", &HR, "HOURS",&status);
    HR=57.295779513*H.tsid/15.0;
    fits_update_key(fptr, TFLOAT, "LST     ", &HR, "HOURS",&status);
    fits_update_key(fptr, TFLOAT,  "EPOCH   ", &H.epoch, " ",&status);
    xcen=57.295779513*H.azs;
    fits_update_key(fptr, TDOUBLE, "AZIMUTH ", &xcen, "DEGREES",&status);
    ycen=57.295779513*H.els;
    fits_update_key(fptr, TDOUBLE, "ELEVATIO", &ycen, "DEGREES",&status);
    fits_update_key(fptr, TFLOAT,  "VLSR    ", &H.vlsr, "KM/S ",&status);
    fits_update_key(fptr, TSTRING, "BUNIT   ", "   K   ", "TA*",&status);
    fits_update_key(fptr, TDOUBLE, "SKY_FREQ", &H.fsky, "GHZ",&status);
    fits_update_key(fptr, TDOUBLE, "LINEFREQ", &H.f0, "GHZ",&status);
    fits_update_key(fptr, TFLOAT, "BW      ", &H.bw, "MHZ",&status);
    if (linename != NULL) {
      fits_update_key(fptr, TSTRING, "LINENAME", linename, " ",&status);
    }
    
    fits_update_key(fptr, TSTRING, "CTYPE1", ctype1, " ",&status);
    crval1=crval1*1000.0;
    fits_update_key(fptr, TFLOAT, "CRVAL1", &crval1, "M/S",&status);
    cdelt1=cdelt1*1000.0;
    fits_update_key(fptr, TFLOAT, "CDELT1", &cdelt1, "M/S",&status);
    fits_update_key(fptr, TFLOAT, "CRPIX1", &crpix1, " ",&status);

    fits_update_key(fptr, TSTRING, "CTYPE2", ctype2, " ",&status);
    xcen=57.295779513*H.XCEN;
    fits_update_key(fptr, TDOUBLE, "CRVAL2", &xcen, "DEGREES",&status);
    fits_update_key(fptr, TFLOAT, "CDELT2", &cdelt2, "DEGREES",&status);
    crpix2=-(crval2)/cdelt2+1.;
    fits_update_key(fptr, TFLOAT, "CRPIX2", &crpix2, " ",&status);
    
    fits_update_key(fptr, TSTRING, "CTYPE3", ctype3, " ",&status);
    ycen=57.295779513*H.YCEN;
    fits_update_key(fptr, TDOUBLE, "CRVAL3", &ycen, "DEGREES",&status);
    fits_update_key(fptr, TFLOAT, "CDELT3", &cdelt3, "DEGREES",&status);
    crpix3=-(crval3)/cdelt3+1.;
    fits_update_key(fptr, TFLOAT, "CRPIX3", &crpix3, " ",&status);
    
    sprintf(history,"Generated by FCRAO Regridding Program %4.2f",(float)OTFREV);
    fits_write_history(fptr,history,&status);
    if (base) {
      sprintf(history,"Baseline Subtracted");
      fits_write_history(fptr,history,&status);
      sprintf(history,"     Global Baseline Parameters: %1d order polynomial",ORDER);
      fits_write_history(fptr,history,&status);
      if (wind_type==1) {
        sprintf(history,"     Window Type=channel");
      }
      else sprintf(history,"Window Type=velocity");
      fits_write_history(fptr,history,&status);
      for(iwind=0; iwind<NWIND; iwind++) {
        sprintf(history,"     %1d %7.2f %7.2f ",iwind+1,W1[iwind],W2[iwind]);
        fits_write_history(fptr,history,&status);
      }
    }
    else {
      sprintf(history,"No Baseline Subtracted");
      fits_write_history(fptr,history,&status);
    }
    if (noise_weight*rmsweight) {
      sprintf(history,"Noise weighting 1/pow(SIGMA,2)");
      fits_write_history(fptr,history,&status);
    }
    if (noise_weight*tsysweight) {
      sprintf(history,"Noise weighting 1/pow(TSYS,2)");
      fits_write_history(fptr,history,&status);
    }
    if (!noise_weight) {
      sprintf(history,"No Noise weighting");
      fits_write_history(fptr,history,&status);
    }
    if (!flatfield) {
      sprintf(history,"No Flat Fielding of Data");
      fits_write_history(fptr,history,&status);
    }
    else {
      sprintf(history,"Flat Fielding of Data");
      fits_write_history(fptr,history,&status);
      sprintf(history,"Main Beam Efficiencies Relative to Pixel 11 ");
      fits_write_history(fptr,history,&status);
      ih=0;
      i=0;
      for(i=0; ih<H.nhorns; ih++) {
        sprintf(history,"     %2d %4.3f ",ih+1,0.001*H.gain[ih]);
        fits_write_history(fptr,history,&status);
      }
    }

    switch(kopt) {
    case 1:
      sprintf(history,"Spatial Filter: Jinc*gaussian*Jinc");
      fits_write_history(fptr,history,&status);
      break;
    case 2:
      sprintf(history,"Spatial Filter: Sinc*gaussian");
      fits_write_history(fptr,history,&status);
      break;
    case 3:
      sprintf(history,"Spatial Filter: Sinc");
      fits_write_history(fptr,history,&status);
      break;
    case 4:
      sprintf(history,"Spatial Filter: gaussian");
      fits_write_history(fptr,history,&status);
      break;
    }

  /* Fill in history of scans of the otf map */
    sprintf(history,"Input OTF Scans:");
    fits_write_history(fptr,history,&status);
    for (i = 0; i<nfiles; i++) {
      /*      strcpy(temp,rawdir);
	      strcat(temp,infile[i]); */
      strcpy (temp, infile[i]);
      if ((otffp=fopen(temp,"r"))==NULL) {
        sprintf(errmsg,"Input OTF file: %s",temp);
        strcat(errmsg,strerror(errno));
#ifdef GUI
        error_mes("Error!", errmsg);
#endif
        return (-1);
      }
      ReadHEADER();
      scanhist[i] = H.iscan;
      fclose(otffp);
    }

    if ((scanhist[nfiles-1]-scanhist[0]) == (nfiles-1)) {
      rstart[0] = scanhist[0]; rend[0] = scanhist[nfiles-1];
      nseq = 1;
      sprintf(history,"%5d to %5d ",rstart[0],rend[0]);
      fits_write_history(fptr,history,&status);
    }
    else {
      qsort(scanhist,nfiles,sizeof(int),compare);
      nseq = 0;
      done = 0;
      curr = 0;
      rstart[nseq] = scanhist[curr];
      while (1) {
       diff = scanhist[curr+1]-scanhist[curr];
       while (diff == 1) {
         curr++;
          /*      printf("%d %d\n",nseq,curr);*/
         if (curr >= (nfiles-1)) {
           done = 1;
           break;
         } 
         else {
           diff=scanhist[curr+1]-scanhist[curr];
         }
       }
       rend[nseq] = scanhist[curr];
      /*      printf("done with diff %d\n",nseq);*/
       nseq++;
       curr++;
       rstart[nseq] = scanhist[curr];
       if (done) break;
      }

      if (nseq <= MSEQ) {
      for (i = 0; i<nseq; i++) {
        sprintf(history,"%5d to %5d ",rstart[i],rend[i]);
        fits_write_history(fptr,history,&status);
        /*      printf("%d %d %d\n",i,rstart[i],rend[i]);*/
      }
    } else {
#ifdef GUI
      append_log(2,1,1,otfgui->logtext,"\n History list overflowed Class origin buffer\n");
#else
      fprintf(stderr,"\n History list overflowed Class origin buffer\n");
#endif
    }
    }

  } else {
#ifdef GUI
    append_log (0,1,1, otfgui->logtext, "Initializing CLASS file \n");
#else
    fprintf(stderr,"\n Initializing CLASS file\n");
#endif
    len_outfile = (int) strlen(outfile);
    LAS_SETUP2;        /* setup default class parameters */
    /*    las_setup2();*/
    /*    printf("%g %g\n",H.epoch, H.vlsr);
	  printf("%g %g\n",H.XCEN, H.YCEN);*/
    if (!stat(outfile, &statbuf)) {
      /* File already exists - append to existing file */
#ifdef GUI
      append_log (0,1,1,otfgui->logtext, "File %s already exists - appending to existing file \n",
		  outfile);
#else
      fprintf (stderr, "File %s already exists - appending to existing file \n",
	       outfile);
#endif
      OUTPUT(outfile, len_outfile, 0, ERROR);
      if (ERROR) {
#ifdef GUI	
	append_log (0,1,1,otfgui->logtext, "Error opening output CLASS file \n");
	return (-1);
#else	
	fprintf(stderr, "\n Error opening output CLASS file \n");
	exit(3);
#endif
      }
      nfound = Com.OXNEXT - 1; /*OXNEXT is the next index #in o/p file */
      /*      printf("nfound = %d\n",nfound);*/
    } else {
      /* File is new - create it */
#ifdef GUI
      append_log (0,1,1,otfgui->logtext, "File %s is new - creating it\n",
		  outfile);
#else
      fprintf (stderr, "File %s is new - creating it\n", outfile);
#endif
      nfound = 0;
      NEWPUT(outfile, len_outfile, M_OX, 0, ERROR);
      if (ERROR) {
#ifdef GUI
	append_log (2,1,1,otfgui->logtext, "Error opening output CLASS file \n");
	return (-1);
#else	
	fprintf(stderr, "\n Error opening output CLASS file \n");
	exit(3);
#endif
      }
    }
    RZERO(C_FUNCTION(USER_FUNCTION,user_function));
    ClassHEAD();
  }     
       

/* Normalize DATA and write out final spectrum */
#ifdef GUI
  append_log (0, 1, 1, otfgui->logtext, "Normalizing Data\n");
#else
  fprintf(stderr,"\n Normalizing Data ");
#endif  
  for(iy=0; iy<naxes[2]; iy++) {
    for(ix=0; ix<naxes[1]; ix++) {
      ii=Getindex(ix,iy,naxes[1]);

      if (WT[ii]!=0.0 && MAX_WT[ii]>(float)MAXWEIGHT) {
	TSYS[ii]=TSYS[ii]/WT[ii];
	jj=ii*naxes[0];

	for(k=0; k<naxes[0]; k++) {
          Z[k]=NAN;
          if (out_type==1) Z[k]=0.0;
          if (T[jj+k] < 1.0e+30) Z[k]=T[jj+k]/WT[ii];
	}
      }
      else {
	TSYS[ii]=NAN;
	INT_TIME[ii]=0.0;
	for(k=0; k<naxes[0]; k++) {
          Z[k]=NAN;
          if (out_type==1) Z[k]=0.0;
        }
      }
      
      /*     Write the spectrum into a CLASS file or back into the FITS cube */
      switch(out_type) {
      case 1:            /* FITS CUBE */
	ind=Getindex(ix,iy,naxes[1]);
	firstpixel=ind*naxes[0]+1;
	nulval=0.0;
	status=0;
	nelements=naxes[0];
	if (fits_write_img(fptr,TFLOAT,firstpixel,nelements,Z, &status))
	  printerror( status );
	break;
      case 2:            /* CLASS FILE */
	if (WT[ii]!=0.0 && MAX_WT[ii]>(float)MAXWEIGHT) {
	  /*	if (WT[ii] != 0.0) {*/
	  Crpar.RLAMOF = (crval2 + ((float) (ix)*cdelt2)) * DEG2RAD;
	  Crpar.RBETOF = (crval3 + ((float) (iy)*cdelt3)) * DEG2RAD;
	  Crpar.RNUM++;
	  Crpar.RTSYS = TSYS[ii];
	  Crpar.RTIME = INT_TIME[ii];
	  datamin = Z[0]; datamax = Z[0];
	  for (k=0; k<naxes[0]; k++) {
	    Crdata.RDATAY[k] = Z[k];
	    if (Crdata.RDATAY[k] < datamin) datamin = Crdata.RDATAY[k];
	    if (Crdata.RDATAY[k] > datamax) datamax = Crdata.RDATAY[k];
	  }
	  Crpar.RAMAX = datamax + 0.05 * (datamax-datamin);
	  Crpar.RAMIN = datamin - 0.05 * (datamax-datamin);
	  /*	  NEWDAT;*/
	  /*	  printf("Crpar.RNSEQ = %d\n",Crpar.RNSEQ);*/
	  /*
#ifdef GUI
	  append_log (0,1,1,otfgui->logtext, "(%d, %d)  ",ix,iy);
#endif
	  */
	  SUB_WRITE(ERROR, C_FUNCTION(USER_FUNCTION,user_function));

	}
	break;
      }
    }
  } 
  if (out_type==1) {
    if (fits_close_file(fptr,&status)) printerror( status );
  } else {
    close(Com.OLUN);
  }
  free(scanhist);
  free(T);
  free(Z);
  free(WT);
  free(TSYS);
  free(MAX_WT);
  free(INT_TIME);
  return(0);
}
