#ifdef GUI
#include "otftool.h"
extern void error_mes (gchar *, gchar *);
#else
#include "otf.h"
#endif

int SetFITSHEADERS(xmin,xmax,ymin,ymax)
float xmin,xmax,ymin,ymax;
{
 int i1,j1;

  naxes[0]=H.nchan;
  crval1=H.xvel1;  cdelt1=H.dveldin;  crpix1=1.0;

/* Ensure that the data falls on same grid as 0,0 */
  i1=fabs(xmax)/(THETA_N/60.0);
  crval2=0.0;
  if (xmax != 0.0) crval2=i1*(THETA_N/3600.)*(fabs(xmax)/xmax);
  xmax=60.0*crval2;
  naxes[1]=(xmax-xmin)/(THETA_N/60.0)+1; 
  j1=fabs(ymin)/(THETA_N/60.0);
  crval3=0.0;
  if (ymin != 0.0) crval3=j1*(THETA_N/3600.)*(fabs(ymin)/ymin);
  ymin=60.0*crval3;
  naxes[2]=(ymax-ymin)/(THETA_N/60.0)+1; 
  
  cdelt2=-THETA_N/3600.0;  cdelt3=THETA_N/3600.;
  crpix2=1.0;  crpix3=1.0;
  strcpy(ctype1,H.vlabel);
  strcpy(ctype2,H.xlabel);
  strcpy(ctype3,H.ylabel);

  if (naxes[1]*naxes[2] > MAXDIM*MAXDIM) {
#ifdef GUI
    sprintf(logtext_string,"\n Output image exceeds dimension limits ");
    append_log(0,1,1,otfgui->logtext,logtext_string);
    error_mes("Error!",logtext_string);
    sprintf(logtext_string,"\n Calculated dimensions: %ld x %ld=%ldi pixels", naxes[1],naxes[2],naxes[1]*naxes[2]);
    append_log(0,1,1,otfgui->logtext,logtext_string);
    sprintf(logtext_string,"\n        MAX pixels: %ld ", MAXDIM*MAXDIM);
    append_log(0,1,1,otfgui->logtext,logtext_string);
    sprintf(logtext_string,"\n Exiting\n");
    return -1;
#else
    fprintf(stderr,"\n Output image exceeds dimension limits ");
    fprintf(stderr,"\n Calculated dimensions: %d x %d=%ld pixels", naxes[1],naxes[2],naxes[1]*naxes[2]);
    fprintf(stderr,"\n        MAX pixels: %ld", MAXDIM*MAXDIM);
    fprintf(stderr,"\n Exiting\n");
    exit(1);
#endif
  }
#ifdef GUI
  sprintf(logtext_string,"\n Output Cube dimensions: %3ld x %3ld x %3ld", naxes[0],naxes[1],naxes[2]);
  append_log(0,1,1,otfgui->logtext,logtext_string);
  sprintf(logtext_string,"\n crval1 = %7.3f", crval1);
  append_log(0,1,1,otfgui->logtext,logtext_string);
  sprintf(logtext_string,"\n cdelt1 = %6.3f", cdelt1);
  append_log(0,1,1,otfgui->logtext,logtext_string);
  sprintf(logtext_string,"\n crpix1 = %6.3f", crpix1);
  append_log(0,1,1,otfgui->logtext,logtext_string);
  sprintf(logtext_string,"\n ctype1 = %s", ctype1);
  append_log(0,1,1,otfgui->logtext,logtext_string);
  sprintf(logtext_string,"\n crval2 = %7.3f", crval2);
  append_log(0,1,1,otfgui->logtext,logtext_string);
  sprintf(logtext_string,"\n cdelt2 = %6.4f", cdelt2);
  append_log(0,1,1,otfgui->logtext,logtext_string);
  sprintf(logtext_string,"\n crpix2 = %6.3f", crpix2);
  append_log(0,1,1,otfgui->logtext,logtext_string);
  sprintf(logtext_string,"\n ctype2 = %s", ctype2);
  append_log(0,1,1,otfgui->logtext,logtext_string);
  sprintf(logtext_string,"\n crval3 = %7.3f", crval3);
  append_log(0,1,1,otfgui->logtext,logtext_string);
  sprintf(logtext_string,"\n cdelt3 = %6.4f", cdelt3);
  append_log(0,1,1,otfgui->logtext,logtext_string);
  sprintf(logtext_string,"\n crpix3 = %6.3f", crpix3);
  append_log(0,1,1,otfgui->logtext,logtext_string);
  sprintf(logtext_string,"\n ctype3 = %s", ctype3);
  append_log(0,1,1,otfgui->logtext,logtext_string);
#else
  fprintf(stderr,"\n Output Cube dimensions: %3d x %3d x %3d", naxes[0],naxes[1],naxes[2]);
  fprintf(stderr,"\n crval1 = %7.3f", crval1);
  fprintf(stderr,"\n cdelt1 = %6.3f", cdelt1);
  fprintf(stderr,"\n crpix1 = %6.3f", crpix1);
  fprintf(stderr,"\n ctype1 = %s", ctype1);
  fprintf(stderr,"\n crval2 = %7.3f", crval2);
  fprintf(stderr,"\n cdelt2 = %6.4f", cdelt2);
  fprintf(stderr,"\n crpix2 = %6.3f", crpix2);
  fprintf(stderr,"\n ctype2 = %s", ctype2);
  fprintf(stderr,"\n crval3 = %7.3f", crval3);
  fprintf(stderr,"\n cdelt3 = %6.4f", cdelt3);
  fprintf(stderr,"\n crpix3 = %6.3f", crpix3);
  fprintf(stderr,"\n ctype3 = %s", ctype3);
#endif 
  return 0;
}
