#ifdef GUI
#include "otftool.h"
extern update_plabel (int, char*);
extern update_progressbar(int, float);
#else
#include "otf.h"
#endif

int 
TotalPower(otffile)
char *otffile;
{
 char xopt[16],yopt[16],title[96],title1[96];
 int iw,i,ih,ii,k,idmp,nch;
 int IHORN;
 int just,axis,NX,NY,IX,IY;
 float *X,*R1,*R2,*R,*M,*TA,*CALSCAN;
 float xl,xu,yl,yu,xsize,ysize;
 float tmax,tmin,ymin,ymax,v1,v2,vtmp;
 float TCAL;

 ReadHEADER();
 ReadXHeader(otffile);

 just=0; axis=0;
 if ( (X = (float *)malloc(sizeof(float)*H.nsample))==NULL) {
   fprintf(stderr,"\n Can not allocate memory for X array\n");
   exit(3);
 }
 for(idmp=0; idmp<H.nsample; idmp++) {
    X[idmp]=1.0*idmp;
 }
 v1=X[0]; v2=X[H.nsample-1];
   
 if ( (M = (float *)malloc(sizeof(float)*H.nchan*H.nhorns))==NULL) {
#ifdef GUI
   strcpy(logtext_string,"\n Can not allocate memory for MAIN data array\n");
   append_log(2,1,1,otfgui->logtext,logtext_string);
   return(-1);
#else
   fprintf(stderr,"\n Can not allocate memory for MAIN data array\n");
   exit(3);
#endif
 }
 if ( (TA = (float *)malloc(sizeof(float)*H.nhorns*H.nsample))==NULL) {
#ifdef GUI
   strcpy(logtext_string,"\n Can not allocate memory for MAIN data array\n");
   append_log(2,1,1,otfgui->logtext,logtext_string);
   return(-1);
#else
   fprintf(stderr,"\n Can not allocate memory for MAIN data array\n");
   exit(3);
#endif
 }


#ifdef GUI
   update_plabel(0, "Working on horn");
#endif


    NX=4;  NY=4;
    if (H.nhorns==32) NX=8;
    xsize=0.8/(float)NX;  ysize=0.8/(float)NY;
    if (id2 > 0) {
     cpgslct(id2);
     cpgask(0);
     cpgpage();
    }
    else if (id2 == 0) {
 /*  Open graphics device. */
     id2=cpgopen("/xserve");
     if (id2 < 1) exit(1);
     cpgslct(id2);
     cpgask(0);
  }
    
 tmax=-1.0e+30;  tmin=1.0e+30;
/* Now start gathering ON data */
 for(IHORN=0; IHORN<H.nhorns; IHORN++) {
  
#ifdef GUI
   sprintf(logtext_string," %d", IHORN+1);
   update_plabel(1, logtext_string);
#endif
  for(idmp=0; idmp<H.nsample; idmp++) {   /* MAIN data in idmp 1:ndumps-1 */

     i=Getindex(idmp,IHORN,H.nsample);
     TA[i]=0.0;
     if(OTFPOS.XOFF[idmp] < 21600) {
       GetDUMP(idmp,M);
    
       nch=0.0;
       for(k=0; k<H.nchan; k++) {
         ii=Getindex(k,IHORN,H.nchan);
         if (fabs(M[ii]) < 1.0e+30) {
           TA[i]+=M[ii];
           nch++;
         }
       }
       if (nch) TA[i]=TA[i]/(float)nch;
       if (TA[i]>tmax) tmax=TA[i];
       if (TA[i]<tmin) tmin=TA[i];
     }  

  }                   /* end of dump loop */
 }                   /* end of horn loop */

 for(IHORN=0; IHORN<H.nhorns; IHORN++) {
   IX=fmod(IHORN,NX)+1;
   IY=(IHORN/NX)+1;
   xl=0.10+(IX-1)*xsize;  xu=xl+xsize;
   yl=0.90-(IY)*ysize;  yu=yl+ysize;
   cpgsvp(xl,xu,yl,yu);
   ymin=tmin-0.15*(tmax-tmin);
   ymax=tmax+0.15*(tmax-tmin);
   cpgswin(v1,v2,ymin,ymax);
   strcpy(xopt,"bcst");
   strcpy(yopt,"bcst");
   if (IX==1 && IY==NY) {
     strcpy(xopt,"bncst");
     strcpy(yopt,"bncst");
   }
   cpgsci(1);
   cpgbox(xopt,0,0,yopt,0,0);
   if (IX==1 && IY==NY) {
    sprintf(title,"\0" );
    cpglab("Dump","Tot. Pwr", title);
   }
   cpgsci(7);
   cpgbin(H.nsample,X,&TA[Getindex(0,IHORN,H.nsample)],1);
 }
 cpgsvp(0.1,0.90,0.1,0.9);
 sprintf(title1,"Scan %5d", H.iscan);
 cpgsci(1);
 cpglab(title,title,title1);

 if (id2 > 0) {
   cpgslct(id2); 
   cpgclos();
 }
/* Free memory */
  free(X);
  free(M);
  free(TA);
  return(0);
}
