#include "cfitsio.h"
#include "otf.h"

void WriteFITSHEADER()
{
 char keyname[16],comment[64];

 fits_write_date(fptr,&status);
 strcpy(keyname,"OBJECT"); strcpy(comment," ");
 fits_write_key(fptr,TSTRING,keyname,&h.H.name[0],comment,&status);
 strcpy(keyname,"ORIGIN"); strcpy(comment," ");
 fits_write_key(fptr,TSTRING,keyname,"FCRAO-OTF",comment,&status);
 strcpy(keyname,"TELESCOP"); strcpy(comment," ");
 fits_write_key(fptr,TSTRING,keyname,"FCRAO-14M",comment,&status);
 strcpy(keyname,"INSTRUME"); strcpy(comment," ");
 fits_write_key(fptr,TSTRING,keyname,"SEQUOIA",comment,&status);

 strcpy(keyname,"CTYPE1"); strcpy(comment," ");
 fits_write_key(fptr,TSTRING,keyname,h.H.ctype1,comment,&status);
 strcpy(keyname,"CRVAL1"); strcpy(comment,"KM/S");
 fits_write_key(fptr,TFLOAT,keyname,&h.H.xvel1,comment,&status);
 strcpy(keyname,"CRPIX1"); strcpy(comment," ");
 fits_write_key(fptr,TFLOAT,keyname,1.0,comment,&status);
 strcpy(keyname,"CDELT1"); strcpy(comment,"KM/S ");
 fits_write_key(fptr,TFLOAT,keyname,&h.H.dveldin,comment,&status);

 strcpy(keyname,"CTYPE2"); strcpy(comment," ");
 fits_write_key(fptr,TSTRING,keyname,h.H.ctype2,comment,&status);
 strcpy(keyname,"CRVAL2"); strcpy(comment,"");
 fits_write_key(fptr,TFLOAT,keyname,&h.H.XCEN,comment,&status);
 strcpy(keyname,"CRPIX2"); strcpy(comment," ");
 fits_write_key(fptr,TFLOAT,keyname,&crpix2,comment,&status);
 strcpy(keyname,"CDELT2"); strcpy(comment," ");
 fits_write_key(fptr,TFLOAT,keyname,cdelt2,comment,&status);

 strcpy(keyname,"CTYPE3"); strcpy(comment," ");
 fits_write_key(fptr,TSTRING,keyname,h.H.ctype3,comment,&status);
 strcpy(keyname,"CRVAL3"); strcpy(comment,"");
 fits_write_key(fptr,TFLOAT,keyname,&h.H.YCEN,comment,&status);
 strcpy(keyname,"CRPIX3"); strcpy(comment," ");
 fits_write_key(fptr,TFLOAT,keyname,&crpix3,comment,&status);
 strcpy(keyname,"CDELT3"); strcpy(comment," ");
 fits_write_key(fptr,TFLOAT,keyname,cdelt3,comment,&status);

 for(i=0; i<nfiles; i++) {
   strcpy(comment,infile[i][0]);
   fits_write_history(fptr,comment,&status);
 }
  
}
