/*

Copyright (C) 2001  Gopal Narayanan <gopal@astro.umass.edu>

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
USA.

*/

/* callback_general.c
 * General purpose callbacks
 */

#include "otftool.h"

extern int save_defaults ();

gint 
delete_event (GtkWidget *widget, GdkEvent *event,
		   gpointer data)
{
  /* If you return FALSE in the "delete_event" signal handler,
   * GTK will emit the "destroy" signal. Returning TRUE means
   * you don't want the window to be destroyed.
   * This is useful for popping up 'are you sure you want to quit?'
   * type dialogs. */

  return FALSE;
}

void 
destroy( GtkWidget *widget,
	      gpointer  data )
{

/* save window size */
  gdk_window_get_size ( GTK_WIDGET (otfgui->mainwindow)->window, 
			&main_window_width, &main_window_height);
  strcpy(sname,filter.sname);
  strcpy(linename_sav,linename);
  save_defaults(); 
  gtk_main_quit();
}

