/* include file  for class io routines
 * uses cfortran.h to glue the c otf structure 
 * to the class fortran common blocks
 * Gopal Narayanan <gopal@astro.umass.edu>
 * Sept. 2001
 */

#ifndef __CLASSIO_H
#define __CLASSIO_H

/* class I/O includes */
#include "cfortran.h"
#include "projection.h"
#include "common_inc.h"
#include "index_inc.h"
#include "parameter_inc.h"
#include "rdata_inc.h"
#include "structure_par.h"
#include "setup_inc.h"

/* for stat'ing files */
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>

/* NEWPUT: Class routine to initialize an output file */

PROTOCCALLSFSUB5(NEWPUT,newput, STRING, INT, INT, LOGICAL, PLOGICAL)
#define NEWPUT(SPEC,NSPEC,LSIZE,LSHARE,ERROR) \
CCALLSFSUB5(NEWPUT, newput, STRING, INT, INT, \
LOGICAL, PLOGICAL, SPEC,NSPEC,LSIZE,LSHARE,ERROR) 

     /* OUTPUT: Internal routine
      * Close any output file, set the file specifications for output
      * open this file.
      * (also selected for input if infile not defined) */
     PROTOCCALLSFSUB4(OUTPUT,output, STRING, INT, LOGICAL, PLOGICAL)
#define OUTPUT(SPEC, NSPEC, LSHARE, ERROR) \
CCALLSFSUB4(OUTPUT,output, STRING, INT, LOGICAL, PLOGICAL, SPEC, NSPEC, \
LSHARE, ERROR)

     PROTOCCALLSFSUB3(INPUT,input,STRING,INT,PLOGICAL)
#define INPUT(SPEC,NSPEC,ERROR) \
CCALLSFSUB3(INPUT,input,STRING,INT,PLOGICAL, SPEC,NSPEC,ERROR) 

    PROTOCCALLSFSUB1(RZERO,rzero, ROUTINE)
#define RZERO(F) \
CCALLSFSUB1(RZERO,rzero, ROUTINE, F)

     /* NEWDAT: Internal routine
      * Recompute scaling factors when a new scan is read in. Also called
      * after changes in plotting mode or unit. */
     PROTOCCALLSFSUB0(NEWDAT,newdat)
#define NEWDAT CCALLSFSUB0(NEWDAT,newdat)

/* SUB_WRITE: Support routine for class write
      * Writes the observation in R onto the output file
      */
     PROTOCCALLSFSUB2(SUB_WRITE,sub_write, PLOGICAL, ROUTINE)
#define SUB_WRITE(ERROR, F) \
CCALLSFSUB2(SUB_WRITE, sub_write, PLOGICAL, ROUTINE, ERROR, F)
#define sub_write_ sub_write__
     
     PROTOCCALLSFSUB0(INFO,info)
#define INFO CCALLSFSUB0(INFO,info)

     PROTOCCALLSFSUB0(LAS_SETUP,las_setup)
#define LAS_SETUP CCALLSFSUB0(LAS_SETUP,las_setup)
#define las_setup_ las_setup__

     PROTOCCALLSFSUB0(LAS_SETUP2,las_setup2)
#define LAS_SETUP2 CCALLSFSUB0(LAS_SETUP2,las_setup2)
#define las_setup2_ las_setup2__

     PROTOCCALLSFSUB0(LAS_VARIABLES2,las_variables2)
#define LAS_VARIABLES2 CCALLSFSUB0(LAS_VARIABLES2,las_variables2)
#define las_variables2_ las_variables2__

 PROTOCCALLSFSUB3(GAG_FROMDATE,gag_fromdate,STRING, PINT, PLOGICAL)
#define GAG_FROMDATE(DATE,IDATE,ERROR) \
CCALLSFSUB3(GAG_FROMDATE, gag_fromdate, STRING, PINT, PLOGICAL, DATE, IDATE, ERROR)
#define gag_fromdate_ gag_fromdate__

     PROTOCCALLSFSUB3(GAG_TODATE,gag_todate,INT,PSTRING,PLOGICAL)
#define GAG_TODATE(IDATE,DATE,ERROR) \
CCALLSFSUB3(GAG_TODATE, gag_todate, INT, PSTRING, PLOGICAL, IDATE, DATE, ERROR)
#define gag_todate_ gag_todate__

     PROTOCCALLSFSUB5(FIX,fix,PINT,PINT,LOGICAL,LOGICAL,PLOGICAL)
#define FIX(NFOUND,IFOUND,UPDATE,NEW_WANTED,ERROR) \
CCALLSFSUB5(FIX,fix,PINT,PINT,LOGICAL,LOGICAL,PLOGICAL,NFOUND,IFOUND,UPDATE,NEW_WANTED,ERROR) 

     PROTOCCALLSFSUB3(FOX,fox,INT,PINT,PLOGICAL)
#define FOX(NFOUND,IFOUND,ERROR) \
CCALLSFSUB3(FOX,fox,INT,PINT,PLOGICAL,NFOUND,IFOUND,ERROR)

#ifndef M_PI
#define M_PI 3.14159265358979323846  /* pi */
#endif


#endif
