/*
 * common_inc.h
 * Derived from GAG/linux-intel/astro/class/common.inc
 * fortran include file
 * Gopal Narayanan <gopal@astro.umass.edu>
 * July 14, 2001
 */

#ifndef __COMMON_INC_H_
#define __COMMON_INC_H_

#include <cfortran.h>

#define MSEC 64               /* Maximum number of sections */
#define MEX 251               /* Maximum number of extensions to index */
#define LENBUF 128

/*
      CHARACTER*80 ISPEC,OSPEC           ! fichiers entree, sortie
      INTEGER*4 IBLOC,                   ! bloc de l'obs courante
     $CLUN,                              ! lun de l'observation courante
     $MAXSEC,                            ! nb. max de sections
     $ILUN,                              ! lun du fichier d'entree
     $OLUN                               ! lun du fichier sortie
*/


/*int IBLOC,CLUN, MAXSEC, ILUN, OLUN;*/

/* 
      INTEGER*4 INBLOC,                  ! nbr. de blocs de l'obs. courante
     $IDATA,                             ! ad. donnees
     $INSEC,                             ! nb. de sections
     $INEXT,ONEXT,                       ! proch bloc libre ds fichier
     $IXNUM,                             ! num. index de l'obs.
     $INSPEC,ONSPEC,                     ! long. nom de fichier
     $IKBL,                              ! offset actuel dans l'obs. (blocs)
     $ICODE,                             ! code d'id. lu
     $CODE1,CODE2,CODE3,                 ! codes d'identification
     $ISEC(MSEC),                        ! numeros des sections
     $ILEN(MSEC),                        ! longueurs des sections
     $IADD(MSEC),                        ! addresses des sections
     $ILEX,OLEX,                         ! longueur de l'extension d'index
     $IMEX,OMEX,                         ! nombre d'extensions de l'index
     $IEX(MEX),OEX(MEX),                 ! tableau des addr. des ext. (blocs)
     $XLUN,XBL,                          ! unite log. et bloc contenu ds xbuf
     $IXNEXT,OXNEXT,                     ! next avail. index entry
     $INWORD,                            ! nombre de mots ecrits ds l'obs.
     $IDATAL,                            ! nb. de mots des donnees
     $OLD_IXNEXT                         ! Last known data in input file.
*/

/*
int INBLOC, IDATA, INSEC, INEXT, ONEXT, IXNUM;
int INSPEC, ONSPEC, IKBL, ICODE, CODE1, CODE2, CODE3;
int ISEC[MSEC], ILEN[MSEC], IADD[MSEC];
int ILEX, OLEX, IMEX, OMEX, IEX[MEX], OEX[MEX];
int XLUN, XBL, IXNEXT, OXNEXT;
int INWORD, IDATAL, OLD_IXNEXT;
*/



/*
      INTEGER LENBUF
      PARAMETER (LENBUF=128)
      INTEGER*4
     $IBUF(LENBUF),                      ! buffer de lecture/ecriture
     $XBUF(LENBUF),                      ! buffer de lec/ecr. d'index
      INTEGER OCONVE                     ! Do format conversion, output
*/

/*
int IBUF[LENBUF],XBUF[LENBUF];
int OCONVE;
*/
/*
      LOGICAL MODIFY                     ! the current observation is open for modification
      LOGICAL SHARE                      ! the output file is shared
      LOGICAL FROM_OLD                   ! Reading from old data format (i.e. PDP11)
      REAL INTERVAL                      ! Wait time for NEW_DATA
      INTEGER NUMBER_TRYS
*/
/*
int MODIFY, SHARE, FROM_OLD;
int NUMBER_TRYS;
*/
/*
COMMON/COM/ INTERVAL,NUMBER_TRYS,
  $ISEC,ILEN,IADD,IH,
  $IBLOC,IBUF,IKBL,CLUN,ILUN,OLUN,
  $INEXT,ILEX,IMEX,IXNEXT,IEX,        ! NOTE: the ordering of these
  $ONEXT,OLEX,OMEX,OXNEXT,OEX,        ! variables is COMPULSORY
  $MAXSEC,INSPEC,ONSPEC,
  $XBUF,XLUN,XBL,
  $OLD_IXNEXT,ICONVE,OCONVE,CODE1,CODE2,CODE3,
  $MODIFY,SHARE,FROM_OLD
COMMON/CARCOM/ ISPEC,OSPEC
*/

typedef struct {
  float INTERVAL;                 /* Wait time for NEW_DATA */
  int NUMBER_TRYS;
  int ISEC[MSEC], ILEN[MSEC], IADD[MSEC];
  union {
    int ih[9];
    int icode;
    struct {
      int dummy;
      int inbloc;
    } s1;
    struct {
      int dummy[2];
      int inword;
    } s2;
    struct {
      int dummy[4];
      int idata;
    } s3;
    struct {
      int dummy[5];
      int idatal;
    } s4;
    struct {
      int dummy[7];
      int insec;
    } s5;
    struct {
      int dummy[8];
      int ixnum;
    } s6;
  } u1;
  int IBLOC;
  int IBUF[LENBUF];
  int IKBL, CLUN, ILUN, OLUN;
  int INEXT, ILEX, IMEX, IXNEXT;
  int IEX[MEX];
  int ONEXT, OLEX, OMEX, OXNEXT;
  int OEX[MEX];
  int MAXSEC, INSPEC, ONSPEC;
  int XBUF[LENBUF];
  int XLUN, XBL;
  int OLD_IXNEXT, ICONVE, OCONVE, CODE1, CODE2, CODE3;
  int MODIFY, SHARE, FROM_OLD;
} COM_DEF;


#define IH u1.ih
#define ICODE u1.icode
#define INBLOC u1.s1.inbloc
#define INWORD u1.s2.inword
#define IDATA u1.s3.idata
#define IDATAL u1.s4.idatal
#define INSEC u1.s5.insec
#define IXNUM u1.s6.ixnum


#define Com COMMON_BLOCK(COM,com)
COMMON_BLOCK_DEF(COM_DEF,Com);

typedef struct {
  char ISPEC[80], OSPEC[80];
} CARCOM_DEF;

#define Carcom COMMON_BLOCK(CARCOM,carcom)
COMMON_BLOCK_DEF(CARCOM_DEF,Carcom);

union {
  int iex[MEX];
  int iex1[123];
  struct {
    int dummy[123];
    int iex2[128];
  } s;
} u2;

#define IEX u2.iex
#define IEX1 u2.iex1
#define IEX2 u2.s.iex2

union {
  int oex[MEX];
  int oex1[123];
  struct {
    int dummy[123];
    int oex2[128];
  } s;
} u3;

#define OEX u3.oex
#define OEX1 u3.oex1
#define OEX2 u3.s.oex2


#endif



