#include "otf.h"

void convolve(idmp,ihorn,Z,WT,TSYS,INT_TIME,MAX_WT,T)
int idmp,ihorn;
float *Z,*WT,*TSYS,*INT_TIME,*MAX_WT,*T;
{
int ii,ix,iy,k,is,ic;
long jj;
float XMAX,YMIN,deltax,deltay,rad2,dely2;
float YBEG,XBEG,STEP,RMAX2;
int iybeg,iyend,ixbeg,ixend;
double dx,wt,wt0,wt1;
double clight=2.99792458e+10;
float lambda_D;
float D=1370.0;     /* FCRAO diameter in cm */

 if (rmsthreshold < 1.0e+30 && rms[ihorn][idmp] > rmsthreshold) return;

 wt1=1.0;
 if (noise_weight*rmsweight) {             /* spatial + 1/rms^2 weighting */
   if (rms[ihorn][idmp] != 0.0) {
     wt1 = rms[ihorn][idmp];
	 wt1 = 1.0 / (wt1 * wt1);
   } 
   else {
     fprintf(stderr,"\n WARNING: rms for Horn %2d: Dump %4d is ZERO",
            ihorn+1,idmp); 
     fprintf(stderr,"\n Weighting set to 1.0\n"); 
     wt1=1.0;
   }
 }
 if (noise_weight*tsysweight) {             /* spatial + 1/tsys^2 weighting */
   if (H.tsys[ihorn] != 0.0) {
     wt1 = H.tsys[ihorn];
	 wt1 = 1.0 / (wt1 * wt1);
   } 
   else {
     fprintf(stderr,"\n WARNING: TSYS for Horn %2d is ZERO",ihorn);
     fprintf(stderr,"\n Weighting set to 1.0\n"); 
     wt1=1.0;
   }
 }
/* Now do spatial weighting  */
 ic=H.nchan/2;
 if (H.nchan  > 128) ic=505;
 dx=RMAX/256.0;
 XMAX=60.0*crval2;
 YMIN=60.0*crval3;
 lambda_D=206264.81*(clight/H.fsky/1.0e+09)/D;       /* lambda/D in arcsecs */

 STEP = THETA_N / lambda_D;

 YBEG = 60.0 * (YPOS[ihorn][idmp] - YMIN) / lambda_D;

 iybeg = (YBEG - RMAX) / STEP + 1;
 if (iybeg < 0) iybeg = 0;

 iyend = (YBEG + RMAX) / STEP + 1;
 if (iyend > naxes[2]) iyend=naxes[2];

 XBEG = 60.0 * (XMAX - XPOS[ihorn][idmp]) / lambda_D;

 ixbeg = (XBEG - RMAX) / STEP + 1;
 if (ixbeg < 0) ixbeg=0;

 ixend = (XBEG + RMAX) / STEP + 1;
 if (ixend > naxes[1]) ixend=naxes[1];

 RMAX2 = RMAX * RMAX;

/* distribute this value to the output image */
 for(iy=iybeg; iy<iyend; iy++) {
    deltay = iy * STEP - YBEG;
	dely2 = deltay * deltay;

    for(ix=ixbeg; ix<ixend; ix++) {
	   deltax = XBEG - ix * STEP;
       rad2 = deltax * deltax + dely2;

       if (rad2 < RMAX2) {
         is=sqrt(rad2)/dx;
         wt0=weights[is];
         wt=wt0*wt1;
         ii=Getindex(ix,iy,naxes[1]);
         WT[ii]+=wt;
         TSYS[ii]+=H.tsys[ihorn]*wt;
         INT_TIME[ii]+=wt*H.tdump;
         if (wt0 > MAX_WT[ii]) MAX_WT[ii]=wt0;
         jj=naxes[0]*ii; 

/*  For the correlator we could define a channel range and get 
    rid of this Z < 1.0e+30 test  */

         for(k=0; k<naxes[0];k++) {
            if (Z[k] < 1.0e+30) T[jj+k]+=(float)wt*Z[k];
		 }

     /*   DEBUG statements 
      fprintf(stderr,"\n %5d %3d %2d %4.2f %4.2f",H.iscan, idmp,ihorn,XPOS[ihorn][idmp],YPOS[ihorn][idmp]);
      fprintf(stderr," %2d %2d %4.2f %4.2f %5.2f %5.2f %5.2f %4.2f %5.3f %6.3e %6.3e %6.3e ", ix,iy,x,y,deltax,deltay,radius,arg,rms[ihorn][idmp],wt1,wt0,wt);
      fprintf(stderr," %2d %2d %6.3e %6.3e %6.3e ", ii,jj,Z[ic],T[jj+ic],WT[ii]);
     */
	   }
    }
 }
}
