#include <math.h>

void coord(ao,bo,ap,bp,a1,b1,a2,b2)
double ao,bo,ap,bp,a1,b1,*a2,*b2;
{
/*
    coordinate rotation using spherical triangles
    ao,bo = input:  origin of a2 in a1,b1 coordinate system
    ap,bp = input:  pole of b2 in a1,b1 coordinate system
    a1,b1 = input:  coordinates in a1,b1 coordinate system
    a2,a2 = output: coordinates in a2,b2 coordinate system
*/
 double sbo,cbo,sbp,cbp,sb1,cb1,sb2,cb2,saa,caa,cbb,sbb,sa2,ca2,ta2o2;


      sbo=sin(bo);
      cbo=cos(bo);
      sbp=sin(bp);
      cbp=cos(bp);
      sb1=sin(b1);
      cb1=cos(b1);
      sb2=sbp*sb1+cbp*cb1*cos(ap-a1);
      cb2=sqrt(1.0-sb2*sb2);
      *b2=atan2(sb2,cb2);

      saa=sin(ap-a1)*cb1/cb2;
      caa=(sb1-sb2*sbp)/(cb2*cbp);
      cbb=sbo/cbp;
      sbb=sin(ap-ao)*cbo;
      sa2=saa*cbb-caa*sbb;
      ca2=caa*cbb+saa*sbb;
      if (ca2 <= 0.0) {  
        ta2o2=(1.0-ca2)/sa2;
      }
      else ta2o2=sa2/(1.0+ca2);
   
      *a2=2.0*atan(ta2o2);
      if (*a2 < 0.0) *a2=*a2+6.28318530720;
}
