#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include "fitsio.h"

/*
#if defined(linux) || defined(LINUX)
#define main    MAIN__
#endif
*/

int status,nhorn=16;
long naxes[2],anaxes[2];
double acrval1,acrval2,acrpix1,acrpix2,acdelt1,acdelt2,acrota;
char acoordtype[16];

void printerror(int);

main()
{
fitsfile *ifptr;
double x,y,ix,iy;
int bitpix, i,j,anynul;
float T[128][256],nulval;
long firstpixel[2],nelements;

  fits_open_file(&ifptr,"cep.fits",READONLY, &status);
  fits_get_img_size(ifptr, 10, anaxes, &status);
  fprintf(stdout,"\n Image %5ld x %5ld", anaxes[0],anaxes[1]);
  fits_read_img_coord(ifptr, &acrval1,&acrval2,&acrpix1,&acrpix2,
                      &acdelt1,&acdelt2,&acrota,acoordtype,&status);
  fprintf(stdout,"\n crval1 = %7.3f crval2 = %7.3f", acrval1,acrval2);
  fprintf(stdout,"\n crpix1 = %6.2f crpix2 = %6.2f", acrpix1,acrpix2);
  fprintf(stdout,"\n cdelt1 = %7.3f cdelt2 = %7.3f", acdelt1,acdelt2);
  fprintf(stdout,"\n crota = %7.3f ", acrota);
  fprintf(stdout,"\n coordytpe = %s", acoordtype);
  fprintf(stderr,"\n ");
 
  acrval1=acrval1*60.0; acrval2=acrval2*60.0;
  acdelt1=acdelt1*60.0; acdelt2=acdelt2*60.0;

  x=0.0; y=0.0;
/*
  if ( fits_world_to_pix(x,y,acrval1,acrval2,acrpix1,acrpix2,
                      acdelt1,acdelt2,acrota,acoordtype,&ix,&iy, &status))
  printerror( status );    
*/
  ix=acrpix1+(acrval1-x)/acdelt1;
  iy=acrpix2+(x-acrval2)/acdelt2;
  fprintf(stderr,"\n %6.2f %6.2f --> %4.1f %4.1f", x,y,ix,iy);
  i=(int)ix;  j=(int)iy;
  if (fits_get_img_type(ifptr, &bitpix, &status))
  printerror( status );    
  fprintf(stderr,"\n bitpux=%d", bitpix);
      
  firstpixel[0]=1; firstpixel[1]=1;  nelements=anaxes[0]*anaxes[1];
  nulval=0.0;
  status=0;
  fprintf(stderr,"\n Entering read function\n");
  if (fits_read_pix(ifptr,TFLOAT,firstpixel,nelements,&nulval,T,&anynul, &status))
  printerror( status );    
  for(j=0; j<anaxes[1]; j++) {
  for(i=0; i<anaxes[0]; i++) 
  fprintf(stderr,"\n %d %d T = %6.2f", i,j,T[j][i]);
  }

  fits_close_file(ifptr,&status);
  printerror( status );    
}
void printerror( int status)
{
    /*****************************************************/
    /* Print out cfitsio error messages and exit program */
    /*****************************************************/


    if (status)
    {
       fits_report_error(stderr, status); /* print error report */

       exit( status );    /* terminate the program, returning error status */
    }
    return;
}
