#include <cpgplot.h>
#include "otf.h"

void PlotColumn(IHORN,ix,TA)
int IHORN,ix;
float *TA;
{
 char title[96];
 int i,k;
 float min,max,v;
 float *X,*Y;
  
 fprintf(stderr,"\n Inside PlotCol: %d %d",id2,ix);
 if ( (X = (float *)malloc(sizeof(float)*h.H.nsample))==NULL) {
   fprintf(stderr,"\n Can not allocate memory for X array\n");
   exit(3);
 }
 if ( (Y = (float *)malloc(sizeof(float)*h.H.nsample))==NULL) {
   fprintf(stderr,"\n Can not allocate memory for Y array\n");
   exit(3);
 }

 max=-1.0e+20; min=1.0e+20;
 for(k=0; k<h.H.nsample; k++) {
   X[k]=1.0+(float)k;
   i=Getindex(ix,k,h.H.nchan);
   Y[k]=TA[i];
   if (TA[i] > max) max=TA[i];
   if (TA[i] < min) min=TA[i];
 }
 v=h.H.xvel1+(ix-1.0)*h.H.dveldin;
 sprintf(title,"%s vlsr %6.2f km/s    Scan %6d Column %3d ", 
         h.H.name,v,h.H.iscan,ix);
 cpgenv(X[0],X[h.H.nsample-1], min,max, 0, 0);
 cpglab("Sample","T", title);
 cpgline(h.H.nsample,X,Y);

 free(X);
 free(Y);
}

