#include "otf.h"

void RestoreRawData(IHORN,TA)
int IHORN;
float *TA;
{
  int i,ii,k,idmp;
  short int ieq,neq;
  float *R1,*R2,*R;
  double x,*b,c[7];

 neq=h.H.order+1;
 b=dvector(1,neq);

 if ( (R1 = (float *)malloc(sizeof(float)*h.H.nchan*h.H.nhorns))==NULL) {
   fprintf(stderr,"\n Can not allocate memory for REF 1  data array\n");
   exit(3);
 }
 if ( (R2 = (float *)malloc(sizeof(float)*h.H.nchan*h.H.nhorns))==NULL) {
   fprintf(stderr,"\n Can not allocate memory for REF 2  data array\n");
   exit(3);
 }
 if ( (R = (float *)malloc(sizeof(float)*h.H.nchan*h.H.nhorns))==NULL) {
   fprintf(stderr,"\n Can not allocate memory for REF  data array\n");
   exit(3);
 }

 for(idmp=0; idmp<h.H.nsample; idmp++) {
   if (h.H.coeff[IHORN][idmp][0]!=0.0) {
     for(ieq=1; ieq<=neq; ieq++) b[ieq]=h.H.coeff[IHORN][idmp][ieq-1];
     WeightREF(WTmode,idmp+1,R1,R2,R);
     for(k=0; k<h.H.nchan; k++) {
       x=(double)k/(h.H.nchan-1.0);
       c[1]=1.0;
       c[2]=2.0*x-1.0;
       c[3]=8.0*pow(x,2.0)-8.0*x+1.0;
       c[4]=32.0*pow(x,3.0)-48.0*pow(x,2.0)+18.0*x-1.0;
       c[5]=128.0*pow(x,4.0)-256.0*pow(x,3.0)+160.0*pow(x,2.0)-32.0*x+1.0;
       c[6]=512.0*pow(x,5.0)-1280.0*pow(x,4.0)+1120.0*pow(x,3.0)-400.0*pow(x,2.0)
              +50*x-1.0;

/*    add polynomial back */
       i=Getindex(k,idmp,h.H.nchan);
       for(ieq=1; ieq<=neq; ieq++) TA[i]+=b[ieq]*c[ieq];

/*    add reference and blank data */
       ii=Getindex(k,IHORN,h.H.nchan);
       TA[i]+=R[ii];

/*  ************       for real data: ***********************************
       TA[i]=R[ii]+T[i]*(R[ii]-h.H.BLANK)/h.H.tsys[IHORN]; 
******************************************************************************/
     }
   }

/* Reset coefficients */
   for(ieq=0; ieq<6; ieq++) h.H.coeff[IHORN][idmp][ieq]=0.0;

 }

 free_dvector(b,1,neq);
 free(R1);
 free(R2);
 free(R);

}
