/*
  DESCRIPTION:
     CHECK_IER checks to see if ier!=0, which indicates that the last 
     IMFORT subtroutine call did not end successfully. The error
     message will be printed out and and value of 1 is returned back
     to the main program so any memory can be de-allocated.

  COMPILING INSTRUCTIONS:
     fcc -c check_ier.c 

  REALTED PROGRAMS:
     CHECK_IER has been incorporated into FIXSPEC.C, ELIM.C, BASELINE.C

  HISTORY:
     1. Written 3/22/92 by JMC
*/

#include <stdio.h>

int check_ier(ier)
int ier;
{
   char s[80];

   if (ier) {
      imemsg(ier,s);
      fprintf(stderr,"\7%s\n",s);
      return(1);
   }
   else
      return(0);
}
