#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <cpgplot.h>
#include "fitsio.h"
#include "otf.h"


FILE *fp;
fitsfile *ifptr;
char actype1[16],actype2[16],actype3[16];
char acoordtype[16];
int MAXDIM=3,anynul,nos;
int status;
long naxes[3],anaxes[3];
long nelements,fpixel=1,naxis=2;

void printerror(int);
int index(int,int,int);

main(argc,argv)
int argc;
char *argv[];
{
 char comment[64];
 int k,ix,iy;
 long ind,firstpixel;
 float s1,s0;
 float tmax;
 float acrval1,acrval2,acrval3,acrpix1,acrpix2,acrpix3,
       acdelt1,acdelt2,acdelt3;
 float I[256];
 float nulval;
 float noise;

  
/* Open input image to observe */
  fits_open_file(&ifptr,argv[1],READONLY, &status);
  fits_get_img_size(ifptr, MAXDIM, anaxes, &status);
  nelements=anaxes[0];

/* Get WCS coordinate headers */
  fits_read_key(ifptr, TFLOAT, "CRVAL1",&acrval1,comment,&status);
  fits_read_key(ifptr, TFLOAT, "CRPIX1",&acrpix1,comment,&status);
  fits_read_key(ifptr, TFLOAT, "CDELT1",&acdelt1,comment,&status);

  fits_read_key(ifptr, TFLOAT, "CRVAL2",&acrval2,comment,&status);
  fits_read_key(ifptr, TFLOAT, "CRPIX2",&acrpix2,comment,&status);
  fits_read_key(ifptr, TFLOAT, "CDELT2",&acdelt2,comment,&status);

  fits_read_key(ifptr, TFLOAT, "CRVAL3",&acrval3,comment,&status);
  fits_read_key(ifptr, TFLOAT, "CRPIX3",&acrpix3,comment,&status);
  fits_read_key(ifptr, TFLOAT, "CDELT3",&acdelt3,comment,&status);
  acrval2=acrval2*60.0; acrval3=acrval3*60.0;
  acdelt2=acdelt2*60.0; acdelt3=acdelt3*60.0;

 for(iy=64; iy<=64; iy++) {
  s1=0.0; s0=0.0; tmax=-1.0e+20;
  for(ix=64; ix<=64; ix++) {
    ind=index(ix,iy,anaxes[1]);
    firstpixel=ind*anaxes[0]+1;
    nulval=0.0;
    status=0;
    if (fits_read_img(ifptr,TFLOAT,firstpixel,nelements,&nulval,I,&anynul, &status
))
    printerror( status );
    for(k=0; k<anaxes[0]; k++) {
      fprintf(stderr,"\n %d %f", k, I[k]);
    }
  }
 }
}


void printerror( int status)
{
    /*****************************************************/
    /* Print out cfitsio error messages and exit program */
    /*****************************************************/


    if (status)
    {
       fits_report_error(stderr, status); /* print error report */

       exit( status );    /* terminate the program, returning error status */
    }
    return;
}

int index(i,j,NX)
int i,j,NX;
{
  return(i+j*NX);
}
  


