#include <stdio.h>
#include <string.h>
#include <math.h>
#include "nrutil.h"
 
#if defined(linux) || defined(LINUX)
#define main	MAIN__
#endif

void GetLimits(int, float *, float *);

main()
{
   int     narg,ier,i,j,k,jj,kk,iv1,iv2,l,ll;
   float   crpix1,crpix2,crpix3,crval1,crval2,crval3,
           cdelt1,cdelt2,cdelt3;
   int  im,im1,axlen[7],naxlen[7],dtype,acmode;
   int naxis,naxis1,naxis2,naxis3;
   char cube[64],imtype[64],output[64],bunit[16];
   float *T,*W;
   float v1,v2,s0,s1,s2,var,rms,tmax,m;

   /* Read command line arguments */

      clnarg(&narg);
      fprintf(stderr,"\n narg = %d", narg);
      if (narg < 5) {
         fprintf(stderr,"\7Error reading command line arguments.\n");
         fprintf(stderr,"    (1) Input data cube \n");
         fprintf(stderr,"    (2) Output Image\n");
         fprintf(stderr,"    (3) Image type \n");
         fprintf(stderr,"    (4) Min velocity\n");
         fprintf(stderr,"    (5) Max velocity \n");
         exit(2);
      }

  clargc(1,cube,&ier);
  if (check_ier(ier)) exit(1);
  acmode=1;
  imopen(cube,acmode,&im,&ier);
  if (check_ier(ier)) exit(1);
  imgsiz(im,naxlen,&naxis,&dtype,&ier);
  if (check_ier(ier)) exit(2);
  naxis1=naxlen[0]; naxis2=naxlen[1]; naxis3=naxlen[2];
  imgkwr(im,"crval1", &crval1, &ier);
  imgkwr(im,"crpix1", &crpix1, &ier);
  imgkwr(im,"cdelt1", &cdelt1, &ier);
  imgkwr(im,"crval2", &crval2, &ier);
  imgkwr(im,"crpix2", &crpix2, &ier);
  imgkwr(im,"cdelt2", &cdelt2, &ier);
  imgkwr(im,"crval3", &crval3, &ier);
  imgkwr(im,"crpix3", &crpix3, &ier);
  imgkwr(im,"cdelt3", &cdelt3, &ier);

  if ( (T = (float *) malloc(sizeof(float) * naxis1*naxis2)) == NULL) {
      printf("\n Insufficient memory available");
      exit(1);
  }
  if ( (W = (float *) malloc(sizeof(float) * naxis2*naxis3)) == NULL) {
      printf("\n Insufficient memory available");
      exit(1);
  }


  clargc(2,output,&ier);
  if (check_ier(ier)) exit(1);
  axlen[0]=naxis2; axlen[1]=naxis3;
  for(i=2; i<7; i++) axlen[i]=0;
  naxis=2; dtype=6;
  imcrea(output,axlen,naxis,dtype,&ier);
  if (check_ier(ier)) exit(1);

  acmode=3;
  imopen(output,acmode,&im1,&ier);
  if (check_ier(ier)) exit(1);

  clargc(3,imtype,&ier);
  fprintf(stderr,"\n Image type: %s", imtype);
  if (check_ier(ier)) exit(1);
  clargr(4,&v1,&ier);
  if (check_ier(ier)) exit(1);
  fprintf(stderr,"\n Min velocity: %7.2f", v1);
  iv1=crpix1+(v1-crval1)/cdelt1-1;
  if (iv1 < 0) iv1=0;
  clargr(5,&v2,&ier);
  if (check_ier(ier)) exit(1);
  fprintf(stderr,"\n Max velocity: %7.2f", v2);
  iv2=crpix1+(v2-crval1)/cdelt1-1;
  if (iv2 > naxis1-1) iv2=naxis1-1;

  for(kk=1; kk<=naxis3; kk++) {
     k=kk-1;
     imgs3r(im,T,1,naxis1,1,naxis2, kk,kk,&ier);
     if (check_ier(ier)) exit(1);


     for(jj=1; jj<=naxis2; jj++) {
       j=jj-1;
       ll=j+k*naxis2;
       W[ll]=0.0; s1=0.0;
       if (!strcmp(imtype,"tint")) {
         for(i=iv1; i<=iv2; i++) {
           l=i+naxis1*j;
           s1+=T[l];
         }
         W[ll]=s1*cdelt1;
         sprintf(bunit,"K km/s  ");
       } 
       else if(!strcmp(imtype,"tmax")) {
          tmax=-1.0e+20;
          for(i=iv1; i<=iv2; i++) {
            l=i+naxis1*j;
            if (T[l] > tmax) tmax=T[l];
          }
          ll=j+k*naxis2;
          W[ll]=tmax;
          strcpy(bunit,"K       ");
       }
       else if(!strcmp(imtype,"rms")) {
         s0=0.0; s1=0.0; s2=0.0;
/*       make first pass thru */
         for(i=1; i<iv1; i++) {
           l=i+naxis1*j;
           if (T[l] != 0.0) {
             s0=s0+1.0; s1=s1+T[l]; s2=s2+pow(T[l],2.);
           }
         }
         for(i=iv2+1; i<naxis1; i++) {
           l=i+naxis1*j;
           if (T[l] != 0.0) {
             s0=s0+1.0; s1=s1+T[l]; s2=s2+pow(T[l],2.);
           }
         }
         if (s0 > 1.0 ) {
           m=s1/s0; 
           var=(s2-2.*s1*m+s0*m*m)/(s0-1.0);
           rms=sqrt(var); 
         }
         s0=0.0; s1=0.0; s2=0.0;
         for(i=1; i<iv1; i++) {
           l=i+naxis1*j;
           if (fabs(T[l]) < 5.0*rms && T[l] != 0.0) {
             s0=s0+1.0; s1=s1+T[l]; s2=s2+pow(T[l],2.);
           }
         }
         for(i=iv2+1; i<naxis1; i++) {
           l=i+naxis1*j;
           if (fabs(T[l]) < 5.0*rms && T[l] != 0.0) {
             s0=s0+1.0; s1=s1+T[l]; s2=s2+pow(T[l],2.);
           }
         }
         rms=0.0;
         if (s0 > 1.0 ) {
            m=s1/s0; 
            var=(s2-2.*s1*m+s0*m*m)/(s0-1.0);
            rms=sqrt(var); 
          }
          ll=j+k*naxis2;
          W[ll]=rms; 
          sprintf(bunit,"K       ");
       }
     }
   }
   fprintf(stderr,"\n Finished looping -- writing data ");
   imps2r(im1,W,1,naxis2, 1,naxis3, &ier);
   if (check_ier(ier)) exit(1);
   fprintf(stderr,"\n Finished  writing data ");

   impkwr(im1,"crval1", crval2, &ier);
   impkwr(im1,"crval2", crval3, &ier);
   impkwr(im1,"crpix1", crpix2, &ier);
   impkwr(im1,"crpix2", crpix3, &ier);
   impkwr(im1,"cdelt1", cdelt2, &ier);
   impkwr(im1,"cdelt2", cdelt3, &ier);
   impkwc(im1,"bunit", bunit, &ier);
   impkwc(im1,"imtype", imtype, &ier);
   fprintf(stderr,"\n Finished  writing header ");
   imclos(im,&ier);
   if (check_ier(ier)) exit(1);
   imclos(im1,&ier);
   if (check_ier(ier)) exit(1);

   free(T);   free(W);
}
