#include "otf.h"
void ParseBaseArguments(int,char**,char*);

main(argc,argv)
int argc;
char *argv[];
{
 FILE *fp;
 char temp[128],otffile[32];
 int iw,N,n;

 wind_type=1;
 CmdLineMASK=-1;
 ORDER=0;
 ParseBaseArguments(argc,argv,otffile);
 
  if ( (fp=fopen(otffile,"r+")) ==NULL ) {
    fprintf(stderr,"\n Can not open OTF list file %s\n", otffile);
    exit(0);
  }
  n=0;
  while(!feof(fp)) {
    if (n == (int)MAXFILES) {
     fprintf(stderr,"\n Too many input files. MAX=%d\n",(int)MAXFILES);
     exit(1);
    }

    fscanf(fp,"%s",temp);
    N=strlen(temp);
    if  ((infile[n] = (char *) malloc(N*sizeof(char)))  == NULL){
     fprintf(stderr,"\n Can not allocate infil mem");
     exit(3);
    }
    strcpy(infile[n],temp);

    n++;
  }

  nfiles=n-1;
  fclose(fp);

  Baseline_All();
  PrintSTATS(0,nfiles);
}

void OTFBaseUsage () {
  fprintf(stderr,"\n Usage: otfbase -f input_list_filename -wt ref_weight_mode{equal:biased}");
  fprintf(stderr," -order order -windtype {channel:velocity} -wind {xl1,xu1;xl2,xu2 ... xl5,xu5} \n");
}

void ParseBaseArguments(argc,argv,otffile)
char **argv,*otffile;
int argc;
{
 char ctmp,carg[64],*b;
 int nh, n,i,horn;
 char windtype_char[5];
 float w1tmp,w2tmp;

 if (argc < 2) {
  OTFBaseUsage();
  exit(2);
 }
 i=1;
 while(i < argc) {
    sscanf(argv[i], "%s", carg);
   
   if (!strcmp(carg,"-order")) {
    i++;
    ORDER=atoi(argv[i]);
    if (ORDER > MAXORDER) {
      fprintf(stderr,"\n Max. allowed Baseline order is %d\n",(int) MAXORDER);
      exit(2);
    }
   }
   else if (!strcmp(carg, "-windtype")) {
     i++;
     sscanf(argv[i],"%s", windtype_char);
     if (!strncmp(windtype_char,"channel",2) && !strncmp(windtype_char,"velocity",2)) {
       fprintf(stderr, "\n Unknown  window type \n");
       OTFBaseUsage();
       exit(2);
     } else {
       if (!strncmp(windtype_char,"channel",2)) {
	 wind_type = 1; 
       } else {
	 wind_type = 2;
       } 
     }
   }
   else if (!strcmp(carg,"-wt")) {
    i++;
    sscanf(argv[i], "%s", WTmode);
    if (!strncmp(WTmode,"equal",2) && !strncmp(WTmode,"biased",2)) {
      fprintf(stderr,"\n Unknown REF weighting option\n");
      exit(2);
    }
   }
   else if (!strcmp(carg,"-f")) {
    i++;
    sscanf(argv[i], "%s", otffile);
   }
   else if (!strcmp(carg,"-wind")) {
    i++;
    nh=0;
    do {
      if (nh) {  
        b=strtok(NULL,",");
      }
      else b=strtok(argv[i],",");
      if (b==NULL) break; 
      sscanf(b,"%f%c%f",&w1tmp,&ctmp,&w2tmp);
      W1[nh]=w1tmp;
      W2[nh]=w2tmp;
      nh++;
      if (nh > MAXWIND) {
        fprintf(stderr,"\n Too many windows defined. MAX=%2d\n",(int)MAXWIND);
        exit(2);
      }
    } while(b!=NULL);
    NWIND=nh;
   }
   else if (!strcmp(carg,"-h")) {
     OTFBaseUsage();
     exit(0);
   }
   else {
    fprintf(stderr,"\n  %s is not an option", carg);
    exit(1);
   }
   i++;
 }
/* Make sure the 4 required command line arguments were given */
 if (!strcmp(otffile,"")) {
  fprintf(stderr,"\n Command line must contain in_file_list option\n");
  OTFBaseUsage();
  exit(1);
 }
}
