#include <stdio.h>
#include <math.h>

main()
{
 FILE *fp;
 int i,j,k,i1,i2,j1,j2,naxes[3],ii,jj,idmp; 
 int iy,nx,ny,ind;
 long nelements;
 float *T;

 naxes[0]=16; naxes[1]=8; naxes[2]=4;

 fprintf(stderr,"\n Initializing scratch file");
 if ((fp=fopen("mh.dat","wb+"))==NULL) {
    fprintf(stderr,"\n Can not open otf scratch file\n");
    exit(1);
 }
 nelements=naxes[0]*naxes[1];
 if ( (T = (float *)malloc(sizeof(float)*nelements))==NULL) {
    fprintf(stderr,"\n Can not allocate memory for array\n");
    exit(3);
 }
 for(i=0; i<nelements; i++) T[i]=0.0;
 for(iy=0; iy<naxes[2]; iy++) fwrite(T,sizeof(float),nelements,fp);
 free(T);
 fprintf(stderr," --- done ");


 for(idmp=0; idmp<3; idmp++) {

  fprintf(stderr,"\n\n\n******************************************************\n");

    i1=1; i2=naxes[1]; j1=1; j2=naxes[2];
    nx=i2-i1+1; ny=j2-j1+1;
    fprintf(stderr,"\n Creating T array: %d %d %d", naxes[0],nx,ny);
    nelements=naxes[0]*nx*ny;
    if ( (T = (float *)malloc(sizeof(float)*nelements))==NULL) {
      fprintf(stderr,"\n Can not allocate memory for array\n");
      exit(3);
    }

    for(j=j1; j<=j2; j++) {
      ind=naxes[0]*Getindex(i1-1,j-1,naxes[1]);
      fprintf(stderr,"\n Moving file pos. ptr to: %ld", ind*sizeof(float));
      fseek(fp,sizeof(float)*ind,SEEK_SET);
      i=(j-j1)*naxes[0]*nx;
      fprintf(stderr,"\n Reading scratch file into ptr %d",i);
      fread(&T[i],sizeof(float),naxes[0]*nx,fp);
    }
    for(j=j1; j<=j2; j++) {
      for(i=i1; i<=i2; i++) {
         ii=Getindex(i-1,j-1,naxes[1]);
         jj=naxes[0]*ii;
         fprintf(stderr,"\n %d %d %ld %ld: ", i,j,ii,jj);
         for(k=0; k<naxes[0]; k++) fprintf(stderr,"%4d %3.1f ",jj+k,T[jj+k]);
      }
    }

    for(j=j1; j<=j2; j++) {
      for(i=i1; i<=i2; i++) {
         ii=Getindex(i-1,j-1,naxes[1]);
         jj=naxes[0]*ii;
         for(k=0; k<naxes[0]; k++) T[jj+k]+=(float)j;
         fprintf(stderr,"\n %d %d %ld %ld: ", i,j,ii,jj);
         for(k=0; k<naxes[0]; k++) fprintf(stderr,"%4d %3.1f ",jj+k,T[jj+k]);
      }
    }
           
          
/*  Write this section back out to disk */
    fprintf(stderr,"\n Writing back to scratch file");
    for(j=j1; j<=j2; j++) {

      ind=naxes[0]*Getindex(i1-1,j-1,naxes[1]);
      fprintf(stderr,"\n Moving file pos. ptr to: %ld", ind*sizeof(float));
      fseek(fp,sizeof(float)*ind,SEEK_SET);
      fprintf(stderr," -- done");
      i=(j-j1)*naxes[0]*nx;
      fprintf(stderr," -- Writing from pointer %ld",i);
      fwrite(&T[i],sizeof(float),naxes[0]*nx,fp);
      fprintf(stderr," -- done");
    }
    free(T);
  }


    fprintf(stderr,"\n\n**************Final ************\n");
    nelements=naxes[0]*naxes[1];
    if ( (T = (float *)malloc(sizeof(float)*nelements))==NULL) {
      fprintf(stderr,"\n Can not allocate memory for array\n");
      exit(3);
    }

    for(j=0; j<naxes[2]; j++) {
      ind=naxes[0]*Getindex(0,j,naxes[1]);
      fprintf(stderr,"\n Moving file pos. ptr to: %ld", ind*sizeof(float));
      fseek(fp,sizeof(float)*ind,SEEK_SET);
      fprintf(stderr," -- done");
      fprintf(stderr,"\n Reading scratch file");
      fread(&T[0],sizeof(float),nelements,fp);

      for(i=0; i<naxes[1]; i++) {
         jj=Getindex(0,i,naxes[0]);
         fprintf(stderr,"\n %d %d %ld: ", i,j,jj);
         for(k=0; k<naxes[0]; k++) fprintf(stderr,"%4d %3.1f ",jj+k,T[jj+k]);
      }
    }

   free(T);
   fclose(fp);
}
