#include "otf.h"

int IHORN;
int id1,id2;


main(argc,argv)
int argc;
char *argv[];
{
 int i1,i2, i,ii,j,k,ih,idmp,ndmp,dumpmode;
 float *R1,*R2,*M,*CALSCAN;


 if (argc < 3) {
  fprintf(stderr,"\n otfdump  filename dumpmode \n");
  exit(1);
 }

 if ((otffp=fopen(argv[1],"r"))==NULL) {
  fprintf(stderr,"\n Can not open file %s\n", argv[1]);
  exit(1);
 }
 dumpmode=atoi(argv[2]);
 if (dumpmode < 1 || dumpmode > 2) {
  fprintf(stderr,"\n Dump Mode must be 1 or 2\n");
  exit(1);
 }
 if (dumpmode == 2 && argc < 4) {
  fprintf(stderr,"\n Specify which pixel to dump \n");
  exit(1);
 }
 if (dumpmode == 2) {
  IHORN=atoi(argv[3]);
  if (IHORN <1 || IHORN > 16) {
    fprintf(stderr,"\n PIXEL selection out of range \n");
    exit(2);
  }
  IHORN=IHORN-1;
 }

 CmdLineMASK=-1;
 ReadHEADER();
 PrintHEADER();


 if (dumpmode == 1) exit(0);

 if ( (R1 = (float *)malloc(sizeof(float)*H.nchan*H.nhorns))==NULL) {
   fprintf(stderr,"\n Can not allocate memory for REF 1  data array\n");
   exit(3);
 }
 if ( (R2 = (float *)malloc(sizeof(float)*H.nchan*H.nhorns))==NULL) {
   fprintf(stderr,"\n Can not allocate memory for REF 2  data array\n");
   exit(3);
 }
 if ( (M = (float *)malloc(sizeof(float)*H.nchan*H.nhorns))==NULL) {
   fprintf(stderr,"\n Can not allocate memory for MAIN data array\n");
   exit(3);
 }

 if (H.caltype) {
   if ( (CALSCAN = (float *)malloc(sizeof(float)*H.nchan*H.nhorns))==NULL) {
     fprintf(stderr,"\n Can not allocate memory for MAIN data array\n");
     exit(3);
   }
   GetCALSCAN(CALSCAN);
   fprintf(stdout,"\n CAL SCAN for Horn %2d\n\n",IHORN+1); 
   for(k=0; k<H.nchan; k++) {
    ii=Getindex(k,IHORN,H.nchan);
    if (fmod(k,16)==0.0) fprintf(stdout,"\n");
    fprintf(stdout," %6.3e",CALSCAN[ii]);
   }
   free(CALSCAN);
 }

   fprintf(stdout,"\n Reference 1 for Horn %2d\n\n",IHORN+1); 
   GetREFERENCE(1,R1);
   for(k=0; k<H.nchan; k++) {
    ii=Getindex(k,IHORN,H.nchan);
    if (fmod(k,16)==0.0) fprintf(stdout,"\n");
    fprintf(stdout," %6.3e",R1[ii]);
   }
   fprintf(stdout,"\n Reference 2 for Horn %2d\n\n",IHORN+1); 
   GetREFERENCE(2,R2);
   for(k=0; k<H.nchan; k++) {
    ii=Getindex(k,IHORN,H.nchan);
    if (fmod(k,16)==0.0) fprintf(stdout,"\n");
    fprintf(stdout," %6.3e",R2[ii]);
   }
 

/* Now start gathering ON data */
 i1=H.caltype+1;   i2=H.nsample-1;
 for(idmp=i1; idmp<i2; idmp++) {
  fprintf(stdout,"\n Main data %3d:   Horn %2d\n\n",idmp,IHORN+1);
  GetDUMP(idmp,M);
  for(k=0; k<H.nchan; k++) {
    ii=Getindex(k,IHORN,H.nchan);
    if (fmod(k,16)==0.0) fprintf(stdout,"\n");
    fprintf(stdout," %6.3e",M[ii]);
  }
 } 

/* Free memory */
  free(R1);
  free(R2);
  free(M);
  fclose(otffp);
}
