#include "otf.h"


main(argc,argv)
int argc;
char *argv[];
{
 char ch,title[32],*otffile,xotffile[MAXCHAR];
 char *rawpath;
 char *tmpstr,temppath[MAXPATHLEN],rawbasepath[MAXPATHLEN];
 int i1,i2,nmain,i,ii,j,k,idmp,ndmp;
 int IHORN;
 int stat;
 short int iw;
 long nmem,N;
 float TCAL;
 float *R1,*R2,*R,*M,*TA,*CALSCAN;

 if (argc < 3) {
  fprintf(stderr,"\n otfedit  filename WTmode(equal:biased) \n");
  exit(1);
 }

 if ((otffp=fopen(argv[1],"r"))==NULL) {
  fprintf(stderr,"\n Can not open file %s\n", argv[1]);
  exit(1);
 }
 otffile = rindex(argv[1],'/');
 otffile++;
 fprintf(stderr,"otffile=%s", otffile);
 ReadHEADER();

/* Open Extension header file if present */
 ReadXHeader(otffile);
 xotf.XH.modified=0;      /* flag to gauge whether 
                              extension headers are modified by program 
                               in ExamineScan  */  

 CmdLineMASK=-1;
 sscanf(argv[2],"%s",WTmode);

 if (H.caltype) {
   if ( (CALSCAN = (float *)malloc(sizeof(float)*H.nchan*H.nhorns))==NULL) {
     fprintf(stderr,"\n Can not allocate memory for REF 1  data array\n");
     exit(3);
   }
   GetCALSCAN(CALSCAN);
 }
 if ( (R1 = (float *)malloc(sizeof(float)*H.nchan*H.nhorns))==NULL) {
   fprintf(stderr,"\n Can not allocate memory for REF 1  data array\n");
   exit(3);
 }
 if ( (R2 = (float *)malloc(sizeof(float)*H.nchan*H.nhorns))==NULL) {
   fprintf(stderr,"\n Can not allocate memory for REF 2  data array\n");
   exit(3);
 }
 if ( (R = (float *)malloc(sizeof(float)*H.nchan*H.nhorns))==NULL) {
   fprintf(stderr,"\n Can not allocate memory for REF  data array\n");
   exit(3);
 }
 if ( (M = (float *)malloc(sizeof(float)*H.nchan*H.nhorns))==NULL) {
   fprintf(stderr,"\n Can not allocate memory for MAIN data array\n");
   exit(3);
 }
 if ( (TA = (float *)malloc(sizeof(float)*H.nsample*H.nchan))==NULL) {
   fprintf(stderr,"\n Can not allocate memory for MAIN data array\n");
   exit(3);
 }

 GetREFERENCE(1,R1);
 GetREFERENCE(2,R2);

/* Now start gathering ON data */
 id1=0; id2=0;    /* set graphics device IDs  */
 PrintHelp();
 IHORN=0;
 while(IHORN<H.nhorns) {
  for(idmp=0; idmp<H.nsample; idmp++) {   
     GetDUMP(idmp,M);
     WeightREF(WTmode,idmp,R1,R2,R);
     for(k=0; k<H.nchan; k++) {
        i=Getindex(k,idmp,H.nchan);
        ii=Getindex(k,IHORN,H.nchan);
        TCAL=H.tsys[IHORN];
        if (H.caltype) TCAL=CALSCAN[ii];

       TA[i]=NAN;
       if (fabs(M[ii]) && fabs(R[ii]) < 1.0e+30) {
         if (OTFPOS.XOFF[idmp] < 21600) {
           if (R[ii] != 0.0) TA[i]=TCAL*(M[ii]-R[ii])/(R[ii]);
         }
         else if (OTFPOS.XOFF[idmp] >23000 && OTFPOS.XOFF[idmp]<30000)  {
           if (idmp==H.nsample-1) {           /* 2nd ref */
              TA[i]=R2[ii];
           }   
           else {                            /* 1st ref */
              TA[i]=R1[ii];
           }
         }
         else {                              /* Cal scan */
              TA[i]=M[ii];
         } 
       }
     }  
  }

  stat=ExamineScan(&IHORN,TA);
  if (stat) break;
  IHORN++;
 }

 if (xotf.XH.modified) {
   xotf.XH.iscan=H.iscan;  
   WriteXHeader(otffile);
 }

/* Free memory */
  if (H.caltype) free(CALSCAN);
  free(R1);
  free(R2);
  free(R);
  free(M);
  free(TA);
}



void PrintHelp()
{
  fprintf(stdout,"\n ");
  fprintf(stdout,"\n ");
  fprintf(stdout,"\n      OTF EDIT Cursor Commands\n ");
  fprintf(stdout,"\n ");
  fprintf(stdout,"\n b -- Subtract baseline from the current horn's data");
  fprintf(stdout,"\n k -- Plot run of RMS values");
  fprintf(stdout,"\n l -- Plot a spectrum");
  fprintf(stdout,"\n m -- Mask a line/section");
  fprintf(stdout,"\n n -- Next Horn");
  fprintf(stdout,"\n r -- Reset Mask for Current Horn");
  fprintf(stdout,"\n s -- Show Current Parameters");
  fprintf(stdout,"\n u -- Unmask a line/section");
  fprintf(stdout,"\n w -- Set Window for baseline subtraction");
  fprintf(stdout,"\n R -- Reset Mask for ALL Horns");
  fprintf(stdout,"\n q -- to exit");
  fprintf(stdout,"\n ? -- to print this help menu");
  fprintf(stdout,"\n ");
  fprintf(stdout,"\n ");
}

void SetMask(IHORN,m1,m2)
int IHORN, m1,m2;
{
 int i1,i2,ih,idmp,itmp;
 long f,temp;

 f=pow(2.,IHORN);
 if (m1 > m2) {
   itmp=m2;
   m2=m1;
   m1=itmp;
 }
 
 i1=m1;
 if (i1 <= H.caltype+1) i1=H.caltype+2;
 i2=m2;
 if (i2 == H.nsample-1) i2=H.nsample-2;
 for(idmp=i1; idmp<=i2; idmp++) {
   temp=xotf.XH.MASK[idmp];
   xotf.XH.MASK[idmp]=temp&(~f);
 }
}
 
void UnSetMask(IHORN,m1,m2)
int IHORN,m1,m2;
{
 int i1,i2,idmp,itmp;
 long f,temp;

 f=pow(2.,IHORN);
 if (m1 > m2) {
   m2=itmp;
   m2=m1;
   m1=itmp;
 }
 i1=m1;  
 if (i1 <= H.caltype+1) i1=H.caltype+2;
 i2=m2;
 if (i2 == H.nsample-1) i2=H.nsample-2;
 for(idmp=i1; idmp<=i2; idmp++) {
   temp=xotf.XH.MASK[idmp];
   xotf.XH.MASK[idmp]=f|temp;
 }
}
