#include "otf.h"
#include "classio.h"


COM_DEF Com;
CARCOM_DEF Carcom;
IND_DEF Ind;
RSCAN_DEF Rscan; 
CRDATA_DEF Crdata;      /* data structure */
CRPAR_DEF Crpar;         /*header structure */
/*CROTF_DEF Crotf; */
SASSET_DEF Sasset; 
SASCET_DEF Sascet; 




main(argc,argv)
int argc;
char *argv[];
{
 char otffile[64],outfile[64];
 int i,ih,idmp,j,ix,iy,k;
 int NX;
 long ii,jj;
 float xmin,xmax,ymin,ymax;

/* initialize command line arguments */
 strcpy(outfile,"");
 strcpy(otffile,"");
 strcpy(calfile,"");
 strcpy(WTmode,"equal");
 kopt=1;
 THETA_N=0.0; 
 out_type=1;
 ORDER=0;
 NWIND=0;
 W1[0]=1; W2[0]=-1;
 rmsthreshold=1.0e+35;
 wind_type=0;
 flatfield=0;
 rmsweight=0;
 tsysweight=0;
 base=0;
 include_margin=0;
 CmdLineMASK=-1;
 ParseArguments(argc,argv,otffile,outfile);

 if ((infile = (char **) malloc (sizeof (char *))) == NULL) {
   fprintf(stderr,"\n infile text error: malloc");
   exit(3);
 } 


 ReadList(otffile);
 GetXYLimits(&xmin,&xmax,&ymin,&ymax);
 SetFITSHEADERS(xmin,xmax,ymin,ymax);
 ReGridData(outfile);
 
}

int GetXYLimits(xmin,xmax,ymin,ymax)
float *xmin,*xmax,*ymin,*ymax;
{
 int i,j,ih,idmp,k;
 float dx,dy,XP[4],YP[4];
 float *deriv;
 float expxmin,expxmax,expymin,expymax;
 double A;
 OTFHeader_t C;
 char temp[MAXPATHLEN];

 *xmin=1.0e+30;  *xmax=-1.0e+30;  *ymin=1.0e+30; *ymax=-1.0e+30;
 expxmin=1.0e+30;  expxmax=-1.0e+30;  expymin=1.0e+30; expymax=-1.0e+30;
 for(i=0; i<nfiles; i++) {
    fprintf(stderr,"\n %d %s", i+1,infile[i]);
    strcpy(temp,rawdir);
    strcat(temp,infile[i]);
   if ((otffp=fopen(temp,"r"))==NULL) {
     fprintf(stderr,"\n Can not open file %s\n", temp);
     exit(1);
   }
   ReadHEADER();
   ReadXHeader(infile[i]);
   if (i==0) {
     C.nchan=H.nchan;
     C.xvel1=H.xvel1;
     C.dveldin=H.dveldin;
     C.XCEN=H.XCEN;
     C.YCEN=H.YCEN;
   }
   else {
      if (!strcmp(H.name,C.name)) {
        fprintf(stderr,"\n WARNING: source names are not consistent\n"); 
      } 
      if (H.nchan != C.nchan) {
        fprintf(stderr,"\n ERROR: Inconsistent number of backend channels\n");
        exit(2);
      }
      if (fabs(H.xvel1-C.xvel1) > 0.2*fabs(H.dveldin)) {
        fprintf(stderr,"\n ERROR: the spectroscopic axes are not aligned\n");
        exit(2);
      }
      if (fabs(H.dveldin-C.dveldin) > 0.01) {
        fprintf(stderr,"\n ERROR: the spectroscopic axes are not sampled the same\n");
        exit(2);
      }
      if (H.XCEN != C.XCEN) {
        fprintf(stderr,"\n ERROR: the central coordinates are not consistent\n");
        exit(2);
      }
      if (H.YCEN != C.YCEN) {
        fprintf(stderr,"\n ERROR: the central coordinates are not consistent\n");
        exit(2);
      }
   }

/* Find endpoints in coordinate system */
   if (!include_margin) {
     A=H.rotang*DEG2RAD;
     dx=H.XSIZE*0.5+H.XOFFMAP;
     dy=H.YSIZE*0.5+H.YOFFMAP;
     XP[0]=dx*cos(A)+dy*sin(A);
     YP[0]=dy*cos(A)-dx*sin(A);

     dx=H.XSIZE*0.5+H.XOFFMAP;
     dy=-H.YSIZE*0.5+H.YOFFMAP;
     XP[1]=dx*cos(A)+dy*sin(A);
     YP[1]=dy*cos(A)-dx*sin(A);

     dx=-H.XSIZE*0.5+H.XOFFMAP;
     dy=H.YSIZE*0.5+H.YOFFMAP;
     XP[2]=dx*cos(A)+dy*sin(A);
     YP[2]=dy*cos(A)-dx*sin(A);

     dx=-H.XSIZE*0.5+H.XOFFMAP;
     dy=-H.YSIZE*0.5+H.YOFFMAP;
     XP[3]=dx*cos(A)+dy*sin(A);
     YP[3]=dy*cos(A)-dx*sin(A);
     for(j=0; j<4; j++) {
       if (XP[j] < expxmin) expxmin=XP[j];
       if (XP[j] > expxmax) expxmax=XP[j];
       if (YP[j] < expymin) expymin=YP[j];
       if (YP[j] > expymax) expymax=YP[j];
     }
   }
   else { 
/* Find extreme positions of all pixels over all dumps */
/*  But first, filter out bad dump positions */

   if ( (deriv = (float *) malloc(sizeof(float)*H.nsample))==NULL) {
#ifdef GUI
     strcpy(logtext_string,"\n Can not allocate memory for array deriv\n");
     append_log(2,1,1,otfgui->logtext,logtext_string);
     return(-1);
#else
     fprintf(stderr,"\n Can not allocate memory for array\n");
     exit(3);
#endif
   }
   if (H.kmap == 2 || H.kmap == 6) {
    deriv[H.caltype+1]=OTFPOS.YOFF[H.caltype+2]-OTFPOS.YOFF[H.caltype+1];
    deriv[H.nsample-2]=OTFPOS.YOFF[H.nsample-2]-OTFPOS.YOFF[H.nsample-3];
    for(idmp=2; idmp<=H.nsample-3; idmp++) deriv[H.caltype+idmp]=0.5*(OTFPOS.YOFF[H.caltype+idmp+1]-OTFPOS.YOFF[H.caltype+idmp-1]);
   }
   else {
    deriv[H.caltype+1]=OTFPOS.XOFF[H.caltype+2]-OTFPOS.XOFF[H.caltype+1];
    deriv[H.nsample-2]=OTFPOS.XOFF[H.nsample-2]-OTFPOS.XOFF[H.nsample-3];
    for(idmp=2; idmp<=H.nsample-3; idmp++) deriv[H.caltype+idmp]=0.5*(OTFPOS.XOFF[H.caltype+idmp+1]-OTFPOS.XOFF[H.caltype+idmp-1]);
   }

    for(idmp=H.caltype+1; idmp<=H.nsample-2; idmp++) {
       if (fabs(deriv[idmp]) > 3.0) {               /* this threshold is temporary  */
#ifdef GUI
         sprintf(logtext_string,"\n Excluding data from dump %4d at position (%7.2f,%7.2f) ", idmp,OTFPOS.XOFF[idmp],OTFPOS.YOFF[idmp]);
         append_log(2,1,1,otfgui->logtext,logtext_string);
#else
          fprintf(stderr,"\n Excluding data from dump %4d at position (%7.2f,%7.2f) ", idmp,OTFPOS.XOFF[idmp],OTFPOS.YOFF[idmp]);
#endif
          OTFPOS.XOFF[idmp]=25000;
       }
    }
    free(deriv);

    for(idmp=0; idmp<H.nsample; idmp++) {
     if (OTFPOS.XOFF[idmp] <21600) {
       for(ih=0; ih<H.nhorns; ih++) {
         if (CheckMASK(idmp,ih)) {
           if (XPOS[ih][idmp] < expxmin) expxmin=XPOS[ih][idmp];
           if (XPOS[ih][idmp] > expxmax) expxmax=XPOS[ih][idmp];
           if (YPOS[ih][idmp] < expymin) expymin=YPOS[ih][idmp];
           if (YPOS[ih][idmp] > expymax) expymax=YPOS[ih][idmp];
         }
       }
     }
    }
   }
   fclose(otffp);
 }
 *xmin=expxmin;
 *xmax=expxmax;
 *ymin=expymin;
 *ymax=expymax;
}
