/* Gopal Narayanan
 * Sept. 28, 2001
 */

#ifndef __OTFTOOL_H_
#define __OTFTOOL_H_

#include "otf.h"

/*
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/stat.h>
#include <errno.h>
#include <time.h>
#include <sys/types.h>
#include <sys/dir.h>
#include <sys/param.h>
*/

#include <pthread.h>
#include <gtk/gtk.h>
#include <gdk/gdkkeysyms.h>


#ifndef DATADIR
#define DATADIR "/usr/local/share/otftool"
#endif

#ifndef RAWPATH
#define RAWPATH "/raw"
#endif

#ifndef RESTOREPATH
#define RESTOREPATH "/home/restore"
#endif

#define WT_EQUAL 0
#define WT_BIASED 1
#define LOG_TERSE 0
#define LOG_VERBOSE 1

#define DATASEL 0
#define DATAEDIT 1
#define DATAGRID 2

#define BASESELECT 0
#define BASEALL 1

typedef struct _BaseLineWidget {
  GtkWidget *checkbtn;
  GtkWidget *order;
  GtkWidget *nwindow;
  GtkWidget *window;
} BaseLineWidget;


typedef struct _otf_gui {
  GtkWidget *mainwindow;
  GtkWidget *menu;
  GtkWidget *vertbox;
  GtkWidget *notebook;
  GtkWidget *vbox[3];
  GtkWidget *page[3];
  GtkWidget *entry[5];
  GtkWidget *clist;
  GtkWidget *hornmasklabel[2];
  GtkWidget *maskbtn[MAXHORNS];
  GtkWidget *statuswin;
  GtkWidget *progressbar[2];
  GtkWidget *progresslabel[4];
  GtkWidget *logwin;
  GtkWidget *logtext;
  GtkWidget *basewin;
  GtkWidget *noisewin;
  GtkWidget *otfedithelp;
  GtkWidget *otfedithelpwin;
  GtkWidget *otfeditstatus;
  GtkWidget *otfeditorder;
  GtkWidget *otfeditnwindow;
  GtkWidget *otfeditwindow;
  GtkWidget *filter_entry[10];
  GtkWidget *clistfilt[2];
  GtkWidget *abortdialog;
  GtkWidget *restorebtn;
} otf_gui;

struct FILTER {
  char sname[12];
  short startscan;
  short endscan;
  short lo;
  float f0;
  float deltaf;
  float bw;
} filter;


otf_gui *otfgui;
BaseLineWidget *baselinewgt;

extern gint delete_event (GtkWidget *, GdkEvent *, gpointer);
extern void destroy (GtkWidget *, gpointer);
extern void otftool_setup_body (otf_gui *);
void weightCB (int);
void setWeightMode (int);
int getWeightMode ();
/*void weightToggleCB(GtkWidget *, gpointer);*/
void ifCB (gpointer);
void setIFnum (int);
int getIFnum ();
void ifToggleCB(GtkWidget *, gpointer);
int setkopt (char *);
char *getkopt (int );
void koptToggleCB(GtkWidget *, gpointer);
void outtypeCB (gpointer);
void setouttype (int);
int getouttype ();
void outtypeToggleCB(GtkWidget *, gpointer);
void file_ok_sel_inp(GtkWidget *, GtkFileSelection *);
void file_sel_inp ();
void file_ok_sel_out(GtkWidget *, GtkFileSelection *);
void file_sel_out ();
void otftool_regrid (GtkWidget *, gpointer);
void append_log (short, short, short, GtkWidget *, const char *, ...);

int weight_mode,IF,out_type;
short horn_is_active[MAXHORNS];
char *otffile,*outfile;
short statusint, logint, log_mode;
char *logtext_string;
short otftool_order;
short otftool_nwindow;
float progress_val;
short assess_mode;
short noise_weight;
short otfedit_exit;
short lo_sel, bw_sel;
int main_window_width, main_window_height;
char *sname, *linename_sav;
short notebookmode;
short baselinemode, last_active_horn;
char observer[10];

static gint idle_flag = 0;
/* file name filter for file dialog */
static gchar *file_filter_text = "*.lis";
static GtkWidget *file_filter_entry = NULL;
static gchar *log_file = "otftool.log";


struct tm start_tm, end_tm;
char pathname[MAXPATHLEN];
char rawbasepath[MAXPATHLEN];
short stop_regrid;

#endif

