#include "otftool.h"
#include "classio.h"
extern void update_plabel (int, char*);
extern void update_progressbar(int, float);
extern GtkWidget* start_progressbar (int);
extern int ReadXHeader (char *);
extern int CheckMASK (int, int);
extern float cputime (void);
extern float realtime (void);

#include "fcraologo.xpm"

void
dialog_ok (GtkWidget *widget,
	   GtkWidget *window)
{
  gtk_widget_destroy(GTK_WIDGET (window));
}

void
dialog_exit_ok (GtkWidget *widget,
	   GtkWidget *window)
{
  gtk_main_quit();
}

void
error_mes (gchar *dtype, gchar *text)
{
  GtkWidget *dialog_window;
  GtkWidget *button, *label;
  GdkPixmap *icon = NULL;
  GdkBitmap *mask = NULL;
  GtkWidget *pixmap;
  GtkWidget *hbox;
  GtkStyle *style;

  dialog_window = gtk_dialog_new ();
  gtk_signal_connect (GTK_OBJECT (dialog_window), "destroy",
		      GTK_SIGNAL_FUNC(gtk_widget_destroyed),
		      &dialog_window);
  gtk_widget_set_name (GTK_WIDGET (dialog_window), "aux window");
  gtk_window_position (GTK_WINDOW (dialog_window), GTK_WIN_POS_MOUSE);
  gtk_window_set_title (GTK_WINDOW (dialog_window), dtype);
  gtk_container_set_border_width (GTK_CONTAINER (dialog_window), 15);
  /*gtk_widget_set_usize (dialog_window, 300, 150);*/

  hbox = gtk_hbox_new (FALSE, 5);
  gtk_box_pack_start (GTK_BOX (GTK_DIALOG (dialog_window)->vbox), hbox, FALSE, FALSE, 0);
  gtk_widget_show (hbox);
  gtk_widget_realize(dialog_window); /* this is for the pixmap below not to produce warning */

  if (!strcmp(dtype,"About")) {

    style = gtk_widget_get_style(dialog_window );
    if (icon == NULL) {
      icon = gdk_pixmap_create_from_xpm_d (GTK_WIDGET (dialog_window)->window, &mask,
					   &style->bg[GTK_STATE_NORMAL], (gchar **)fcraologo);
      if (icon) {
	pixmap = gtk_pixmap_new ( icon, mask );
	gtk_misc_set_alignment (GTK_MISC (pixmap), 0.0, 0.5);
	gtk_box_pack_start (GTK_BOX (hbox), pixmap,
			    TRUE, TRUE, 0);
	gtk_widget_show ( pixmap );
      }
    }
  }

  label = gtk_label_new (text);
  gtk_box_pack_start (GTK_BOX (hbox), label, TRUE, TRUE, 0);
  gtk_widget_show (label);
  
  button = gtk_button_new_with_label ("OK");
  GTK_WIDGET_SET_FLAGS (button, GTK_CAN_DEFAULT);
  gtk_box_pack_start (GTK_BOX (GTK_DIALOG (dialog_window)->action_area), 
		      button, TRUE, TRUE, 0);
  gtk_widget_grab_default (button);
  gtk_widget_show (button);
  

  gtk_signal_connect (GTK_OBJECT (button), "clicked",
		      GTK_SIGNAL_FUNC (dialog_ok),
		      dialog_window);
  gtk_widget_show(dialog_window);

}

/*
void
getmask()
{
  int i;
  int HornMASK;

  CmdLineMASK = 0;
  for (i = 0; i< 16; i++) {
    if(GTK_TOGGLE_BUTTON(otfgui->maskbtn[i])->active) {
      HornMASK = 1<<i;
      CmdLineMASK = CmdLineMASK|HornMASK;
    }
  }
  printf("%b\n",CmdLineMASK);
}

*/

void
abort_regrid (GtkWidget *widget, gpointer data) 
{
  stop_regrid = 1;
  gtk_widget_set_sensitive (GTK_WIDGET (widget), FALSE);
}

void
regrid_abort_dialog () 
{
  GtkWidget *button;
  GtkWidget *vbox;

  otfgui->abortdialog = gtk_window_new (GTK_WINDOW_DIALOG);
  gtk_widget_set_name (GTK_WIDGET (otfgui->abortdialog), "aux window");
  gtk_window_set_modal (GTK_WINDOW (otfgui->abortdialog), TRUE);
  gtk_container_set_border_width (GTK_CONTAINER (otfgui->abortdialog), 10);
  gtk_window_position (GTK_WINDOW (otfgui->abortdialog), GTK_WIN_POS_CENTER);
  gtk_widget_set_usize (otfgui->abortdialog, 200, 100);
  gtk_window_set_title (GTK_WINDOW (otfgui->abortdialog), "Abort Regrid");

  vbox = gtk_vbox_new (TRUE, 5);
  gtk_container_add (GTK_CONTAINER (otfgui->abortdialog), vbox);
  
  button = gtk_button_new_with_label ("Abort Regrid");
  gtk_box_pack_start (GTK_BOX (vbox), button, TRUE, TRUE, 2);
  gtk_signal_connect (GTK_OBJECT (button), "clicked",
                      GTK_SIGNAL_FUNC (abort_regrid), NULL);
  gtk_widget_show (button);
  gtk_widget_show (vbox);
  gtk_widget_show (otfgui->abortdialog);
}


void 
otftool_regrid (GtkWidget *widget, gpointer data)
{
  float xmin,xmax,ymin,ymax;  
  struct stat statbuf;
  char *errmsg;
  GtkWidget *statuscontainer;
  short returnint;
  char tmpfile[100];

  if ((errmsg = (char *) malloc(50*sizeof(char))) == NULL) {
    perror("errmsg text error: malloc");
    exit(3);
  }


  if (sscanf (gtk_entry_get_text(GTK_ENTRY (otfgui->entry[0])), 
	      "%g", &THETA_N) != 1) {
    error_mes("Error!","Invalid Entry for Cell Size");
    return;
  } else {
    if (THETA_N <= 0) {
      error_mes("Error!","Cell Size should be greater than 0");
      return;
    }
    append_log (0,1,1,otfgui->logtext, "Using Cell Size of %g for Regrid\n", THETA_N);
  }
  if (sscanf (gtk_entry_get_text(GTK_ENTRY (otfgui->entry[1])), 
	      "%s", &tmpfile[0]) != 1) {
    error_mes("Error!","Invalid Entry for Input List file");
    return;
  } else {
    if ((otffile = realloc (otffile, ((strlen(tmpfile)+1)*sizeof(char)))) == NULL) {
        append_log(2,1,1,otfgui->logtext, "Reallocation memory error for otffile\n");
        return;
    }
    strcpy (otffile, tmpfile);
    if ((stat(otffile,&statbuf)) == -1) {
      strcpy(errmsg,"Input List file:");
      strcat(errmsg,strerror(errno));
      error_mes("Error!", errmsg);
      return;
    }
    append_log (0,1,1,otfgui->logtext, "Using input list file %s for Regrid\n",
		otffile);
  }
    
  if (sscanf (gtk_entry_get_text(GTK_ENTRY (otfgui->entry[2])), 
	      "%s", &tmpfile[0]) != 1) {
    error_mes("Error!","Invalid Entry for Output file");
    return;
  } else {
    if ((outfile = realloc (outfile, ((strlen(tmpfile)+1)*sizeof(char)))) == NULL) {
        append_log(2,1,1,otfgui->logtext, "Reallocation memory error for outfile\n");
        return;
    }
    strcpy (outfile, tmpfile);
    append_log (0,1,1,otfgui->logtext, "Will write to output file %s for Regrid\n",
		outfile);    
  }  

  if (sscanf (gtk_entry_get_text(GTK_ENTRY (otfgui->entry[3])), 
	      "%s", &linename[0]) == 1) {
    if (strlen(linename) > 12) {
      error_mes("Error!","Linename can only be 12 characters long");
      return;
    }
    append_log (0,1,1,otfgui->logtext, "Will use linename %s for Regrid\n",
		linename);    
  }

  if (sscanf (gtk_entry_get_text(GTK_ENTRY (otfgui->entry[4])), 
	      "%g", &rmsthreshold) != 1) {
    error_mes ("Error!", "Invalid Entry for rms threshold value");
  } else {
    if (rmsthreshold <= 0) {
      error_mes("Error!","RMS Threshold value should be greater than 0");
      return;
    }
    append_log (0,1,1,otfgui->logtext, "Using rms threshold of %g for Regrid\n",
		rmsthreshold);
  }



  /*  getmask();*/
  /*  gtk_widget_set_sensitive (GTK_WIDGET (otfgui->notebook), FALSE);*/

  gtk_widget_set_sensitive (GTK_WIDGET (widget), FALSE);

  regrid_abort_dialog ();

  /*  gtk_signal_disconnect (GTK_OBJECT (widget), regrid_sighandle);

  gtk_label_set_text (GTK_LABEL (GTK_BIN (widget)->child), "Abort Regridding");
  regrid_sighandle = gtk_signal_connect ( GTK_OBJECT (widget), "clicked",
  GTK_SIGNAL_FUNC (abort_regrid), NULL); */
  
  statuscontainer = GTK_WIDGET (start_progressbar(2));
  
  printf("\n%s\n", otffile);
  if (ReadList(otffile) == -1) {
    gtk_widget_set_sensitive (GTK_WIDGET (widget), TRUE);
    gtk_widget_destroy (statuscontainer);
    gtk_widget_destroy (otfgui->abortdialog);
    return;
  }
  if (GetXYLimits(&xmin,&xmax,&ymin,&ymax) == -1) {
    gtk_widget_set_sensitive (GTK_WIDGET (widget), TRUE);
    gtk_widget_destroy (statuscontainer);
    gtk_widget_destroy (otfgui->abortdialog);
    return;
  }
  if (SetFITSHEADERS(xmin,xmax,ymin,ymax) == -1) {
    gtk_widget_set_sensitive (GTK_WIDGET (widget), TRUE);
    gtk_widget_destroy (statuscontainer);
    gtk_widget_destroy (otfgui->abortdialog);
    return;
  }    
  update_plabel (0, "");
  update_plabel (1,"");
  update_progressbar (0,0.0);
  times(&StartTime); time (&STime);
  returnint = ReGridData(outfile);
  times(&EndTime); time (&ETime);
  append_log (0,1,1,otfgui->logtext, "Regridding consumed %g CPU seconds (%g CPU minutes) \n",
	      cputime(), cputime()/60.0);
  append_log (0,1,1,otfgui->logtext, "Regridding consumed %g real seconds (%g real minutes) \n",
	      realtime(), realtime()/60.0);
  switch (returnint) {
  case -5:
    append_log (0,1,1,otfgui->logtext,"User aborted Regridding\n");
    break;
  case 0:
    append_log(0,1,1,otfgui->logtext,"Regridding done");
    error_mes("Done!","Regridding done");
    break;
  default:
    append_log (0,1,1,otfgui->logtext,"Error in Regridding\n");
    break;    
  }

  gtk_widget_set_sensitive (GTK_WIDGET (widget), TRUE);
  gtk_widget_destroy (statuscontainer);
  gtk_widget_destroy (otfgui->abortdialog);
  stop_regrid = 0;
  free(errmsg);
  return;

}

int 
GetXYLimits(xmin,xmax,ymin,ymax)
float *xmin,*xmax,*ymin,*ymax;
{
 int i,j,ih,idmp;
 float dx,dy,XP[4],YP[4];
 float expxmin,expxmax,expymin,expymax;
 float *deriv;
 double A;
 OTFHeader_t C;
 char temp[MAXPATHLEN];

 expxmin=1.0e+30;  expxmax=-1.0e+30;  expymin=1.0e+30; expymax=-1.0e+30;
 *xmin=1.0e+30;  *xmax=-1.0e+30;  *ymin=1.0e+30; *ymax=-1.0e+30;

#ifdef GUI
 update_plabel(0,"Finding XY Limits");
 /* gtk_label_set_text (GTK_LABEL (otfgui->progresslabel[0]), "Finding XY Limits");
    gui_catchup();*/
#endif

 for(i=0; i<nfiles; i++) {
#ifdef GUI
   if (log_mode == LOG_VERBOSE) {
     sprintf(logtext_string, "\n%d) %s\n", i+1,infile[i]);
     append_log(0,1,1,otfgui->logtext,logtext_string);
   }
#else
    fprintf(stderr,"\n %d %s\n", i+1,infile[i]);
#endif
    /*    strcpy(temp,rawdir);
	  strcat(temp,infile[i]); */
    strcpy (temp, infile[i]);
    if ((otffp=fopen(temp,"r"))==NULL) {
#ifdef GUI      
      sprintf(logtext_string,"Cannot open OTF File: %s : ",temp);
      strcat(logtext_string, strerror(errno));
      append_log(2,1,1,otfgui->logtext,"%s\n",logtext_string);
      /*      append_log(0,1,1,"\n");*/
      return -1;
#else
      fprintf(stderr,"\n Cannot open file %s\n", infile[i]);
      return -1;
      /*      exit(1);*/
#endif      
    }

    /*    update_progress (1,"Finding XY Limits",(float) (i/nfiles), infile[i]);*/
#ifdef GUI
    update_progressbar(0, ((float) i/(float) nfiles)*100.0);
    /*    gtk_progress_set_value (GTK_PROGRESS (otfgui->progressbar[0]), (int) (i/nfiles)*100);    
	  gui_catchup();*/
    update_plabel (1, infile[i]);
    /*
    gtk_label_set_text (GTK_LABEL (otfgui->progresslabel[1]), infile[i]);
    gui_catchup();    */
#endif

    ReadHEADER();
    ReadXHeader(infile[i]);
   if (i==0) {
     strcpy(C.name,H.name);
     C.nchan=H.nchan;
     C.xvel1=H.xvel1;
     C.dveldin=H.dveldin;
     C.XCEN=H.XCEN;
     C.YCEN=H.YCEN;
   }
   else {
      if (strcmp(H.name,C.name)) {
#ifdef GUI
	append_log(0,1,1,otfgui->logtext,"WARNING: source names are not consistent in ");
	sprintf(logtext_string,"file %s \n", infile[i]);
 	append_log(0,1,1,otfgui->logtext,logtext_string);
#else
	fprintf(stderr,"\n WARNING: source names are not consistent\n"); 
#endif
      } 
/*   MH commented out for comet observing
      if (fabs(H.xvel1-C.xvel1) > 0.2*fabs(H.dveldin)) {
#ifdef GUI
	append_log(0,1,1,otfgui->logtext,"ERROR: the spectroscopic axes are not aligned\n");
	return -1;
#else
        fprintf(stderr,"\n ERROR: the spectroscopic axes are not aligned\n");
	return -1;
#endif	
      }
      if (fabs(H.dveldin-C.dveldin) > 0.01) {
#ifdef GUI
	append_log(0,1,1,otfgui->logtext,"ERROR: the spectroscopic axes are not sampled the same\n");
	return -1;
#else
        fprintf(stderr,"\n ERROR: the spectroscopic axes are not sampled the same\n");
	return -1;
#endif
      }

	if (fabs(H.XCEN-C.XCEN) > 1.e-5) {
#ifdef GUI
	append_log(0,1,1,otfgui->logtext,"ERROR: the central coordindates are not consistent\n");
	return -1;
#else
        fprintf(stderr,"\n ERROR: the central coordindates are not consistent\n");
	return -1;
#endif
      }
	if (fabs(H.YCEN-C.YCEN) > 1.e-5) {
#ifdef GUI
	append_log(0,1,1,otfgui->logtext,"ERROR: the central coordindates are not consistent\n");
	return -1;
#else
        fprintf(stderr,"\n ERROR: the central coordindates are not consistent\n");
	return -1;
#endif
      }
*/
   }

/* Find endpoints in coordinate system */
   if (!include_margin) {
     A=H.rotang*DEG2RAD;
     dx=H.XSIZE*0.5+H.XOFFMAP;
     dy=H.YSIZE*0.5+H.YOFFMAP;
     XP[0]=dx*cos(A)+dy*sin(A);
     YP[0]=dy*cos(A)-dx*sin(A);

     dx=H.XSIZE*0.5+H.XOFFMAP;
     dy=-H.YSIZE*0.5+H.YOFFMAP;
     XP[1]=dx*cos(A)+dy*sin(A);
     YP[1]=dy*cos(A)-dx*sin(A);

     dx=-H.XSIZE*0.5+H.XOFFMAP;
     dy=H.YSIZE*0.5+H.YOFFMAP;
     XP[2]=dx*cos(A)+dy*sin(A);
     YP[2]=dy*cos(A)-dx*sin(A);

     dx=-H.XSIZE*0.5+H.XOFFMAP;
     dy=-H.YSIZE*0.5+H.YOFFMAP;
     XP[3]=dx*cos(A)+dy*sin(A);
     YP[3]=dy*cos(A)-dx*sin(A);
     for(j=0; j<4; j++) {
       if (XP[j] < expxmin) expxmin=XP[j];
       if (XP[j] > expxmax) expxmax=XP[j];
       if (YP[j] < expymin) expymin=YP[j];
       if (YP[j] > expymax) expymax=YP[j];
     }
   }
   else { 

/* Find extreme positions of all pixels over all dumps */
/*  But first, filter out bad dump positions */

   if ( (deriv = (float *) malloc(sizeof(float)*H.nsample))==NULL) {
#ifdef GUI
     strcpy(logtext_string,"\n Can not allocate memory for array deriv\n");
     append_log(2,1,1,otfgui->logtext,logtext_string);
     return(-1);
#else
     fprintf(stderr,"\n Can not allocate memory for array\n");
     exit(3);
#endif
   }
   if (H.kmap == 2 || H.kmap == 6) {
    deriv[H.caltype+1]=OTFPOS.YOFF[H.caltype+2]-OTFPOS.YOFF[H.caltype+1];
    deriv[H.nsample-2]=OTFPOS.YOFF[H.nsample-2]-OTFPOS.YOFF[H.nsample-3];
    for(idmp=2; idmp<=H.nsample-3; idmp++) deriv[H.caltype+idmp]=0.5*(OTFPOS.YOFF[H.caltype+idmp+1]-OTFPOS.YOFF[H.caltype+idmp-1]);
   }
   else {
    deriv[H.caltype+1]=OTFPOS.XOFF[H.caltype+2]-OTFPOS.XOFF[H.caltype+1];
    deriv[H.nsample-2]=OTFPOS.XOFF[H.nsample-2]-OTFPOS.XOFF[H.nsample-3];
    for(idmp=2; idmp<=H.nsample-3; idmp++) deriv[H.caltype+idmp]=0.5*(OTFPOS.XOFF[H.caltype+idmp+1]-OTFPOS.XOFF[H.caltype+idmp-1]);
   }

    for(idmp=H.caltype+1; idmp<=H.nsample-2; idmp++) {
       if (fabs(deriv[idmp]) > 3.0) {               /* this threshold is temporary  */
#ifdef GUI
         sprintf(logtext_string,"\n Excluding data from dump %4d at position (%7.2f,%7.2f) ", idmp,OTFPOS.XOFF[idmp],OTFPOS.YOFF[idmp]);
         append_log(2,1,1,otfgui->logtext,logtext_string);
#else
          fprintf(stderr,"\n Excluding data from dump %4d at position (%7.2f,%7.2f) ", idmp,OTFPOS.XOFF[idmp],OTFPOS.YOFF[idmp]);
#endif
          OTFPOS.XOFF[idmp]=25000;
       }
    }
    free(deriv);


    for(idmp=0; idmp<H.nsample; idmp++) {
     if (OTFPOS.XOFF[idmp] <21600) {
       for(ih=0; ih<H.nhorns; ih++) {
         if (CheckMASK(idmp,ih)) {
           if (XPOS[ih][idmp] < expxmin) expxmin=XPOS[ih][idmp];
           if (XPOS[ih][idmp] > expxmax) expxmax=XPOS[ih][idmp];
           if (YPOS[ih][idmp] < expymin) expymin=YPOS[ih][idmp];
           if (YPOS[ih][idmp] > expymax) expymax=YPOS[ih][idmp];
         }
       }
     }
    }
   }
   fclose(otffp);
 }
 *xmin=expxmin;
 *xmax=expxmax;
 *ymin=expymin;
 *ymax=expymax;
 return 0;
}

  
