#include "otftool.h"

#ifdef MYSQLDB
#include "global.h"
#include <my_sys.h>
#include <m_string.h>
#include <mysql.h>
#include <mysql_version.h>
#include <mysqld_error.h>
static my_string host=0;
/*static opt_password=0,user=0;*/
static uint opt_mysql_port=0;
/*static my_bool opt_show_keys=0,opt_compress=0,opt_status=0;*/
/*static uint opt_verbose=0;*/
static my_string opt_mysql_unix_port=0;
#endif

/*#include <sys/types.h>*/
/*#include <sys/dir.h>*/
/*#include <sys/param.h>*/
extern  int alphasort();

extern void entry_changed (GtkWidget *, gpointer);
extern void filesel_inp (void);
/*extern void header_activate (gchar *);*/
extern void plotpos_x11_activate (gint );
extern struct tm *caldate (double );
extern void update_plabel (int, char*);
extern void update_progressbar(int, float);
extern GtkWidget *start_progressbar (int);
extern GtkWidget *make_menu_item (GtkWidget *, gchar *);
extern void error_mes (gchar *, gchar *);
extern int plotpos (int, int, char **, int);
char *mystrcat (char *, const char *, ...);
extern void GtkPrintHEADER (char *);

GtkWidget *calw;
int start_mark, end_mark;
GtkWidget *dialog;
int savemode;
char **otflist;

#define SAVE_OVERWRITE 0
#define SAVE_APPEND 1
#define SAVE_CANCEL 2
#define DAYSTART 0
#define DAYEND 1

double
utdate (struct tm t1, short daytype)
{
  int month[12] = {31,28,31,30,31,30,31,31,30,31,30,31};
  int year;
  double utdt;
  div_t divt;
  int i;
  float days_in_year;

  year = TM_YEAR_BASE + t1.tm_year;
  divt = div(year, 4);
  if (divt.rem == 0) {
    month[1] = 29;
    days_in_year = 366.;
  } else {
    days_in_year = 365.;
  }
  utdt = 0.0;
  for (i = 0; i<t1.tm_mon; i++)
    utdt = utdt + (double) month[i];
  if (daytype == DAYSTART) {
    utdt = (utdt + t1.tm_mday - 1)/ days_in_year;
  } else {
    utdt = (utdt + t1.tm_mday)/ days_in_year;
  }
  utdt = (double) year + utdt;
  return utdt;
}
  
  
void
setLO (int mode) 
{
  lo_sel = mode;
  strcpy(pathname,rawbasepath);
  switch (lo_sel) {
  case 0:
  case 1:
    strcat(pathname,"/dcc");
    break;
  case 2:
    strcat(pathname,"/qef");
    break;    
  }
}

void
setBW (int mode) 
{
  bw_sel = mode;
}

short
getLO ()
{
  return lo_sel;
}

float
getBW ()
{
  float b=0.0;

  switch (bw_sel) {
  case 0: 
    b = 0.0;
    break;
  case 1:
    b = 50.0;
    break;
  case 2:
    b = 25.0;
    break;
  }
  return b;
}

char
*get_lo_string ()
{
  static char txt[10];
  switch (lo_sel) {
  case 0:
    strcpy(txt,"1");
    break;
  case 1:
    strcpy(txt,"2");
    break;    
  case 2:
    strcpy(txt,"QEF");
    break;    
  }
  return &txt[0];
}

char
*get_bw_string ()
{
  static char txt[10];
  switch (bw_sel) {
  case 0:
    strcpy(txt,"Any");
    break;
  case 1:
    strcpy(txt,"50 MHz");
    break;    
  case 2:
    strcpy(txt,"25 MHz");
    break;    
  }
  return &txt[0];
}

char
*get_lo_char3 ()
{
  static char txt[4];
  switch (lo_sel) {
  case 0:
    strcpy(txt,"loa");
    break;
  case 1:
    strcpy(txt,"lob");
    break;    
  case 2:
    strcpy(txt,"qef");
    break;    
  }
  return &txt[0];
}

void 
observer_init_set (void) 
{
#ifdef MYSQLDB
  MYSQL mysql;
  /*  MYSQL_RES *result;
      MYSQL_FIELD *field;*/
  MYSQL_ROW row;
  char query[200];
  /*  double tmput;*/
  GList *glist = NULL;

  /* initialize MYSQL object */
  mysql_init (&mysql);
  /* Use compressed client-server protocol */
  mysql_options(&mysql,MYSQL_OPT_COMPRESS,NullS);
  /* the actual connection */
  if (!(mysql_real_connect(&mysql,host,"observer","password",
                           "otfdb",opt_mysql_port,opt_mysql_unix_port,
                           0)))
    {
      append_log(0,1,1,otfgui->logtext,"MYSQL Error:  %s\n", mysql_error(&mysql));
      return;
    }
  strcpy (query, "select distinct observer from ");
  mystrcat (query, "%s;",get_lo_char3());
  if (!mysql_query (&mysql, query)) {
    MYSQL_RES *result;
    if ((result = mysql_store_result (&mysql))) {
      if (((ulong) mysql_num_rows (result))!= 0) {
	while ((row = mysql_fetch_row (result))) {
	  if (!strcmp(row[0],"-1")) {
	    glist = g_list_append (glist, "None");
	  } else {
	    glist = g_list_append (glist, row[0]);
	  }
	}
      } else {
	append_log (2,1,1, otfgui->logtext, 
		    "No result returned from number of distinct observer rows query\n");
	mysql_close(&mysql);
	return;
      }
    }
    mysql_free_result (result);
  } else {
    append_log(2,1,1, otfgui->logtext, "Select query error: %s\n",
	       mysql_error(&mysql));
    mysql_close(&mysql);
    return;
  }
  mysql_close(&mysql); 
  gtk_combo_set_popdown_strings (GTK_COMBO (otfgui->filter_entry[9]), glist);
  g_list_free(glist);
#endif
}

void
loCB (int Clientdata)
{
  setLO ((int) Clientdata);
  switch(lo_sel) {
  case 0:
    if ((GTK_IS_WIDGET (otfgui->filter_entry[8])) && 
	(otfgui->filter_entry[8] !=NULL)) 
      gtk_widget_set_sensitive (otfgui->filter_entry[8], TRUE);
    append_log(0,1,1,otfgui->logtext,"LO 1 chosen\n");
    break;
  case 1:
    if ((GTK_IS_WIDGET (otfgui->filter_entry[8])) && 
	(otfgui->filter_entry[8] !=NULL)) 
      gtk_widget_set_sensitive (otfgui->filter_entry[8], TRUE);
    append_log(0,1,1,otfgui->logtext,"LO 2 chosen\n");
    break;    
  case 2:
    setBW(0);
    if ((GTK_IS_WIDGET (otfgui->filter_entry[8])) && 
	(otfgui->filter_entry[8] !=NULL)) {
      gtk_entry_set_text (GTK_ENTRY (GTK_COMBO (otfgui->filter_entry[8])->entry),
			  get_bw_string());
      gtk_widget_set_sensitive (otfgui->filter_entry[8], FALSE);
    }
    append_log(0,1,1,otfgui->logtext,"QEF chosen\n");
    break;        
  }
  observer_init_set();
#ifdef DEBUG
  printf("LO  = %d\n",lo_sel);
#endif  
}

void
lo_combo_change (GtkWidget *widget, gpointer data)
{
  char txt[10];

  strcpy(txt,gtk_entry_get_text(GTK_ENTRY( widget)));
  if (!strcmp(txt,"1")) {
    loCB(0);
  }
  if (!strcmp(txt,"2")) {
    loCB(1);
  }
  if (!strcmp(txt,"QEF")) {
    loCB(2);
  }
}

void 
observer_combo_change (GtkWidget *widget, gpointer data) 
{
  char txt[10];

  strcpy(txt,gtk_entry_get_text(GTK_ENTRY( widget)));
  if (!strcmp(txt,"None")) {
    strcpy(observer, "-1");
  } else {
    strcpy(observer, txt);
  }
  if (!strcmp(observer, "-1")) {
      append_log(0,1,1,otfgui->logtext,"Observer None chosen\n");
  } else {
    append_log(0,1,1,otfgui->logtext,"Observer %s chosen\n",observer);
  }
}      


void
bwCB (int Clientdata)
{
  setBW ((int) Clientdata);
  switch(bw_sel) {
  case 0:
    append_log(0,1,1,otfgui->logtext,"Defaulting to all bandwidths\n");
    break;
  case 1:
    append_log(0,1,1,otfgui->logtext,"50 MHz BW chosen\n");
    break;    
  case 2:
    append_log(0,1,1,otfgui->logtext,"25 MHz BW chosen\n");
    break;        
  }
#ifdef DEBUG
  printf("BW  = %d\n",bw_sel);
#endif  
}

void
bw_combo_change (GtkWidget *widget, gpointer data)
{
  char txt[10];

  strcpy(txt,gtk_entry_get_text(GTK_ENTRY( widget)));
  if (!strcmp(txt,"Any")) {
    bwCB(0);
  }
  if (!strcmp(txt,"50 MHz")) {
    bwCB(1);
  }
  if (!strcmp(txt,"25 MHz")) {
    bwCB(2);
  }
}


void 
filter_entry_changed (GtkWidget *widget, gpointer data)
{

  switch ((int) data) {
  case 0:
    if (sscanf (gtk_entry_get_text(GTK_ENTRY (otfgui->filter_entry[0])), 
		"%s", &filter.sname[0]) == 1) 
      append_log(0,1,1,otfgui->logtext, "source name in filter = %s\n", filter.sname);
    break;
  case 1:
    if (sscanf (gtk_entry_get_text(GTK_ENTRY (otfgui->filter_entry[1])), 
		"%hd", &filter.startscan) == 1) 
      append_log(0,1,1,otfgui->logtext, "Start scan in filter = %d\n", filter.startscan);
    break;
  case 2:
    if (sscanf (gtk_entry_get_text(GTK_ENTRY (otfgui->filter_entry[2])), 
		"%hd", &filter.endscan) == 1) 
      append_log(0,1,1,otfgui->logtext, "End scan in filter = %d\n", filter.endscan);
    break;
  case 6: 
    if (sscanf (gtk_entry_get_text (GTK_ENTRY (otfgui->filter_entry[6])),
		"%g", &filter.f0) == 1)
      append_log(0,1,1,otfgui->logtext, "f0 in filter = %g GHz\n", filter.f0);
    break;      
  case 7:
    if (sscanf (gtk_entry_get_text (GTK_ENTRY (otfgui->filter_entry[7])),
		"%g", &filter.deltaf) == 1)
      append_log(0,1,1,otfgui->logtext, "deltaf in filter = %g GHz\n", filter.deltaf);
    break;      
  }
}


void 
collect_filter ()
{
  if (sscanf (gtk_entry_get_text(GTK_ENTRY (otfgui->filter_entry[0])), 
              "%s", &filter.sname[0]) == 1) {
    append_log(0,1,1,otfgui->logtext, "source name in filter = %s\n", filter.sname);
  } else {
    strcpy(filter.sname,"");
    append_log(0,1,1,otfgui->logtext, "No source name specified in filter\n");
  }
  if (sscanf (gtk_entry_get_text(GTK_ENTRY (otfgui->filter_entry[1])), 
              "%hd", &filter.startscan) == 1) {
    append_log(0,1,1,otfgui->logtext, "Start scan in filter = %d\n", filter.startscan);
  } else {
    filter.startscan = 0;
    append_log(0,1,1,otfgui->logtext, "Assuming Start scan 0\n");
  }
  if (sscanf (gtk_entry_get_text(GTK_ENTRY (otfgui->filter_entry[2])), 
              "%hd", &filter.endscan) == 1) {
    append_log(0,1,1,otfgui->logtext, "End scan in filter = %d\n", filter.endscan);
  } else {
    filter.endscan = 31000;
    append_log(0,1,1,otfgui->logtext, "Assuming End scan 31000\n");
  }
  filter.lo = getLO();
  if (sscanf (gtk_entry_get_text (GTK_ENTRY (otfgui->filter_entry[6])),
	      "%g", &filter.f0) == 1) {
    append_log (0, 1, 1, otfgui->logtext, "f0 in filter = %g GHz\n", filter.f0);
  } else {
    filter.f0 = 0.0;
    append_log (0,1,1,otfgui->logtext, "Not filtering with respect to line frequency\n");
  }
  if (sscanf (gtk_entry_get_text (GTK_ENTRY (otfgui->filter_entry[7])),
	      "%g", &filter.deltaf) == 1) {
    append_log (0, 1, 1, otfgui->logtext, "deltaf in filter = %g GHz\n", filter.deltaf);
  } else {
    filter.deltaf = 0.0;
    if (filter.f0 != 0.0) 
      append_log (0,1,1,otfgui->logtext, "Filtering at exactly %g GHz\n", filter.f0);
  }
  filter.bw = getBW();
}

void
print_filter ()
{
  char txt[20];

  sprintf(txt,"%s",filter.sname);
  gtk_entry_set_text(GTK_ENTRY (otfgui->filter_entry[0]), txt);
  sprintf(txt, "%d",filter.startscan);
  gtk_entry_set_text(GTK_ENTRY (otfgui->filter_entry[1]), txt);

  if (filter.endscan != 0) {
    sprintf(txt, "%d",filter.endscan);
    gtk_entry_set_text(GTK_ENTRY (otfgui->filter_entry[2]), txt);
  }
  if (filter.f0 != 0.0) {
    sprintf(txt, "%g", filter.f0);
    gtk_entry_set_text(GTK_ENTRY (otfgui->filter_entry[6]), txt);
  }
  if (filter.deltaf != 0.0) {
    sprintf(txt, "%g", filter.deltaf);
    gtk_entry_set_text(GTK_ENTRY (otfgui->filter_entry[7]), txt);
  }

}


int 
file_select(struct direct   *entry)
{
  char *ptr;
  char *ext;
  /*  char *rindex(char *s, char c);*/

  ext = (char *) malloc (4*sizeof (char));
  /*Ignore . and .. entries */
  if ((strcmp(entry->d_name, ".") == 0) ||
      (strcmp(entry->d_name, "..") == 0))
    return (FALSE);
  
  switch (lo_sel) {
  case 0:
    strcpy(ext,".loa");
    break;
  case 1:
    strcpy(ext,".lob");
    break;
  case 2:
    strcpy(ext,".qef");
    break;
  }

  /* Check for filename extensions */
  ptr = rindex(entry->d_name, '.');
  if ((ptr != NULL) && (strcmp(ptr, ext) == 0) ) {
    free(ext);
    return (TRUE);
  }  else {
    free(ext);
    return(FALSE);
  }
}

#ifdef MYSQLDB
char 
*mystrcat (char *query, const char *fmt, ...)
{
  va_list args;
  char *txt;
  int length;
  if ((txt = (char *) malloc(100*sizeof (char))) == NULL) {
    perror("txt error: malloc");
    exit(3);
  }

  va_start (args, fmt);
  vsprintf(txt, fmt, args);
  va_end(args);
  length = strlen(txt);
  strncat(query, txt, strlen(txt));
  free(txt);
  return query;
}
#endif

void
filter_raw_data (GtkWidget *widget, gpointer data)
{
  int i, count;
  struct direct **files;
  int file_select();
  char rawfilename[MAXPATHLEN];
  short sscan=0;
  short escan=31000;
  double startut, endut, tmp;
  int ifnum;
  char *text[6];
  struct tm *t1;
  int mode = (int) data;
  GtkWidget *statuscontainer;
  int skip, pb;
  char restorefilename[MAXPATHLEN];
  char *tmpfile, *dirc;
  /*  char *basec; */
  /*  gint rows;*/
  char *clistdata;

#ifdef MYSQLDB
  MYSQL mysql;
  /*  MYSQL_RES *result;
      MYSQL_FIELD *field;*/
  MYSQL_ROW row;
  char query[200];
  /*  double tmput;*/
#endif
  char ondisk[2], ontape[2];
  struct {
  GdkColor color;
    gchar *name;
  } text_colors[] = {
    { { 0, 0x0000, 0x0000, 0x0000 }, "black" },
    { { 0, 0xFFFF, 0xFFFF, 0xFFFF }, "white" },
    { { 0, 0xFFFF, 0x0000, 0x0000 }, "red" },
    { { 0, 0x0000, 0xFFFF, 0x0000 }, "green" },
    { { 0, 0x0000, 0x0000, 0xFFFF }, "blue" }, 
    { { 0, 0x0000, 0xFFFF, 0xFFFF }, "cyan" },
    { { 0, 0xFFFF, 0x0000, 0xFFFF }, "magenta" },
    { { 0, 0xFFFF, 0xFFFF, 0x0000 }, "yellow" }
  };
  struct stat statbuf;

  for (i = 0; i<6; i++) {
    if ((text[i] =  (char *) malloc(50*sizeof(char))) == NULL) {
      append_log(2,1,1,otfgui->logtext,"Memory alloc error for row text\n");
      return;
    }
  }

  statuscontainer = GTK_WIDGET (start_progressbar(1));
  gtk_clist_clear (GTK_CLIST (otfgui->clistfilt[0]));
  
  if (mode == 0) {
    collect_filter();
    if (filter.startscan <= filter.endscan) {
      sscan = filter.startscan;
      escan = filter.endscan;
    }  else {
      sscan = filter.endscan;
      escan = filter.startscan;
    }

    startut = utdate(start_tm,DAYSTART); endut = utdate(end_tm,DAYEND);
    if (startut > endut) {
      tmp = startut;
      startut = endut;
      endut = tmp;
    }
  }

  strcpy(rawdir,pathname);
  strcat(rawdir,"/");

#ifndef MYSQLDB
  /*  printf("%s\n", pathname);*/
  count = scandir(pathname, &files, file_select, alphasort);

  /* If no files found, make a non-selectable menu item */
  if  (count <= 0){
    append_log(0,1,1,otfgui->logtext,"No files in raw directory: %s\n", pathname);
    gtk_widget_destroy(statuscontainer);
    return;
  }
  append_log(0,1,1,otfgui->logtext,"Number of files in raw dir = %d\n",count);
  ifnum = 0;
  /*  gtk_clist_freeze (GTK_CLIST (otfgui->clistfilt[0]));*/
  update_plabel(0, "Working on file");
  skip = (int) (count/10);
  pb = 0;
  for (i=0;i<count;i++) {
    strcpy(rawfilename,pathname);
    strcat(rawfilename,"/");
    strcat(rawfilename,files[i]->d_name);
    /*    printf("%s ",rawfilename);*/

    /*    printf("%s\n",rawfilename);*/
    if ((otffp=fopen(rawfilename,"r"))!=NULL) {
      if (ReadHEADER() != 0) {
	fclose(otffp);
	append_log(0,1,1,otfgui->logtext, "Problem with %s\n",rawfilename);
	continue;
      }
      /*      printf("%s %s %d\n", H.name, filter.sname, strlen(filter.sname));*/
      fclose(otffp);
      if ((strcmp(filter.sname,"") == 0) || (strncasecmp 
					     (filter.sname,H.name,strlen(filter.sname)) == 0) 
	  || (mode ==1)) {
	/* source name match */
	/*	printf("Source match \n");*/
	if (((sscan <= H.iscan) && (H.iscan <= escan)) || (mode == 1)) {
	  /* scan number match */
	  if (((startut <= H.utd) && (H.utd <= endut)) || (mode == 1)) {
	    /* ut range match */
	    if ((filter.bw == H.bw) || (filter.bw != 0.0) || (mode == 1)) {
	      /* BW match */
	      if ((((filter.f0-filter.deltaf) <= H.f0) && 
		   ((filter.f0+filter.deltaf) >= H.f0)) || (filter.f0 != 0.0)
		  || (mode == 1)) {
		/* frequency match */
		strcpy(text[0],files[i]->d_name);
		strcpy(text[1],H.name);
		sprintf(text[2],"%d",H.iscan);
		t1 = caldate(H.utd);
		sprintf(text[3],"%d/%d/%d \n",t1->tm_mon+1,t1->tm_mday,TM_YEAR_BASE+t1->tm_year);
		sprintf(text[4], "%g",H.f0);
		gtk_clist_append(GTK_CLIST (otfgui->clistfilt[0]), (char **) text);
		while (gtk_events_pending())
		  gtk_main_iteration();
		ifnum++;
	      }
	    }
	  }
	}
      }
      
    } else {
      append_log(2,1,1,otfgui->logtext,"Cannot read file %s: %s\n", rawfilename, strerror(errno));
    }
    if ( i == pb) {
      progress_val = (float) ((((float) (i+1))/((float) (count))) * 100.0);
      update_progressbar(0, progress_val);
      sprintf(logtext_string," %d", i+1);
      update_plabel(1, logtext_string);
      pb = pb+skip;
    }
  }
  /*  gtk_clist_thaw (GTK_CLIST (otfgui->clistfilt[0]));*/

  
  gtk_widget_destroy (statuscontainer);
  if (mode == 0)
    append_log(0,1,1,otfgui->logtext,"Filtered %d files from the raw directory\n",ifnum);
  else 
    append_log(0,1,1,otfgui->logtext,"Got %d files from the raw directory\n",ifnum);
#else
  /* initialize MYSQL object */
  mysql_init (&mysql);
  /* Use compressed client-server protocol */
  mysql_options(&mysql,MYSQL_OPT_COMPRESS,NullS);
 /* the actual connection */
  if (!(mysql_real_connect(&mysql,host,"observer","password",
                           "otfdb",opt_mysql_port,opt_mysql_unix_port,
                           0)))
  {
    append_log(0,1,1,otfgui->logtext,"MYSQL Error:  %s\n", mysql_error(&mysql));
    gtk_widget_destroy(statuscontainer);
    return;
  }
  strcpy (query, "select count(*) from ");
  mystrcat (query, "%s;",get_lo_char3());
  if (!mysql_query (&mysql, query)) {
    MYSQL_RES *result;
    if ((result = mysql_store_result (&mysql))) {
      if (((ulong) mysql_num_rows (result))!= 0) {
	row = mysql_fetch_row (result);
	count = atoi(row[0]);
      } else {
	append_log (2,1,1, otfgui->logtext, 
		    "No result returned from number of rows query\n");
	mysql_close(&mysql); 
	gtk_widget_destroy(statuscontainer);
	return;
      }
    }
    mysql_free_result (result);
  } else {
    append_log(2,1,1, otfgui->logtext, "Select query error: %s\n",
	       mysql_error(&mysql));
    mysql_close(&mysql); 
    gtk_widget_destroy(statuscontainer);
    return;
  }

  append_log(0,1,1,otfgui->logtext,"Number of files in %s database = %d\n",
	     get_lo_char3(),count);
  /*  gtk_clist_freeze (GTK_CLIST (otfgui->clistfilt[0]));*/
  update_plabel(0, "Working on file");

  strcpy(query,"select filename, name, iscan, utdate, f0, ondisk, ontape from ");
  mystrcat (query, "%s ",get_lo_char3());

  if (mode == 0) {
    mystrcat (query, "where name like '%s%%' ",filter.sname);
    mystrcat (query, "and iscan >= %d and iscan <= %d ",sscan, escan);
    mystrcat (query, "and utd >= %.10g and utd <= %.10g ", startut, endut);
    if (filter.bw != 0.0) 
      mystrcat (query, "and bw = %g ", filter.bw);
    if (filter.f0 != 0.0) {
      mystrcat (query, "and f0 >= %.12g and f0 <= %.12g ", filter.f0-filter.deltaf,
		filter.f0+filter.deltaf);
    }
    if (strcmp(observer, "-1")) {
      mystrcat (query, "and observer = '%s' ", observer);
    }
  }
  mystrcat (query, ";");
  
  if (!mysql_query (&mysql, query)) {
    MYSQL_RES *result;
    if ((result = mysql_store_result (&mysql))) {
      if ((ifnum = (ulong) mysql_num_rows (result)) != 0) {
	skip = (int) (ifnum/10);
	pb = 0;
	i = 0;
	while ((row = mysql_fetch_row (result))) {
	  strcpy(rawfilename,row[0]);
	  strcpy(text[0], (char *) (rindex(row[0],'/') + 1));
	  strcpy(text[1], row[1]);
	  strcpy(text[2], row[2]);
	  /*
	  tmput = atof(row[3]);
	  t1 = caldate(tmput);
	  sprintf(text[3],"%d/%d/%d \n",t1->tm_mon+1,
		  t1->tm_mday,TM_YEAR_BASE+t1->tm_year);
	  */
	  strcpy(text[3], row[3]);
	  strcpy(text[4], row[4]);
	  strcpy(text[5], row[5]);
	  strcpy(ondisk, row[5]);
	  strcpy(ontape, row[6]);
	  gtk_clist_append(GTK_CLIST (otfgui->clistfilt[0]), (char **) text);
	  while (gtk_events_pending())
	    gtk_main_iteration();
	  if (!strcmp(ondisk, "N") || !strcmp(ondisk, "n")) {
	    gtk_widget_set_sensitive (otfgui->restorebtn, TRUE);
	    strcpy(restorefilename, RESTOREPATH);
	    strcat(restorefilename, rawfilename);
	    tmpfile = strdup (restorefilename);
	    /*tmpfile2 = strdup (restorefilename);*/
	    dirc = dirname(tmpfile);
	    /*	    basec = basename (tmpfile2);*/
	    /* printf("dir: %s\n", dirc); */
	    /*
	    rows = GTK_CLIST (otfgui->clistfilt[0])->rows;
	    printf ("%d\n", rows);*/
	    gtk_clist_set_row_data (GTK_CLIST (otfgui->clistfilt[0]),
				    i, (gpointer) dirc); 
	    if (stat(restorefilename, &statbuf) == 0) {
	      gtk_clist_set_foreground (GTK_CLIST (otfgui->clistfilt[0]),
					i, &text_colors[4].color);
	      gtk_clist_set_selectable (GTK_CLIST (otfgui->clistfilt[0]),
					i, TRUE);
	      strcpy (ondisk, "R");
	      gtk_clist_set_text (GTK_CLIST (otfgui->clistfilt[0]),
				  i, 5, "R");
	    } else {
	      gtk_clist_set_foreground (GTK_CLIST (otfgui->clistfilt[0]),
					i, &text_colors[2].color);
	      gtk_clist_set_selectable (GTK_CLIST (otfgui->clistfilt[0]),
					i, FALSE);
	    }
	  } else {
	    tmpfile = strdup (rawfilename);
	    dirc = dirname (tmpfile);
	    gtk_clist_set_row_data (GTK_CLIST (otfgui->clistfilt[0]),
				    i, (gpointer) dirc);
	  }

	  clistdata = gtk_clist_get_row_data (GTK_CLIST (otfgui->clistfilt[0]),
					      i);
	  /*	  printf ("Clist data = %s\n", clistdata);*/
	  /*	  free(tmpfile); */


	  if ( i == pb) {
	    progress_val = (float) ((((float) (i+1))/((float) (ifnum))) * 100.0);
	    update_progressbar(0, progress_val);
	    sprintf(logtext_string," %d", i+1);
	    update_plabel(1, logtext_string);
	    pb = pb+skip;
	  }
	  i++;
	}
      } else {
	append_log (2,1,1, otfgui->logtext, 
		    "No result returned from filter query\n");
	mysql_close(&mysql); 
	gtk_widget_destroy(statuscontainer);
	return;
      }
    }
    mysql_free_result (result);
  } else {
    append_log(2,1,1, otfgui->logtext, "Select query error: %s\n",
	       mysql_error(&mysql));
    mysql_close(&mysql); 
    gtk_widget_destroy(statuscontainer);
    return;
  }    
  /*  gtk_clist_thaw (GTK_CLIST (otfgui->clistfilt[0]));*/
  mysql_close(&mysql); 
  gtk_widget_destroy (statuscontainer);
  if (mode == 0)
    append_log(0,1,1,otfgui->logtext,"Filtered %d files from the raw directory\n",ifnum);
  else 
    append_log(0,1,1,otfgui->logtext,"Got %d files from the raw directory\n",ifnum);
#endif
}




void
set_start_time (GtkWidget *widget, GtkWidget *cal)
{
  char txt[40];
  time_t time;
  /*  double test;
      struct tm *t1; */

  gtk_calendar_unmark_day (GTK_CALENDAR (cal), start_mark);
  memset (&start_tm, 0, sizeof (start_tm));
  gtk_calendar_get_date (GTK_CALENDAR (cal),
			 &start_tm.tm_year, &start_tm.tm_mon, &start_tm.tm_mday);
  start_tm.tm_year -= TM_YEAR_BASE;
  time = mktime(&start_tm);
  strftime (txt, sizeof(txt)-1, "%x", gmtime(&time));
  gtk_label_set_text (GTK_LABEL (otfgui->filter_entry[4]), txt);
  gtk_calendar_mark_day (GTK_CALENDAR (cal), start_tm.tm_mday);
  start_mark = start_tm.tm_mday;
  append_log(0,1,1,otfgui->logtext, "Filtering with start ut date set to %s\n",
	     txt);
  /*  printf("%f\n",utdate(start_tm));*/
  /*  test =  utdate(start_tm);
      t1 = caldate(test);*/
  /*  printf("%d/%d/%d \n",t1->tm_mon+1,t1->tm_mday,TM_YEAR_BASE+t1->tm_year);*/
}

void
set_end_time (GtkWidget *widget, GtkWidget *cal)
{
  char txt[40];
  time_t time;

  memset (&end_tm, 0, sizeof (end_tm));
  gtk_calendar_get_date (GTK_CALENDAR (cal),
			 &end_tm.tm_year, &end_tm.tm_mon, &end_tm.tm_mday);
  end_tm.tm_year -= TM_YEAR_BASE;
  time = mktime(&end_tm);
  strftime (txt, sizeof(txt)-1, "%x", gmtime(&time));
  gtk_label_set_text (GTK_LABEL (otfgui->filter_entry[5]), txt);
  gtk_calendar_mark_day (GTK_CALENDAR (cal), end_tm.tm_mday);
  end_mark = end_tm.tm_mday;
  append_log(0,1,1,otfgui->logtext, "Filtering with end ut date set to %s\n",
	     txt);
}

void
calendar_popup (GtkWidget *widget, gpointer data)
{
  char txt[100];
  GtkWidget *vbox;
  GtkWidget *calendar;
  GtkWidget *hbox;
  GtkWidget *button;
  /*  int mode = (int) data;*/
  time_t t1;
  char timebuf[40], timebuf1[40];
  GdkFont *font;
  GtkStyle *style;

  strcpy(txt, "Set UT Date Interval");
  
  calw = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_window_set_title (GTK_WINDOW (calw), txt);

  gtk_signal_connect (GTK_OBJECT (calw), "destroy",
                      GTK_SIGNAL_FUNC (gtk_widget_destroyed), &calw);
  gtk_container_border_width (GTK_CONTAINER (calw), 5);
  vbox = gtk_vbox_new(FALSE, 5);
  gtk_container_add (GTK_CONTAINER (calw), vbox);

  calendar = gtk_calendar_new ();
  gtk_box_pack_start (GTK_BOX (vbox), calendar, FALSE, FALSE, 0);
  gtk_widget_show (calendar);

  font = gdk_font_load ("-*-helvetica-medium-r-*-*-*-180-*-*-*-*-*-*");
  style = gtk_style_copy (gtk_widget_get_style (calendar));
  gdk_font_unref (style->font);
  style->font = font;
  gdk_font_ref (style->font);
  gtk_widget_set_style (calendar, style);
  
  t1 = time(NULL);
  strftime(timebuf, sizeof (timebuf)-1, "%m", gmtime(&t1));
  /*  printf("%d\n",atoi(timebuf));*/
  strftime(timebuf1, sizeof (timebuf1)-1, "%Y", gmtime(&t1));
  gtk_calendar_select_month( GTK_CALENDAR (calendar), atoi(timebuf)-1,
			     atoi(timebuf1));
  strftime(timebuf, sizeof (timebuf)-1, "%d", gmtime(&t1));
  gtk_calendar_select_day ( GTK_CALENDAR (calendar), atoi(timebuf));

  strftime(timebuf, sizeof (timebuf)-1, "%x", gmtime(&t1));
  /*  printf("%s\n",timebuf);*/

  gtk_calendar_mark_day (GTK_CALENDAR (calendar), start_tm.tm_mday);
  gtk_calendar_mark_day (GTK_CALENDAR (calendar), end_tm.tm_mday);


  hbox = gtk_hbox_new (FALSE, 5);
  gtk_box_pack_start (GTK_BOX (vbox), hbox, FALSE, FALSE, 0);

  button = gtk_button_new_with_label ("Set Start UT Date");
  gtk_box_pack_start (GTK_BOX (hbox), button, FALSE, FALSE, 0);
  gtk_signal_connect (GTK_OBJECT (button), "clicked",
		      GTK_SIGNAL_FUNC (set_start_time), calendar);
  gtk_widget_show (button);

  button = gtk_button_new_with_label ("Set End UT Date");
  gtk_box_pack_start (GTK_BOX (hbox), button, FALSE, FALSE, 0);
  gtk_signal_connect (GTK_OBJECT (button), "clicked",
			GTK_SIGNAL_FUNC (set_end_time), calendar);
  gtk_widget_show (button);

  button = gtk_button_new_with_label ("Dismiss");
  gtk_box_pack_start (GTK_BOX (hbox), button, FALSE, FALSE, 0);
  gtk_signal_connect_object (GTK_OBJECT (button), "clicked",
                             GTK_SIGNAL_FUNC (gtk_widget_destroy),
                             GTK_OBJECT (calw));

  gtk_widget_show (button);
  gtk_widget_show (hbox);



  gtk_widget_show (vbox);
  gtk_widget_show (calw);


}

void
alert_action (GtkWidget *widget, gpointer data)
{
  savemode = (int) data;
  gtk_widget_destroy (dialog);
  printf("S = %d\n", savemode);
  gtk_main_quit();
}

void
alert_window ()
{
  GtkWidget *button;
  GtkWidget *label;
  GtkTooltips *tooltips;

  dialog = gtk_dialog_new ();
  /*  gtk_signal_connect (GTK_OBJECT (dialog), "destroy",
                      GTK_SIGNAL_FUNC(alert_action),
                      (gpointer) 2);*/
  gtk_widget_set_name (GTK_WIDGET (dialog), "aux window");
  gtk_window_set_modal (GTK_WINDOW (dialog), TRUE);
  gtk_window_position (GTK_WINDOW (dialog), GTK_WIN_POS_MOUSE);
  gtk_window_set_title (GTK_WINDOW (dialog), "Warning!");
  gtk_container_set_border_width (GTK_CONTAINER (dialog), 0);
  label = gtk_label_new ("Warning! File Exists");
  gtk_box_pack_start (GTK_BOX (GTK_DIALOG (dialog)->vbox),
                      label, TRUE, TRUE, 0);
  gtk_widget_show (label);

  tooltips = gtk_tooltips_new ();
  
  button = gtk_button_new_with_label ("Overwrite");
  GTK_WIDGET_SET_FLAGS (button, GTK_CAN_DEFAULT);
  gtk_box_pack_start (GTK_BOX (GTK_DIALOG (dialog)->action_area), 
                      button, TRUE, TRUE, 0);
  gtk_widget_grab_default (button);
  gtk_widget_show (button);
  gtk_signal_connect (GTK_OBJECT (button), "clicked",
		      GTK_SIGNAL_FUNC (alert_action), (gpointer) 0);

  button = gtk_button_new_with_label ("Append");
  gtk_box_pack_start (GTK_BOX (GTK_DIALOG (dialog)->action_area), 
                      button, TRUE, TRUE, 0);
  gtk_widget_show (button);
  gtk_signal_connect (GTK_OBJECT (button), "clicked",
		      GTK_SIGNAL_FUNC (alert_action), (gpointer) 1);


  button = gtk_button_new_with_label ("Cancel");
  gtk_box_pack_start (GTK_BOX (GTK_DIALOG (dialog)->action_area), 
                      button, TRUE, TRUE, 0);
  gtk_widget_show (button);
  gtk_signal_connect (GTK_OBJECT (button), "clicked",
		      GTK_SIGNAL_FUNC (alert_action), (gpointer) 2);
  gtk_widget_show (dialog);
  gtk_main();
}



void
save_list_file (GtkWidget *widget, gpointer data)
{
  /*  GList *l;*/
  /*  char *otflist1[MAXFILES];*/
  char **otflist1;
  int i, numotf, gett;
  FILE *fp=NULL;
  struct stat statbuf;
  char rawfilename[MAXPATHLEN];
  char *temp;
  char *clistdata;
  int N;

  if (sscanf (gtk_entry_get_text(GTK_ENTRY (otfgui->entry[1])), 
              "%s", otffile) != 1) {
    error_mes("Error!","Invalid Entry for Input List file");
    return;
  } 

  if ((otflist1 = (char **) malloc (sizeof (char *))) == NULL) {
    perror("otflist1 text error: malloc");
    exit(3);
  } 

  numotf = 0;
  gett = gtk_clist_get_text (GTK_CLIST (otfgui->clistfilt[1]), numotf, 0, &temp);
  while (gett != 0) {
    gett = gtk_clist_get_text (GTK_CLIST (otfgui->clistfilt[1]), numotf, 0, &temp);
    if (gett != 0) {
      if ((otflist1 = (char **) realloc (otflist1, ((numotf+1) * sizeof(char *)))) == NULL) {
	perror("otflist1 text error: realloc");
	exit(3);
      }
      clistdata = gtk_clist_get_row_data (GTK_CLIST (otfgui->clistfilt[1]),
					  numotf);
      /*      printf ("%s\n", clistdata);*/
      strcpy(rawfilename, clistdata);
      strcat (rawfilename, "/");
      strcat (rawfilename, temp);
      N = strlen (rawfilename);
      otflist1[numotf] = malloc(N+1);
      strcpy(otflist1[numotf],rawfilename);
      numotf++;
    }
  }
  
  /*  numotf--;*/
  if (numotf <1) {
    error_mes("Error!","No files in otf list");
    append_log(0,1,1,otfgui->logtext,"No files in otf list");
    return;
  }
  /*  savemode = SAVE_CANCEL;*/

  if (!stat(otffile, &statbuf)) {
    /* File already exists - make sure it can be overwritten */
    alert_window();
    printf("%d\n", savemode);
    switch(savemode) {
    case SAVE_OVERWRITE:
      if ( (fp = fopen(otffile,"w")) == NULL) {
	append_log (2,1,1,otfgui->logtext, "%s\n",strerror(errno));
	return;
      }
      break;
    case SAVE_APPEND:
      if ( (fp = fopen(otffile,"a")) == NULL) {
	append_log (2,1,1,otfgui->logtext, "%s\n",strerror(errno));
	return;
      }
      break;
    case SAVE_CANCEL:
      return;
      break;
    }
  } else {
    /* File does not exist - create */
    if ( (fp = fopen(otffile,"w")) == NULL) {
      append_log (2,1,1,otfgui->logtext, "%s\n",strerror(errno));
      return;
    }
  }

  for (i = 0; i<numotf; i++) {
    /*    strcpy(rawfilename, pathname);
    strcat(rawfilename, "/");
    strcat (rawfilename, otflist1[i]);
    fprintf(fp,"%s\n",rawfilename);*/
    fprintf(fp,"%s\n",otflist1[i]);
  }
  fclose(fp);
  append_log (2,1,1,otfgui->logtext, "Wrote otflist to file %s\n",otffile);
  free(otflist1);
}

void
move_selected (GtkWidget *widget, gpointer data)
{
  GList *l;
  char *filename;
  char **otflist1;
  int i, numotf, gett;
  short present = 0;
  char *temp;
  int N;
  char *clistdata;
  int rightrows;

  /*  clist0 = GTK_CLIST (otfgui->clistfilt[0]);
      clist1 = GTK_CLIST (otfgui->clistfilt[1]);*/
  if ((otflist1 = (char **) malloc (sizeof (char *))) == NULL) {
    perror("otflist1 text error: malloc");
    exit(3);
  } 

  l = GTK_CLIST (otfgui->clistfilt[0])->selection;
  if (l != NULL) {
    numotf = 0;
    gett = gtk_clist_get_text (GTK_CLIST (otfgui->clistfilt[1]), numotf, 0, &temp);
    while (gett != 0) {
      gett = gtk_clist_get_text (GTK_CLIST (otfgui->clistfilt[1]), numotf, 0, &temp);
      if (gett != 0) {
	if ((otflist1 = (char **) realloc (otflist1, 
					   ((numotf+1) * sizeof(char *)))) == NULL) {
	  perror("otflist1 text error: realloc");
	  exit(3);
	}
	N = strlen (temp);
	otflist1[numotf] = malloc(N+1);
	strcpy(otflist1[numotf],temp);
	numotf++;
      }
    } 
    /*    numotf--;*/
    /*    for (i=0; i<numotf; i++) printf("%d %s \n",i,otflist1[i]);*/
    
    gtk_clist_freeze (GTK_CLIST (otfgui->clistfilt[1]));
    rightrows = 0;
    for (l= GTK_CLIST (otfgui->clistfilt[0])->selection; l!=NULL; l=l->next) {
      gtk_clist_get_text (GTK_CLIST (otfgui->clistfilt[0]), 
			  GPOINTER_TO_INT (l->data), 0, &filename);
      present = 0;
      for (i = 0; i<numotf; i++) {
	if (!strcmp(filename,otflist1[i])) present = 1;
      }
      if (!present) {
	gtk_clist_append (GTK_CLIST (otfgui->clistfilt[1]), &filename);
	clistdata = gtk_clist_get_row_data (GTK_CLIST (otfgui->clistfilt[0]),
					    GPOINTER_TO_INT (l->data));
	gtk_clist_set_row_data (GTK_CLIST (otfgui->clistfilt[1]), rightrows, 
				(gpointer) clistdata);
	rightrows++;
      }
	
    }
    gtk_clist_unselect_all (GTK_CLIST (otfgui->clistfilt[0]));
    gtk_clist_thaw (GTK_CLIST (otfgui->clistfilt[1]));
  }
  free(otflist1);

}


void
remove_selected (GtkWidget *widget, gpointer data)
{
  GList *l;
  int row;

  l = GTK_CLIST (otfgui->clistfilt[1])->selection;
  gtk_clist_freeze (GTK_CLIST (otfgui->clistfilt[1]));
  while (l) {
    row = GPOINTER_TO_INT (l->data);
    l = l->next;
    gtk_clist_remove (GTK_CLIST (otfgui->clistfilt[1]), row);
  }
  gtk_clist_thaw (GTK_CLIST (otfgui->clistfilt[1]));
    /*gtk_clist_unselect_all (GTK_CLIST (otfgui->clistfilt[1]));*/
}

void
move_all (GtkWidget *widget, gpointer data)
{
  gtk_clist_select_all (GTK_CLIST (otfgui->clistfilt[0]));
  move_selected (widget , data);
}

void
remove_all (GtkWidget *widget, gpointer data)
{
  gtk_clist_select_all (GTK_CLIST (otfgui->clistfilt[1]));
  remove_selected (widget , data);
}

void 
file_ok_save_restore (GtkWidget *w, GtkFileSelection *fs)
{
  FILE *fsave;
  /*  int nchars;*/
  char *filename, *ondisk_char;
  gint rows, i;
  /*  GList *l;*/
  char rawfilename[MAXPATHLEN];

  if ((fsave=fopen(gtk_file_selection_get_filename 
		   (GTK_FILE_SELECTION (fs)), "w"))==NULL) {
    fprintf(stderr,"\n Can not open file\n");
    append_log(6,1,1,otfgui->logtext,"Cannot Open File for restore list\n");
    return;
  }
  rows = GTK_CLIST (otfgui->clistfilt[0])->rows;
  /*printf ("Number of rows = %d\n", rows);*/
  /*
  gtk_clist_select_all (GTK_CLIST (otfgui->clistfilt[0]));
  l = GTK_CLIST (otfgui->clistfilt[0])->selection;
  for (l= GTK_CLIST (otfgui->clistfilt[0])->selection; l!=NULL; l=l->next) {
  */
  for (i = 0; i<rows; i++) {
    gtk_clist_get_text (GTK_CLIST (otfgui->clistfilt[0]), 
			i, 0, &filename);
    gtk_clist_get_text (GTK_CLIST (otfgui->clistfilt[0]),
			i, 5, &ondisk_char);
    /* printf("%s %s\n", filename, ondisk_char);*/
   if (!strcmp(ondisk_char, "N")) {
     strcpy(rawfilename, pathname);
     strcat(rawfilename, "/");
     strcat (rawfilename, filename);
     fprintf(fsave, "%s\n",rawfilename);
    }
  }

  /*  gtk_clist_unselect_all (GTK_CLIST (otfgui->clistfilt[0]));*/
  gtk_widget_destroy(GTK_WIDGET (fs));
  fclose(fsave);
}



void 
restore_list (GtkWidget *widget, gpointer data)
{
  static GtkWidget *filewin = NULL;
  
  if (!filewin) {
    /* Create a new file selection widget */
    filewin = gtk_file_selection_new ("Restore List File selection");
    
    gtk_widget_set_name (GTK_WIDGET (filewin), "aux window");
    gtk_file_selection_show_fileop_buttons (GTK_FILE_SELECTION (filewin));
    gtk_signal_connect (GTK_OBJECT (filewin), "destroy",
                        GTK_SIGNAL_FUNC (gtk_widget_destroyed), &filewin);
    
    /* Connect the ok_button to file_ok_sel function */
    gtk_signal_connect (GTK_OBJECT (GTK_FILE_SELECTION (filewin)->ok_button),
			"clicked", (GtkSignalFunc) file_ok_save_restore, filewin );
    
  /* Connect the cancel_button to destroy the widget */
    gtk_signal_connect_object (GTK_OBJECT (GTK_FILE_SELECTION
					   (filewin)->cancel_button),
			       "clicked", (GtkSignalFunc) gtk_widget_destroy,
			       GTK_OBJECT (filewin));

    gtk_file_selection_set_filename (GTK_FILE_SELECTION(filewin),
				     "otftool.restore");
    /*    gtk_file_selection_complete (GTK_FILE_SELECTION (filewin),"*.lis");*/
  }
  
  if (!GTK_WIDGET_VISIBLE (filewin))
    gtk_widget_show(filewin);
  else 
    gtk_widget_destroy(filewin);
}


void
clistfilt_header_activate (gint row)
{
  char errmsg[300];
  char temp[MAXPATHLEN];
  gchar *text;
  gchar *clistdata;
  
  gtk_clist_get_text(GTK_CLIST(otfgui->clistfilt[1]), row, 0, &text);
  clistdata = gtk_clist_get_row_data (GTK_CLIST(otfgui->clistfilt[1]), 
				      row);
  strcpy(temp,clistdata);
  strcat (temp, "/");
  strcat(temp,text);
  if ((otffp=fopen(temp,"r"))==NULL) {
    sprintf(errmsg,"Input OTF file: %s",temp);
    strcat(errmsg,strerror(errno));
    error_mes("Error!", errmsg);
    return;
  }
  
  append_log(0,1,1,otfgui->logtext,"Reading file for header listing: %s\n", text);
  ReadHEADER();
  GtkPrintHEADER(text);
  /*  PrintHEADER();*/
}


int
plotpos_datasel (gint row) 
{
  int n, len;
  char *temp;
  int gett;
  gchar *clistdata;
  /*  gchar clisttext[MAXPATHLEN];*/
  int rows, numfiles;
  
  if ((otflist = (char **) malloc (sizeof (char *))) == NULL) {
    append_log(2,1,1,otfgui->logtext, "Can not allocate otflist mem\n");
    perror("otflist text error: malloc");
    return -1;
  }
  if ((temp = (char *) malloc (15*sizeof(char))) == NULL) {
    append_log(2,1,1,otfgui->logtext, "Can not allocate otflist mem\n");
    perror("otflist text error: malloc");
    return -1;
  }

  if (row == -1) {
    /* Get all rows */
    n = 0;

    rows = GTK_CLIST (otfgui->clistfilt[1])->rows;
    numfiles = rows;
    for (n=0; n<rows; n++) {
      if ((otflist = (char **) realloc(otflist, ((n+1) * sizeof(char *)))) == NULL) {
	append_log(2,1,1,otfgui->logtext, "Cannot allocate otflist mem\n");
	return -1;
      }
      /*gett = gtk_clist_get_text (GTK_CLIST (otfgui->clistfilt[1]), n, 0, &temp);
	while (gett != 0) { */
      gett = gtk_clist_get_text (GTK_CLIST (otfgui->clistfilt[1]), n, 0, &temp);
      if (gett != 0) {
	clistdata = gtk_clist_get_row_data (GTK_CLIST (otfgui->clistfilt[1]),
					    n);
	if (clistdata == NULL) break;
	len = strlen (clistdata) + strlen (temp) + 1;
	otflist[n] = malloc(len+1);
	strcpy (otflist[n],clistdata);
	strcat (otflist[n],"/");
	strcat (otflist[n],temp);
    /*
	printf ("%s \n", clistdata);
	strcpy (clisttext, clistdata);
	strcat (clisttext,"/");
	strcat (clisttext,temp);
	len = strlen (clisttext);
	otflist[n] = (char *) malloc((len+1) * sizeof (char));
	printf("%s %s %d\n",clisttext,temp, len);
	strncpy (otflist[n],clisttext, len);
    */
	/*
	n++;
	if ((otflist = (char **) realloc(otflist, ((n+1) * sizeof(char *)))) == NULL) {
	  append_log(2,1,1,otfgui->logtext, "Can not allocate otflist mem\n");
	  return -1;
	}
	*/
      }
    }
    /*    n--;*/
  } else {
    n = 0; numfiles = 1;
    if ((otflist = (char **) realloc(otflist, ((n+1) * sizeof(char *)))) == NULL) {
      append_log(2,1,1,otfgui->logtext, "Can not allocate otflist mem\n");
      return -1;
    }
    
    gtk_clist_get_text (GTK_CLIST (otfgui->clistfilt[1]), row, 0, &temp);
    clistdata = gtk_clist_get_row_data (GTK_CLIST (otfgui->clistfilt[1]),
					row);
    len = strlen (clistdata) + strlen (temp) + 1;
    otflist[n] = malloc(len+1);
    strcpy (otflist[n],clistdata);
    strcat (otflist[n],"/");
    strcat (otflist[n],temp);
  }
  return numfiles;
  /*  plotpos (n, 1, otflist, 0);*/

}

void 
plotpos_datasel_x11 (gint row)
{
  int num;
  num = plotpos_datasel (row);
  if (num != -1) {
    plotpos (0, num, otflist, 0);
    free(otflist);
  }
}
		      
void
plotpos_datasel_ps (gint row)
{
  int num;
  num = plotpos_datasel (row);
  if (num != -1) {
    plotpos (0, num, otflist, 1);
    append_log(0,1,1,otfgui->logtext,"Plotting positions for %s to postscript file otfplotpos.ps\n",
	       otflist[row]);
    free(otflist);
  }
}

void 
plotpos_all_datasel_x11 (gint row)
{
  int num;
  num = plotpos_datasel (-1);
  if (num != -1) {
    plotpos (0, num, otflist, 0);
    free(otflist);
  }
}
		      
void
plotpos_all_datasel_ps (gint row)
{
  int num;
  num = plotpos_datasel (-1);
  if (num != -1) {
    plotpos (0, num, otflist, 1);
    append_log(0,1,1,otfgui->logtext,"Plotting all positions to postscript file otfplotpos.ps\n");
    free(otflist);
  }
}

gint
clistfilt_button_pressed (GtkWidget *widget, GdkEventButton *event)
{
  GtkWidget *menu, *item1, *item2, *item3;
  GtkWidget *item4, *item5, *item6;
  gint row, column;
  gint ret;
  gchar *text;

  menu = gtk_menu_new ();
  item1 = make_menu_item (menu, "Header");
  item2 = make_menu_item (menu, "Plot Positions");
  item3 = make_menu_item (menu, "Plot Positions PS");
  item4 = make_menu_item (menu, "SEPARATOR");
  item5 = make_menu_item (menu, "Plot Positions All");
  item6 = make_menu_item (menu, "Plot Positions PS All");

  if (event->type == GDK_BUTTON_PRESS) {
    /* convert GdkEvent to GdkEventButton */
    GdkEventButton *bevent = (GdkEventButton *) event;
    if (!(ret = gtk_clist_get_selection_info(GTK_CLIST (widget),
                                             (gint) event->x, (gint) event->y, &row, &column)))
      {
	return FALSE;
      } else {
	gtk_clist_get_text(GTK_CLIST(widget), row, column, &text);
        gtk_signal_connect_object (GTK_OBJECT (item1), "activate",
                                   GTK_SIGNAL_FUNC (clistfilt_header_activate),
				   (gpointer) row);
	/*                                   (gpointer) text);*/

        gtk_signal_connect_object (GTK_OBJECT (item2), "activate",
                                   GTK_SIGNAL_FUNC (plotpos_datasel_x11),
                                   (gpointer) row);

        gtk_signal_connect_object (GTK_OBJECT (item3), "activate",
                                   GTK_SIGNAL_FUNC (plotpos_datasel_ps),
                                   (gpointer) row);

        gtk_signal_connect_object (GTK_OBJECT (item5), "activate",
                                   GTK_SIGNAL_FUNC (plotpos_all_datasel_x11),
                                   NULL);

        gtk_signal_connect_object (GTK_OBJECT (item6), "activate",
                                   GTK_SIGNAL_FUNC (plotpos_all_datasel_ps),
                                   NULL);

        if (event->button == 3 || event->button == 2) {
          gtk_menu_popup (GTK_MENU (menu), NULL, NULL, NULL, NULL,
                          bevent->button, bevent->time);
        }
        return TRUE;
      }
  }
  return FALSE;
}

void
otftool_setup_datasel(otf_gui *otfg, GtkWidget *vbox)
{
  GtkWidget *hbox;
  GtkWidget *frame;
  GtkWidget *vbox1, *vbox2;
  GtkWidget *box1;
  GtkWidget *label, *button;
  GtkWidget *table;
  GList *glist = NULL;
  GList *glist1 = NULL;
  GList *glist2 = NULL;
  char txt[40];
  GtkWidget *vboxl, *vboxm, *vboxr;
  GtkWidget *scrolled_window;
  /*  GtkWidget *clist1, *clist2;*/
  gchar *titles1[6] = { "File Name", "Source", "Scan", "UTD", "Freq", "OnDisk"};
  gchar *titles2[1] = { "File Name" };
  GtkWidget *arrow_right, *arrow_left;
  GtkTooltips *tooltips;
  time_t t1;
  GtkWidget *align, *vbox3;
  GtkWidget *hbox2;
  /*  GtkWidget *labelbox;*/

    /* Now put together the box with required parameters */

  notebookmode = DATASEL;

  vbox1 = gtk_vbox_new (FALSE, 5);

  gtk_box_pack_start (GTK_BOX (vbox), vbox1, TRUE, TRUE, 0);

  hbox = gtk_hbox_new (FALSE, 5);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox, TRUE, TRUE, 0);

  frame = gtk_frame_new ("Filter Criteria");
  gtk_container_add (GTK_CONTAINER (hbox), frame);
  

  vbox2 = gtk_vbox_new (FALSE, 5);
  gtk_container_add (GTK_CONTAINER (frame), vbox2);

  table = gtk_table_new (3,6,TRUE);
  gtk_box_pack_start (GTK_BOX (vbox2), table, FALSE, FALSE, 0);
  

  box1 = gtk_hbox_new (FALSE, 5);
  gtk_table_attach  (GTK_TABLE (table), box1, 0, 1, 0, 1, GTK_FILL, GTK_FILL|GTK_EXPAND, 2, 4);


  tooltips = gtk_tooltips_new ();
  label = gtk_label_new ("Source Name");
  gtk_box_pack_start (GTK_BOX (box1), label, FALSE, FALSE, 0);
  gtk_widget_show (label); gtk_widget_show (box1);

  box1 = gtk_hbox_new (FALSE, 5);
  gtk_table_attach  (GTK_TABLE (table), box1, 1, 2, 0, 1, GTK_FILL, GTK_FILL|GTK_EXPAND, 2, 4);
  otfg->filter_entry[0] = gtk_entry_new();
  gtk_box_pack_start (GTK_BOX (box1), otfg->filter_entry[0], FALSE, FALSE, 0);
  gtk_widget_show (otfg->filter_entry[0]); 
  gtk_widget_show (box1);
  gtk_signal_connect (GTK_OBJECT (otfg->filter_entry[0]), "activate",
                      GTK_SIGNAL_FUNC (filter_entry_changed), (gpointer) 0);


  box1 = gtk_hbox_new (FALSE, 5);
  gtk_table_attach  (GTK_TABLE (table), box1, 2, 3, 0, 1, GTK_FILL, GTK_FILL|GTK_EXPAND, 2, 4);

  label = gtk_label_new ("Starting Scan Number");
  gtk_box_pack_start (GTK_BOX (box1), label, FALSE, FALSE, 0);
  gtk_widget_show (label); gtk_widget_show (box1);

  box1 = gtk_hbox_new (FALSE, 5);
  gtk_table_attach  (GTK_TABLE (table), box1, 3, 4, 0, 1, GTK_FILL, GTK_FILL|GTK_EXPAND, 2, 4);
  otfg->filter_entry[1] = gtk_entry_new();
  gtk_box_pack_start (GTK_BOX (box1), otfg->filter_entry[1], FALSE, FALSE, 0);
  gtk_widget_show (otfg->filter_entry[1]); 
  gtk_widget_show (box1); 
  gtk_signal_connect (GTK_OBJECT (otfg->filter_entry[1]), "activate",
                      GTK_SIGNAL_FUNC (filter_entry_changed), (gpointer) 1);


  box1 = gtk_hbox_new (FALSE, 5);
  gtk_table_attach  (GTK_TABLE (table), box1, 4, 5, 0, 1, GTK_FILL, GTK_FILL|GTK_EXPAND, 2, 4);
  label = gtk_label_new ("Ending Scan Number");
  gtk_box_pack_start (GTK_BOX (box1), label, FALSE, FALSE, 0);
  gtk_widget_show (label); gtk_widget_show (box1);

  box1 = gtk_hbox_new (FALSE, 5);
  gtk_table_attach  (GTK_TABLE (table), box1, 5, 6, 0, 1, GTK_FILL, GTK_FILL|GTK_EXPAND, 2, 4);
  otfg->filter_entry[2] = gtk_entry_new();
  gtk_box_pack_start (GTK_BOX (box1), otfg->filter_entry[2], FALSE, FALSE, 0);
  gtk_widget_show (otfg->filter_entry[2]); 
  gtk_widget_show (box1); 
  gtk_signal_connect (GTK_OBJECT (otfg->filter_entry[2]), "activate",
                      GTK_SIGNAL_FUNC (filter_entry_changed), (gpointer) 2);
  

  box1 = gtk_hbox_new (FALSE, 5);
  gtk_table_attach  (GTK_TABLE (table), box1, 0, 1, 1, 2, GTK_FILL, GTK_FILL|GTK_EXPAND, 2, 4);

  label = gtk_label_new ("IF #");
  gtk_box_pack_start (GTK_BOX (box1), label, FALSE, FALSE, 0);
  gtk_widget_show (label); gtk_widget_show (box1);

  box1 = gtk_hbox_new (FALSE, 5);
  gtk_table_attach  (GTK_TABLE (table), box1, 1, 2, 1, 2, GTK_FILL, GTK_FILL|GTK_EXPAND, 2, 4);

  otfg->filter_entry[3] = gtk_combo_new ();
  glist = g_list_append(glist, "1");  
  glist = g_list_append(glist, "2");   glist = g_list_append(glist, "QEF");
  gtk_combo_set_popdown_strings (GTK_COMBO (otfg->filter_entry[3]), glist);
  gtk_entry_set_editable( GTK_ENTRY (GTK_COMBO (otfg->filter_entry[3])->entry), FALSE);
  gtk_signal_connect (GTK_OBJECT (GTK_COMBO (otfg->filter_entry[3])->entry), "changed",
		      GTK_SIGNAL_FUNC (lo_combo_change), NULL);
  gtk_box_pack_start (GTK_BOX (box1), otfg->filter_entry[3], TRUE, FALSE, 0);
  gtk_widget_set_usize (GTK_WIDGET (otfg->filter_entry[3]), 60, -1);

  gtk_widget_show (otfg->filter_entry[3]);
  gtk_widget_show (box1);


  box1 = gtk_hbox_new (FALSE, 5);
  gtk_table_attach  (GTK_TABLE (table), box1, 2, 3, 1, 2, GTK_FILL, GTK_FILL|GTK_EXPAND, 2, 4);

  button = gtk_button_new_with_label ("Set UT Date Interval");
  gtk_box_pack_start (GTK_BOX (box1), button, FALSE, FALSE, 0);
  gtk_tooltips_set_tip (tooltips, button,
                        "Pops up calendar for selecting UT Interval", NULL);
  gtk_signal_connect (GTK_OBJECT (button), "clicked",
		      calendar_popup, (gpointer) 0);
  gtk_widget_show (button); gtk_widget_show (box1);

  
  t1 = mktime(&start_tm);
  strftime (txt, sizeof(txt)-1, "%x", gmtime(&t1));

  box1 = gtk_hbox_new (FALSE, 5);
  gtk_table_attach  (GTK_TABLE (table), box1, 3, 4, 1, 2, GTK_FILL, GTK_FILL|GTK_EXPAND, 2, 4);  
  otfg->filter_entry[4] = gtk_label_new (txt);
  gtk_box_pack_start (GTK_BOX (box1), otfg->filter_entry[4], FALSE, FALSE, 0);
  gtk_widget_show (otfg->filter_entry[4]); gtk_widget_show (box1);
  
  label = gtk_label_new ("to");
  gtk_table_attach  (GTK_TABLE (table), label, 4, 5, 1, 2, GTK_FILL, GTK_FILL|GTK_EXPAND, 2, 4);  
  /*  gtk_box_pack_start (GTK_BOX (box1), label, FALSE, FALSE, 0);*/
  gtk_widget_show (label);


  t1 = mktime (&end_tm);
  strftime (txt, sizeof(txt)-1, "%x", gmtime(&t1));
  otfg->filter_entry[5] = gtk_label_new (txt);
  gtk_table_attach  (GTK_TABLE (table), otfg->filter_entry[5], 5, 6, 1, 2, GTK_FILL, GTK_FILL|GTK_EXPAND, 2, 4);  
  gtk_widget_show (otfg->filter_entry[5]);
  /*  gtk_box_pack_start (GTK_BOX (box1), otfg->filter_entry[5], FALSE, FALSE, 0);*/
  gtk_widget_show (otfg->filter_entry[5]);
  gtk_widget_show (box1); 

  /* Put in frequency and bandwidth filter criteria */
  
  box1 = gtk_hbox_new (FALSE, 5);
  gtk_table_attach  (GTK_TABLE (table), box1, 0, 1, 2, 3, GTK_FILL, GTK_FILL|GTK_EXPAND, 2, 4);

  label = gtk_label_new ("Frequency (GHz)");
  gtk_box_pack_start (GTK_BOX (box1), label, FALSE, FALSE, 0);
  gtk_widget_show (box1); gtk_widget_show (label);

  box1 = gtk_hbox_new (FALSE, 5);
  gtk_table_attach  (GTK_TABLE (table), box1, 1, 2, 2, 3, GTK_FILL, GTK_FILL|GTK_EXPAND, 2, 4);

  otfg->filter_entry[6] = gtk_entry_new();
  gtk_box_pack_start (GTK_BOX (box1), otfg->filter_entry[6], FALSE, FALSE, 0);
  gtk_signal_connect (GTK_OBJECT (otfg->filter_entry[6]), "activate",
                      GTK_SIGNAL_FUNC (filter_entry_changed), (gpointer) 6);
  gtk_widget_show (otfg->filter_entry[6]); 
  gtk_widget_show (box1); 

  box1 = gtk_hbox_new (FALSE, 5);
  gtk_table_attach  (GTK_TABLE (table), box1, 2, 3, 2, 3, GTK_FILL, GTK_FILL|GTK_EXPAND, 2, 4);

  label = gtk_label_new ("Delta f (+/- GHz)");
  gtk_box_pack_start (GTK_BOX (box1), label, FALSE, FALSE, 0);
  gtk_widget_show (box1); gtk_widget_show (label);

  box1 = gtk_hbox_new (FALSE, 5);
  gtk_table_attach  (GTK_TABLE (table), box1, 3, 4, 2, 3, GTK_FILL, GTK_FILL|GTK_EXPAND, 2, 4);

  otfg->filter_entry[7] = gtk_entry_new();
  gtk_box_pack_start (GTK_BOX (box1), otfg->filter_entry[7], FALSE, FALSE, 0);
  gtk_signal_connect (GTK_OBJECT (otfg->filter_entry[7]), "activate",
                      GTK_SIGNAL_FUNC (filter_entry_changed), (gpointer) 7);
  gtk_widget_show (otfg->filter_entry[7]); 
  gtk_widget_show (box1); 

  box1 = gtk_hbox_new (FALSE, 5);
  gtk_table_attach  (GTK_TABLE (table), box1, 4, 5, 2, 3, 
		     GTK_FILL, GTK_FILL|GTK_EXPAND, 2, 4);
  label = gtk_label_new ("BW Mode");
  gtk_box_pack_start (GTK_BOX (box1), label, FALSE, TRUE, 0);

  gtk_widget_show (label); gtk_widget_show (box1);

  otfg->filter_entry[8] = gtk_combo_new ();
  glist1 = g_list_append(glist1, "Any");  
  glist1 = g_list_append(glist1, "50 MHz");   glist1 = g_list_append(glist1, "25 MHz");
  gtk_combo_set_popdown_strings (GTK_COMBO (otfg->filter_entry[8]), glist1);
  gtk_entry_set_editable( GTK_ENTRY (GTK_COMBO (otfg->filter_entry[8])->entry), FALSE);
  gtk_signal_connect (GTK_OBJECT (GTK_COMBO (otfg->filter_entry[8])->entry), "changed",
		      GTK_SIGNAL_FUNC (bw_combo_change), NULL);
  gtk_box_pack_start (GTK_BOX (box1), otfg->filter_entry[8], FALSE, FALSE, 0);
  /*  gtk_table_attach  (GTK_TABLE (table), otfg->filter_entry[8], 5, 6, 2, 3, 
      GTK_FILL, GTK_FILL|GTK_EXPAND, 2, 4); */
  sprintf(logtext_string,"%s",get_bw_string());
  gtk_widget_set_usize (GTK_WIDGET (otfg->filter_entry[8]), 80, -1);
  gtk_entry_set_text (GTK_ENTRY (GTK_COMBO (otfg->filter_entry[8])->entry), 
		      logtext_string);
  gtk_widget_show (otfg->filter_entry[8]);

  box1 = gtk_hbox_new (FALSE, 5);
  gtk_table_attach  (GTK_TABLE (table), box1, 5, 6, 2, 3, 
		     GTK_FILL, GTK_FILL|GTK_EXPAND, 2, 4);
  label = gtk_label_new ("Observer");
  gtk_box_pack_start (GTK_BOX (box1), label, FALSE, TRUE, 0);

  gtk_widget_show (label); gtk_widget_show (box1);  

  otfg->filter_entry[9] = gtk_combo_new ();
  glist2 = g_list_append(glist2, "None");    
  gtk_combo_set_popdown_strings (GTK_COMBO (otfg->filter_entry[9]), glist2);
  gtk_entry_set_editable( GTK_ENTRY (GTK_COMBO (otfg->filter_entry[9])->entry), FALSE);
  gtk_signal_connect (GTK_OBJECT (GTK_COMBO (otfg->filter_entry[9])->entry), "changed",
		      GTK_SIGNAL_FUNC (observer_combo_change), NULL);
  gtk_box_pack_start (GTK_BOX (box1), otfg->filter_entry[9], FALSE, FALSE, 0);
  gtk_widget_set_usize (GTK_WIDGET (otfg->filter_entry[9]), 80, -1);
  gtk_widget_show (otfg->filter_entry[9]);

  sprintf(logtext_string,"%s",get_lo_string());
  gtk_entry_set_text (GTK_ENTRY (GTK_COMBO (otfg->filter_entry[3])->entry), logtext_string);
  print_filter();

  gtk_widget_show (table);
  /* gtk_widget_set_usize (GTK_WIDGET (table), 400, -1);*/

  box1 = gtk_hbox_new (FALSE, 5);
  gtk_box_pack_start (GTK_BOX (vbox2), box1, TRUE, TRUE, 0);

  button = gtk_button_new_with_label ("Filtered Raw Data List");
  gtk_tooltips_set_tip (tooltips, button,
                        "Produces Filtered List of Raw data files in left window below, based on criteria provided", NULL);
  gtk_box_pack_start (GTK_BOX (box1), button, TRUE, TRUE, 0);
  gtk_widget_show (button);   gtk_widget_show (box1); 
  gtk_signal_connect (GTK_OBJECT (button), "clicked",
		      GTK_SIGNAL_FUNC (filter_raw_data), (gpointer) 0);


  button = gtk_button_new_with_label ("All Raw Data");
  gtk_tooltips_set_tip (tooltips, button,
                        "Produces Entire List of Raw data files for given IF in left window below", NULL);
  gtk_box_pack_start (GTK_BOX (box1), button, TRUE, TRUE, 0);
  gtk_widget_show (button);   gtk_widget_show (box1); 
  gtk_signal_connect (GTK_OBJECT (button), "clicked",
		      GTK_SIGNAL_FUNC (filter_raw_data), (gpointer) 1);

  gtk_widget_show (vbox2);


  gtk_widget_show (frame);  
  gtk_widget_show (hbox);

  hbox = gtk_hbox_new (FALSE, 5);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox, FALSE, FALSE, 0);

  vboxl = gtk_vbox_new (FALSE, 5);
  gtk_box_pack_start (GTK_BOX (hbox), vboxl, TRUE, TRUE, 0);
  gtk_widget_show (vboxl);

  vbox2 = gtk_vbox_new (FALSE, 5);
  gtk_box_pack_start (GTK_BOX (hbox), vbox2, TRUE, TRUE, 0);
  gtk_widget_show (vbox2);
  
  hbox2 = gtk_hbox_new (FALSE, 5);
  gtk_box_pack_start (GTK_BOX (vbox2), hbox2, TRUE, TRUE, 0);
  gtk_widget_show (hbox2);  
  
  vboxm = gtk_vbox_new (FALSE, 5);
  gtk_box_pack_start (GTK_BOX (hbox2), vboxm, TRUE, TRUE, 0);
  gtk_widget_show (vboxm);

  vboxr = gtk_vbox_new (FALSE, 5);
  gtk_box_pack_start (GTK_BOX (hbox2), vboxr, TRUE, TRUE, 0);
  gtk_widget_show (vboxr);

  frame = gtk_frame_new ("Filtered List of Raw data");
  gtk_container_add (GTK_CONTAINER (vboxl), frame);
  
  scrolled_window = gtk_scrolled_window_new (NULL, NULL);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolled_window),
				  GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC); 
  gtk_container_add (GTK_CONTAINER (frame), scrolled_window);
  gtk_widget_show (scrolled_window);

  otfg->clistfilt[0] = gtk_clist_new_with_titles (6, titles1);
  gtk_clist_set_shadow_type (GTK_CLIST(otfg->clistfilt[0]), GTK_SHADOW_ETCHED_IN);
  gtk_clist_set_column_width (GTK_CLIST(otfg->clistfilt[0]), 0, 100);
  gtk_clist_column_titles_passive (GTK_CLIST (otfg->clistfilt[0]) );
  gtk_clist_set_selection_mode (GTK_CLIST (otfg->clistfilt[0]), GTK_SELECTION_MULTIPLE);
  gtk_clist_set_column_width (GTK_CLIST (otfg->clistfilt[0]), 0, 125);
  gtk_clist_set_column_width (GTK_CLIST (otfg->clistfilt[0]), 1, 100);
  gtk_clist_set_column_width (GTK_CLIST (otfg->clistfilt[0]), 2, 70);
  gtk_clist_set_column_width (GTK_CLIST (otfg->clistfilt[0]), 3, 100);
  gtk_clist_set_column_width (GTK_CLIST (otfg->clistfilt[0]), 4, 80);

  gtk_container_add(GTK_CONTAINER(scrolled_window), otfg->clistfilt[0]);
  gtk_widget_show(otfg->clistfilt[0]);
  gtk_widget_set_usize (scrolled_window, 500, 200);
  gtk_widget_show (scrolled_window); gtk_widget_show (frame);

  align = gtk_alignment_new (0.5, 0.5, 0.0, 0.0);
  gtk_box_pack_start (GTK_BOX (vboxm), align, FALSE, FALSE, 0);
  gtk_widget_show (align);
  vbox3 = gtk_vbox_new (FALSE, 5);
  gtk_container_add (GTK_CONTAINER (align), vbox3);

  button = gtk_button_new();
  arrow_right = gtk_arrow_new (GTK_ARROW_RIGHT, GTK_SHADOW_OUT);
  gtk_tooltips_set_tip (tooltips, button,
                        "Moves Selected files from filtered list to otf list", NULL);
  gtk_container_add (GTK_CONTAINER (button), arrow_right);
  gtk_widget_set_usize (GTK_WIDGET (arrow_right), 25, 15);
  gtk_box_pack_start (GTK_BOX (vbox3), button, FALSE, FALSE, 0);
  
  gtk_widget_show (button); gtk_widget_show (arrow_right);
  gtk_signal_connect (GTK_OBJECT (button), "clicked",
		      GTK_SIGNAL_FUNC (move_selected), NULL);


  button = gtk_button_new();
  arrow_left = gtk_arrow_new (GTK_ARROW_LEFT, GTK_SHADOW_OUT);
  gtk_tooltips_set_tip (tooltips, button,
                        "Removes Selected files from otf list", NULL);
  gtk_container_add (GTK_CONTAINER (button), arrow_left);
  gtk_widget_set_usize (GTK_WIDGET (arrow_left), 25, 15);
  gtk_box_pack_start (GTK_BOX (vbox3), button, FALSE, FALSE, 0);
  gtk_signal_connect (GTK_OBJECT (button), "clicked",
		      GTK_SIGNAL_FUNC (remove_selected), NULL);

  gtk_widget_show (button); gtk_widget_show (arrow_left);

  button = gtk_button_new_with_label ("All");
  gtk_tooltips_set_tip (tooltips, button,
                        "Moves All files to Otf List", NULL);
  gtk_box_pack_start (GTK_BOX (vbox3), button, FALSE, FALSE, 0);
  gtk_widget_show (button); 
  gtk_signal_connect (GTK_OBJECT (button), "clicked",
		      GTK_SIGNAL_FUNC (move_all), NULL);

  button = gtk_button_new_with_label ("None");
  gtk_tooltips_set_tip (tooltips, button,
                        "Removes All files from Otf List", NULL);
  gtk_box_pack_start (GTK_BOX (vbox3), button, FALSE, FALSE, 0);
  gtk_widget_show (button); 
  gtk_signal_connect (GTK_OBJECT (button), "clicked",
		      GTK_SIGNAL_FUNC (remove_all), NULL);


  otfg->restorebtn = gtk_button_new_with_label ("Save Restore List");
  gtk_tooltips_set_tip (tooltips, otfg->restorebtn,
                        "Pops up a window to save the list of files not available on disk", NULL);
  gtk_box_pack_start (GTK_BOX (vbox3), otfg->restorebtn, FALSE, FALSE, 0);
  gtk_widget_show (otfg->restorebtn); 
  gtk_signal_connect (GTK_OBJECT (otfg->restorebtn), "clicked",
		      GTK_SIGNAL_FUNC (restore_list), NULL);  
  gtk_widget_set_sensitive (otfg->restorebtn, FALSE);

  gtk_widget_show (vbox3);


  /* Now the box on right */
  frame = gtk_frame_new ("Otf File List");
  gtk_container_add (GTK_CONTAINER (vboxr), frame);
  
  scrolled_window = gtk_scrolled_window_new (NULL, NULL);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolled_window),
                                  GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
  gtk_container_add (GTK_CONTAINER (frame), scrolled_window);
  gtk_widget_show (scrolled_window);

  otfg->clistfilt[1] = gtk_clist_new_with_titles (1, titles2);
  gtk_clist_set_shadow_type (GTK_CLIST(otfg->clistfilt[1]), GTK_SHADOW_ETCHED_IN);
  gtk_clist_set_selection_mode (GTK_CLIST (otfg->clistfilt[1]), GTK_SELECTION_MULTIPLE);
  gtk_clist_set_column_width (GTK_CLIST(otfg->clistfilt[1]), 0, 125);
  gtk_clist_column_titles_passive (GTK_CLIST (otfg->clistfilt[1]) );

  gtk_container_add(GTK_CONTAINER(scrolled_window), otfg->clistfilt[1]);
  gtk_widget_show(otfg->clistfilt[1]);
  gtk_widget_set_usize (scrolled_window, 150, 200);
  gtk_widget_show (scrolled_window); gtk_widget_show (frame);
  
  gtk_signal_connect_object (GTK_OBJECT(otfg->clistfilt[1]), "button_press_event",
                     GTK_SIGNAL_FUNC(clistfilt_button_pressed),
                     GTK_OBJECT (otfg->clistfilt[1]));


  hbox2 = gtk_hbox_new (FALSE, 5);
  gtk_box_pack_start (GTK_BOX (vbox2), hbox2, TRUE, TRUE, 0);
  gtk_widget_show (hbox2);
  

  button = gtk_button_new_with_label ("Save List file");
  gtk_box_pack_start (GTK_BOX (hbox2), button, TRUE, TRUE, 0);
  gtk_tooltips_set_tip (tooltips, button, 
                        "Save list of files above right to a file that will be used for assessment and regridding", NULL);
  gtk_widget_show (button);
  gtk_signal_connect (GTK_OBJECT (button), "clicked",
		      GTK_SIGNAL_FUNC (save_list_file), NULL);


  otfg->entry[1] = gtk_entry_new();
  /*  gtk_widget_set_usize(otfg->entry[1],50,-1);*/
  gtk_box_pack_start(GTK_BOX (hbox2), otfg->entry[1], TRUE, TRUE, 0);
  gtk_widget_show (otfg->entry[1]);
  /*  gtk_signal_connect (GTK_OBJECT (otfg->entry[1]), "activate",
      GTK_SIGNAL_FUNC (entry_changed), (gpointer) 1);*/

  if (strcmp(otffile,""))
    gtk_entry_set_text (GTK_ENTRY (otfg->entry[1]), otffile);

  button = gtk_button_new_with_label("Browse");
  gtk_box_pack_start (GTK_BOX (hbox2), button, TRUE, TRUE, 0);
  gtk_widget_show (button);
  gtk_signal_connect (GTK_OBJECT (button), "clicked",
                      GTK_SIGNAL_FUNC (filesel_inp), NULL);



  gtk_widget_show (hbox);
  gtk_widget_show (vbox1);
  gtk_widget_show (vbox);
}
