#include "otftool.h"
#include <stdarg.h>

extern char* timestring (void);
static short last_append_terminated=0;

void 
append_log (short fg, short bg, short intfont, GtkWidget *w, const char *fmt, ...)
{
  va_list args;
  char *txt;
  FILE *fplog=NULL;
  struct {
  GdkColor color;
    gchar *name;
  } text_colors[] = {
    { { 0, 0x0000, 0x0000, 0x0000 }, "black" },
    { { 0, 0xFFFF, 0xFFFF, 0xFFFF }, "white" },
    { { 0, 0xFFFF, 0x0000, 0x0000 }, "red" },
    { { 0, 0x0000, 0xFFFF, 0x0000 }, "green" },
    { { 0, 0x0000, 0x0000, 0xFFFF }, "blue" }, 
    { { 0, 0x0000, 0xFFFF, 0xFFFF }, "cyan" },
    { { 0, 0xFFFF, 0x0000, 0xFFFF }, "magenta" },
    { { 0, 0xFFFF, 0xFFFF, 0x0000 }, "yellow" }
  };
  GdkFont *font1, *font2, *font;
  /*  int ntext_colors = sizeof(text_colors) / sizeof(text_colors[0]);*/
  
  if ((txt = (char *) malloc(500*sizeof (char))) == NULL) {
    perror("errmsg text error: malloc");
    exit(3);
  }

  va_start (args, fmt);
  vsprintf(txt, fmt, args);
  va_end (args);
  if ((fplog = fopen(log_file,"a")) != NULL) {
    /* check for last string to be terminated by NULL character */
    if (last_append_terminated)
      fprintf(fplog,"%s  :", (char *)timestring());
    if (rindex(txt,'\n') != NULL)
      last_append_terminated = 1;
    else 
      last_append_terminated = 0;
    fprintf(fplog,"%s", txt);
    fclose (fplog);
  }

  if ((GTK_IS_WIDGET (w)) && (w !=NULL)) {
    font1 = gdk_font_load ("-*-helvetica-medium-r-*-*-*-120-*-*-*-*-*-*");
    font2 = gdk_font_load ("-*-helvetica-bold-r-*-*-*-120-*-*-*-*-*-*");
    switch (intfont) {
    case 1:
      font = font1;
      break;
    case 2:
      font = font2;
      break;
    default:
      font = NULL;
      break;
    }
  
    gtk_text_set_point( GTK_TEXT (w), 
			gtk_text_get_point (GTK_TEXT (w)));
    gtk_text_freeze (GTK_TEXT (w));
    if ((fg>=0) && (fg<8)) {
      if ((bg>=0) && (bg<8)) 
	gtk_text_insert( GTK_TEXT (w), font, &text_colors[fg].color,
			 &text_colors[bg].color, txt, -1);
      else 
        gtk_text_insert( GTK_TEXT (w), font, &text_colors[fg].color,
                         NULL, txt, -1);      
    } else {
      if ((bg>=0) && (bg<8)) 
        gtk_text_insert( GTK_TEXT (w), font, NULL,
                         &text_colors[bg].color, txt, -1);
      else 
        gtk_text_insert( GTK_TEXT (w), font, NULL,
                         NULL, txt, -1);      
    }
    gtk_text_thaw (GTK_TEXT (w));  
    gtk_editable_set_position( GTK_EDITABLE (w), 
			       gtk_text_get_point (GTK_TEXT (w)));
  }
  free(txt);
}

/*
void
append_log (short fg, short bg, short intfont, gchar *txt)
{
  struct {
  GdkColor color;
  gchar *name;
  } text_colors[] = {
    { { 0, 0x0000, 0x0000, 0x0000 }, "black" },
    { { 0, 0xFFFF, 0xFFFF, 0xFFFF }, "white" },
    { { 0, 0xFFFF, 0x0000, 0x0000 }, "red" },
    { { 0, 0x0000, 0xFFFF, 0x0000 }, "green" },
    { { 0, 0x0000, 0x0000, 0xFFFF }, "blue" }, 
    { { 0, 0x0000, 0xFFFF, 0xFFFF }, "cyan" },
    { { 0, 0xFFFF, 0x0000, 0xFFFF }, "magenta" },
    { { 0, 0xFFFF, 0xFFFF, 0x0000 }, "yellow" }
  };
  GdkFont *font1, *font2, *font;
  int ntext_colors = sizeof(text_colors) / sizeof(text_colors[0]);

  if ((GTK_IS_WIDGET (otfgui->logtext)) && (otfgui->logtext !=NULL)) {
    font1 = gdk_font_load ("-*-helvetica-medium-r-*-*-*-120-*-*-*-*-*-*");
    font2 = gdk_font_load ("-*-helvetica-bold-r-*-*-*-120-*-*-*-*-*-*");
    
    switch (intfont) {
    case 1:
      font = font1;
      break;
    case 2:
      font = font2;
      break;
    default:
      font = NULL;
      break;
    }
    gtk_text_set_point( GTK_TEXT (otfgui->logtext), 
			gtk_text_get_point (GTK_TEXT (otfgui->logtext)));
    gtk_text_freeze (GTK_TEXT (otfgui->logtext));
    if ((fg>=0) && (fg<8)) {
      if ((bg>=0) && (bg<8)) 
	gtk_text_insert( GTK_TEXT (otfgui->logtext), font, &text_colors[fg].color,
			 &text_colors[bg].color, txt, -1);
      else 
	gtk_text_insert( GTK_TEXT (otfgui->logtext), font, &text_colors[fg].color,
			 NULL, txt, -1);      
    } else {
      if ((bg>=0) && (bg<8)) 
	gtk_text_insert( GTK_TEXT (otfgui->logtext), font, NULL,
			 &text_colors[bg].color, txt, -1);
      else 
	gtk_text_insert( GTK_TEXT (otfgui->logtext), font, NULL,
			 NULL, txt, -1);      
    }
    gtk_text_thaw (GTK_TEXT (otfgui->logtext));  
    gtk_editable_set_position( GTK_EDITABLE (otfgui->logtext), 
		      gtk_text_get_point (GTK_TEXT (otfgui->logtext)));
  }
}
  
*/

void 
file_ok_save_log (GtkWidget *w, GtkFileSelection *fs)
{
  FILE *fsave;
  int nchars;
  char *alltext;

  if ((fsave=fopen(gtk_file_selection_get_filename (GTK_FILE_SELECTION (fs)), "w"))==NULL) {
    fprintf(stderr,"\n Can not open file\n");
    append_log(6,1,1,otfgui->logtext,"Cannot Open File\n");
    return;
  }
  nchars = gtk_text_get_length(GTK_TEXT (otfgui->logtext));
  alltext = gtk_editable_get_chars( GTK_EDITABLE (otfgui->logtext), 0, -1);
  fwrite(alltext, sizeof(char), nchars, fsave);
  append_log(0,1,1,otfgui->logtext,"Saved log file\n");
  g_free(alltext);
  gtk_widget_destroy(GTK_WIDGET (fs));
  fclose(fsave);
}

void 
clear_log (GtkWidget *widget, GtkWidget *text)
{
  int nchars;

  nchars = gtk_text_get_length(GTK_TEXT (text));
  gtk_editable_set_position( GTK_EDITABLE (text), 
			     gtk_text_get_point (GTK_TEXT (text)));
  gtk_text_backward_delete (GTK_TEXT (text), nchars);
  gtk_editable_set_position( GTK_EDITABLE (text), 
			       gtk_text_get_point (GTK_TEXT (text)));
}

void
save_log (GtkWidget *widget, GtkWidget *text)
{
  static GtkWidget *filew = NULL;
  
  if (!filew) {
    filew = gtk_file_selection_new ("Save Log to File");
    
    /*    gtk_file_selection_hide_fileop_buttons (GTK_FILE_SELECTION (filew));*/
    gtk_signal_connect (GTK_OBJECT (filew), "destroy",
                        GTK_SIGNAL_FUNC (gtk_widget_destroyed), &filew);

    /* Connect the ok_button to file_ok_sel function */
    gtk_signal_connect (GTK_OBJECT (GTK_FILE_SELECTION (filew)->ok_button),
			"clicked", (GtkSignalFunc) file_ok_save_log, filew );
    /* Connect the cancel_button to destroy the widget */
    gtk_signal_connect_object (GTK_OBJECT (GTK_FILE_SELECTION
					   (filew)->cancel_button),
			       "clicked", (GtkSignalFunc) gtk_widget_destroy,
			       GTK_OBJECT (filew));
    
    gtk_file_selection_set_filename (GTK_FILE_SELECTION(filew),
                                   "otftool.log");
  }

  if (!GTK_WIDGET_VISIBLE (filew))
    gtk_widget_show(filew);
  else 
    gtk_widget_destroy(filew);
#ifdef DEBUG
  printf("In save\n");
#endif
}

GtkWidget
*otftool_setup_logging(otf_gui *otfg)
{
  GtkWidget *frame;
  GtkWidget *vbox;
  GtkWidget *scrolled_window;
  GtkWidget *hbox;
  GtkWidget *button;
  GtkTooltips *tooltips;
  GtkWidget *vbox0;

  vbox0 = gtk_vbox_new (FALSE, 5);
  gtk_widget_show (vbox0);
  gtk_box_pack_end (GTK_BOX (otfg->vertbox), vbox0, TRUE, TRUE, 0);

  frame = gtk_frame_new ("Log");
  gtk_container_add (GTK_CONTAINER (vbox0), frame);


  vbox = gtk_vbox_new(FALSE, 5);
  gtk_container_add (GTK_CONTAINER (frame), vbox);

  scrolled_window = gtk_scrolled_window_new (NULL, NULL);
  gtk_box_pack_start (GTK_BOX (vbox), scrolled_window, TRUE, TRUE, 0);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolled_window),
				  GTK_POLICY_NEVER,
				  GTK_POLICY_ALWAYS);
  gtk_widget_show (scrolled_window);
  
  gtk_widget_set_usize (scrolled_window, -1, 60);
  otfg->logtext = gtk_text_new (NULL, NULL);
  gtk_text_set_editable (GTK_TEXT (otfg->logtext), FALSE);
  gtk_container_add (GTK_CONTAINER (scrolled_window), otfg->logtext);
  gtk_widget_grab_focus (otfg->logtext);
  gtk_widget_show (otfg->logtext);
  gtk_text_set_word_wrap(GTK_TEXT (otfg->logtext), TRUE);
  

  /*  gtk_text_insert (GTK_TEXT (otfg->logtext), NULL, NULL, NULL, "test\n", -1);*/

  hbox = gtk_hbox_new (FALSE, 5);
  gtk_box_pack_start (GTK_BOX (vbox), hbox, FALSE, FALSE,0);

  button = gtk_button_new_with_label ("Save Log");
  tooltips = gtk_tooltips_new ();
  gtk_tooltips_set_tip (tooltips, button, 
			"Save Log", NULL);
  gtk_signal_connect (GTK_OBJECT (button), "clicked",
		      GTK_SIGNAL_FUNC (save_log), otfg->logtext);
  
  gtk_box_pack_start (GTK_BOX (hbox), button, FALSE, FALSE, 0);
  gtk_widget_show (button);

  button = gtk_button_new_with_label ("Clear Log");
  tooltips = gtk_tooltips_new ();
  gtk_tooltips_set_tip (tooltips, button, 
			"Clear Log text in window", NULL);
  gtk_signal_connect (GTK_OBJECT (button), "clicked",
		      GTK_SIGNAL_FUNC (clear_log), otfg->logtext);
  
  gtk_box_pack_start (GTK_BOX (hbox), button, FALSE, FALSE, 0);
  gtk_widget_show (button);

  gtk_widget_show (hbox);

  gtk_widget_show (otfg->logtext);
  gtk_widget_show (vbox);
  gtk_widget_show (frame);

  return frame;
}  


