/*
 * parameter_inc.h
 * Derived from GAG/linux-intel/astro/class/parameter.inc
 * fortran include file
 * Gopal Narayanan <gopal@astro.umass.edu>
 * Sept 4, 2001
 */

#ifndef __PARAMETER_INC_H_
#define __PARAMETER_INC_H_

#include <cfortran.h>

#define MDATA 32768

#define MX_SEC 64      /* maximum range of section number*/
#define COM_SEC 64    /*comment -1 */
#define GEN_SEC 63    /*General -2 */
#define POS_SEC 62    /*Position -3 */
#define SPEC_SEC 61   /*Spectroscopy -4 */
#define BASE_SEC 60   /*Baseline -5 */
#define ORIG_SEC 59   /*Origin -6 */
#define PLOT_SEC 58   /*Plot Parameters -7 */
#define SWITCH_SEC 57 /*Phase description -8 */
#define FSW_SEC 57    /*alias for phase desc -8 */
#define GAUS_SEC 56   /*Gauss fit -9 */
#define CONT_SEC 55   /*Drift Continuum Section -10 */
#define BEAM_SEC 54   /*Beam Switch -11 */
#define SHELL_SEC 53  /*Shell fit -12 */
#define NH3_SEC 52    /*NH3 fit -13 */
#define ABS_SEC 47    /*Absorption fit -18 */
#define CAL_SEC 51    /*Calibration -14 */
#define POINT_SEC 50  /*Continuum fit results -15 */
#define SKYDIP_SEC 49  /*Skydip description -16 */
#define XCOORD_SEC 48  /*X coordinates -17 */
#define DESCR_SEC 35   /*data descriptor section -30 */

typedef struct {
  int PRESEC[65];
  long int RXNUM, TXNUM, KNEXT, NINDEX, M_HEADER, M_DH;
} RSCAN_DEF;


#define Rscan COMMON_BLOCK(RSCAN,rscan)
COMMON_BLOCK_DEF(RSCAN_DEF,Rscan);

#endif
