/*
 * projection.h
 * derived from Gildas fortran include file constant.inc
 * Gopal Narayanan <gopal@astro.umass.edu>
 * July 14, 2001
 */

#ifndef __PROJECTON_H
#define __PROJECTION_H

#define MPROJ 7                  /* Number of supported projections */
#define P_NONE 0                 /* Unprojected data */
#define P_GNOMONIC 1             /* Radial Tangent plane */
#define P_ORTHO 2                /* Dixon Tangent plane */
#define P_AZIMUTHAL 3            /* Schmidt Tangent plane */
#define P_STEREO 4               /* Stereographic */
#define P_LAMBERT 5              /* Lambert equal area */
#define P_AITOFF 6               /* Aitoff equal area */
#define P_RADIO 7                /* Classic Single dish radio mapping */
#define TYPE_UN 1                /* Unknown system */
#define TYPE_EQ 2                /* Equatorial */
#define TYPE_GA 3                /* Galactic */
#define TYPE_HO 4                /* Horizontal */
#define VEL_UNK 0                /* Unsupported referential (planetary...) */
#define VEL_LSR  1               /* LSR referential */
#define VEL_HEL  2               /* Heliocentric referential */
#define VEL_OBS  3               /* Observatory referential */
#define VEL_EAR  4               /* Earth-Moon barycenter referential */
#define VEL_AUT  -1              /* Take referential from data */
#define KIND_SPEC 0              /* Spectroscopic data */
#define KIND_CONT 1              /* Continuum drift */
#define KIND_SKY 2               /* Skydip data */
#define KIND_ONOFF 3             /* Continuum on/off */
#define A_VELO  1                /* X unit is velocity */
#define A_FREQ  2                /* X unit is frequency */
#define A_WAVE  3                /* X unit is wavelength */
#define MOD_FREQ 0               /* Frequency switch */
#define MOD_POS 1                /* Position switch */
#define MOD_FOLD 2               /* Folded frequency switch */

static char *PROJNAM[] = {"NONE","GNOMONIC","ORTHOGRAPHIC","AZIMUTHAL",
			  "STEREOGRAPHIC","LAMBERT","AITOFF","RADIO"};

#endif











