/*
 * setup_inc.h
 * Derived from GAG/linux-intel/astro/class/setup.inc
 * fortran include file
 * Gopal Narayanan <gopal@astro.umass.edu>
 * Sept 4, 2001
 */

#ifndef __SETUP_INC_H_
#define __SETUP_INC_H_

#include <cfortran.h>

#define MWIND1 20
#define MMASK1 5

typedef struct {
  float SOFFS1, SOFFS2, SOFFL1,SOFFL2;
  long int SBASE, SSCAN1, SSCAN2, SNUME1, SNUME2;
  long int SNWIND;
  float SWIND1[MWIND1], SWIND2[MWIND1], SEPOCH;
  float SPOSA1, SPOSA2;
  long int SOBSE1, SOBSE2, SREDU1, SREDU2;
  float STOLE, SBEAMT,SGAINT;
  int SMATCH, SCURSO;
  long int SNMASK;
  float SMASK1[MMASK1],SMASK2[MMASK1];
  long int SKIND, SCOORD, SVELOC;
  double FANGLE;
  long int LBASE, SQUAL1, SQUAL2;
  int SFUPDA, SMAPCL, DO_SORT, DO_SCAN;
} SASSET_DEF;

#define Sasset COMMON_BLOCK(SASSET,sasset)
COMMON_BLOCK_DEF(SASSET_DEF,Sasset);

typedef struct {
  char SLINE[12], SSOURC[12], STELES[12];
  char SALIGN, SALIG2, SANGLE, SHEADE, SMODEX, SMODEY, SPLOT, SUNITX;
  char SWEIGH, SUNITX_UP, SBAD;
  char DEFEXT[32];
  char SMETHOD[12];
} SASCET_DEF;

#define Sascet COMMON_BLOCK(SASCET,sascet)
COMMON_BLOCK_DEF(SASCET_DEF,Sascet);

#endif
